"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var _a, _b, _c;
Object.defineProperty(exports, "__esModule", { value: true });
const src_1 = require("../src");
src_1.LogService.setLogger(new src_1.RichConsoleLogger());
src_1.LogService.setLevel(src_1.LogLevel.TRACE);
src_1.LogService.muteModule("Metrics");
src_1.LogService.trace = src_1.LogService.debug;
let creds = null;
try {
    creds = require("../../examples/storage/bot.creds.json");
}
catch (e) {
    // ignore
}
const dmTarget = (_a = creds === null || creds === void 0 ? void 0 : creds['dmTarget']) !== null && _a !== void 0 ? _a : "@admin:localhost";
const homeserverUrl = (_b = creds === null || creds === void 0 ? void 0 : creds['homeserverUrl']) !== null && _b !== void 0 ? _b : "http://localhost:8008";
const accessToken = (_c = creds === null || creds === void 0 ? void 0 : creds['accessToken']) !== null && _c !== void 0 ? _c : 'YOUR_TOKEN';
const storage = new src_1.SimpleFsStorageProvider("./examples/storage/bot.json");
const crypto = new src_1.RustSdkCryptoStorageProvider("./examples/storage/bot_sled");
const client = new src_1.MatrixClient(homeserverUrl, accessToken, storage, crypto);
src_1.AutojoinRoomsMixin.setupOnClient(client);
(function () {
    return __awaiter(this, void 0, void 0, function* () {
        yield client.dms.update(); // should update in `start()`, but we're earlier than that here
        const targetRoomId = yield client.dms.getOrCreateDm(dmTarget);
        client.on("room.message", (roomId, event) => __awaiter(this, void 0, void 0, function* () {
            if (roomId !== targetRoomId)
                return;
            const message = new src_1.MessageEvent(event);
            if (message.messageType !== "m.text")
                return;
            if (message.textBody.startsWith("!ping")) {
                yield client.replyNotice(roomId, event, "Pong from DM");
            }
        }));
        src_1.LogService.info("index", "Starting bot...");
        yield client.start();
    });
})();
