"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isCryptoCapable = void 0;
const LogService_1 = require("./logging/LogService");
let hasDependency = null;
/**
 * Determines if the project is capable of running end-to-end encryption, aside
 * from solutions like Pantalaimon.
 * @category Encryption
 */
function isCryptoCapable() {
    if (hasDependency !== null)
        return hasDependency;
    try {
        require("@matrix-org/olm");
        hasDependency = true;
    }
    catch (e) {
        LogService_1.LogService.error("isCryptoCapable", "Failed check: ", e);
        hasDependency = false;
    }
    return hasDependency;
}
exports.isCryptoCapable = isCryptoCapable;
