import { MatrixClient } from "./MatrixClient";
import { IStorageProvider } from "./storage/IStorageProvider";
/**
 * A MatrixClient class which attempts to use Sync V3 instead of the normal sync protocol
 * on the server.
 *
 * This class is considered <b>UNSTABLE</b> and may be removed at any time. This class will
 * not check for server support before attempting to use it.
 */
export declare class SyncV3MatrixClient extends MatrixClient {
    private syncSessionId;
    /**
     Creates a new matrix client
     @param {string} homeserverUrl The homeserver's client-server API URL
     @param {string} accessToken The access token for the homeserver
     @param {IStorageProvider} storage The storage provider to use.
     */
    constructor(homeserverUrl: string, accessToken: string, storage: IStorageProvider);
    protected startSyncInternal(): Promise<any>;
    private loopSync;
    private processSyncV3;
    private doSyncV3;
}
