/**
 * A Sync V3 list.
 * @category Unstable: Sync V3
 */
import { MatrixClient } from "../MatrixClient";
import { OpDelete, OpInsert, OpSync, OpUpdate } from "./operations";
export declare enum ListBehaviour {
    General = 0,
    Invites = 1
}
export declare class List {
    readonly listIndex: number;
    readonly client: MatrixClient;
    readonly behaviour: ListBehaviour;
    private roomIds;
    constructor(listIndex: number, client: MatrixClient, behaviour: ListBehaviour);
    get orderedRoomIds(): string[];
    handleSyncOp(op: OpSync): Promise<void>;
    handleInsertOp(op: OpInsert): Promise<void>;
    handleUpdateOp(op: OpUpdate): Promise<void>;
    handleDeleteOp(op: OpDelete): Promise<void>;
    private storeList;
    private loadList;
    private findMembership;
    private handleTimeline;
}
