import { EncryptionEventContent } from "../models/events/EncryptionEvent";
import { RequiredStateTuple } from "./V3List";
import { MembershipEvent } from "../models/events/MembershipEvent";
import { SyncV3Event, SyncV3Room } from "./models";
import { MatrixClient } from "../MatrixClient";
/**
 * @category Unstable: Sync V3
 */
export interface IV3Room {
    name: string | undefined;
    topic: string | undefined;
    encryptionConfig: EncryptionEventContent | undefined;
    membership: MembershipEvent;
}
/**
 * @category Unstable: Sync V3
 */
export declare class V3Room implements IV3Room {
    readonly roomId: string;
    private nameEvent;
    private topicEvent;
    private encryptionEvent;
    private myMembership;
    constructor(roomId: string);
    get lossySerialized(): SyncV3Room & {
        room_id: string;
    };
    get name(): string | undefined;
    get topic(): string | undefined;
    get encryptionConfig(): EncryptionEventContent | undefined;
    get membership(): MembershipEvent;
    updateState(client: MatrixClient, state: (SyncV3Event & {
        state_key: string;
    })[]): Promise<void>;
    updateTimeline(client: MatrixClient, timeline: SyncV3Event[]): Promise<void>;
    static get REQUIRED_STATE(): RequiredStateTuple[];
}
