import { ICryptoSecureStorageProvider } from "./ICryptoSecureStorageProvider";
import { CryptexOpts } from "cryptex";
/**
 * A storage provider for secure information relating to crypto, stored using Cryptex.
 * Requires `cryptex` package to be installed.
 *
 * The pickle key is stored as the "pickle_key" secret.
 * @category Storage providers
 * @see https://github.com/TomFrost/Cryptex
 */
export declare class CryptexCryptoSecureStorageProvider implements ICryptoSecureStorageProvider {
    private cryptex;
    constructor(opts?: CryptexOpts);
    getPickleKey(): Promise<string>;
    setPickleKey(pickleKey: string): Promise<void>;
}
