var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
System.register("IFilter", [], function (exports_1, context_1) {
    "use strict";
    var __moduleName = context_1 && context_1.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("storage/IStorageProvider", [], function (exports_2, context_2) {
    "use strict";
    var __moduleName = context_2 && context_2.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("models/events/Event", [], function (exports_3, context_3) {
    "use strict";
    var MatrixEvent;
    var __moduleName = context_3 && context_3.id;
    return {
        setters: [],
        execute: function () {
            /**
             * A Matrix event.
             * @category Matrix events
             */
            MatrixEvent = class MatrixEvent {
                constructor(event) {
                    this.event = event;
                }
                /**
                 * The user ID who sent this event.
                 */
                get sender() {
                    return this.event['sender'];
                }
                /**
                 * The type of this event.
                 */
                get type() {
                    return this.event['type'];
                }
                /**
                 * The content for this event. May have no properties.
                 */
                get content() {
                    return this.event['content'] || {};
                }
                /**
                 * Gets the raw event that this MatrixEvent is using.
                 * Note that there's no guarantees on formats here - it is the exact
                 * same input to the constructor.
                 */
                get raw() {
                    return this.event;
                }
            };
            exports_3("MatrixEvent", MatrixEvent);
        }
    };
});
System.register("models/events/RoomEvent", ["models/events/Event"], function (exports_4, context_4) {
    "use strict";
    var Event_1, RoomEvent, StateEvent;
    var __moduleName = context_4 && context_4.id;
    return {
        setters: [
            function (Event_1_1) {
                Event_1 = Event_1_1;
            }
        ],
        execute: function () {
            /**
             * A Matrix room event.
             * @category Matrix events
             */
            RoomEvent = class RoomEvent extends Event_1.MatrixEvent {
                constructor(event) {
                    super(event);
                    this.event = event;
                }
                /**
                 * The event ID of this event.
                 */
                get eventId() {
                    return this.event['event_id'];
                }
                /**
                 * The timestamp in milliseconds this event was sent.
                 */
                get timestamp() {
                    return this.event['origin_server_ts'];
                }
                /**
                 * The unsigned content for this event. May have no properties.
                 */
                get unsigned() {
                    return this.event['unsigned'] || {};
                }
            };
            exports_4("RoomEvent", RoomEvent);
            /**
             * A room state event.
             * @category Matrix events
             */
            StateEvent = class StateEvent extends RoomEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The state key for this event. May be an empty string.
                 */
                get stateKey() {
                    return this.event['state_key'];
                }
                /**
                 * The previous content for this state event. Will be an empty
                 * object if there is no previous content.
                 */
                get previousContent() {
                    return this.unsigned['prev_content'] || this.event['prev_content'] || {}; // v2, v1, fallback
                }
            };
            exports_4("StateEvent", StateEvent);
        }
    };
});
System.register("models/events/EncryptionEvent", ["models/events/RoomEvent"], function (exports_5, context_5) {
    "use strict";
    var RoomEvent_1, RoomEncryptionAlgorithm, EncryptionEvent;
    var __moduleName = context_5 && context_5.id;
    return {
        setters: [
            function (RoomEvent_1_1) {
                RoomEvent_1 = RoomEvent_1_1;
            }
        ],
        execute: function () {
            /**
             * The kinds of room encryption algorithms allowed by the spec.
             * @category Models
             * @see EncryptionEvent
             */
            (function (RoomEncryptionAlgorithm) {
                RoomEncryptionAlgorithm["MegolmV1AesSha2"] = "m.megolm.v1.aes-sha2";
            })(RoomEncryptionAlgorithm || (RoomEncryptionAlgorithm = {}));
            exports_5("RoomEncryptionAlgorithm", RoomEncryptionAlgorithm);
            /**
             * Represents an m.room.encryption state event
             * @category Matrix events
             */
            EncryptionEvent = class EncryptionEvent extends RoomEvent_1.StateEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The encryption algorithm for the room.
                 */
                get algorithm() {
                    return this.content.algorithm;
                }
                /**
                 * How long a session should be used before changing it. Defaults to a week.
                 */
                get rotationPeriodMs() {
                    var _a;
                    return (_a = this.content.rotation_period_ms) !== null && _a !== void 0 ? _a : 604800000; // 1 week
                }
                /**
                 * How many messages should be sent before a session changes. Defaults to 100.
                 */
                get rotationPeriodMessages() {
                    var _a;
                    return (_a = this.content.rotation_period_msgs) !== null && _a !== void 0 ? _a : 100;
                }
            };
            exports_5("EncryptionEvent", EncryptionEvent);
        }
    };
});
System.register("models/Crypto", [], function (exports_6, context_6) {
    "use strict";
    var OTKAlgorithm, EncryptionAlgorithm, DeviceKeyAlgorithm;
    var __moduleName = context_6 && context_6.id;
    return {
        setters: [],
        execute: function () {
            /**
             * One time key algorithms.
             * @category Models
             */
            (function (OTKAlgorithm) {
                OTKAlgorithm["Signed"] = "signed_curve25519";
                OTKAlgorithm["Unsigned"] = "curve25519";
            })(OTKAlgorithm || (OTKAlgorithm = {}));
            exports_6("OTKAlgorithm", OTKAlgorithm);
            /**
             * The available encryption algorithms.
             * @category Models
             */
            (function (EncryptionAlgorithm) {
                EncryptionAlgorithm["OlmV1Curve25519AesSha2"] = "m.olm.v1.curve25519-aes-sha2";
                EncryptionAlgorithm["MegolmV1AesSha2"] = "m.megolm.v1.aes-sha2";
            })(EncryptionAlgorithm || (EncryptionAlgorithm = {}));
            exports_6("EncryptionAlgorithm", EncryptionAlgorithm);
            /**
             * The key algorithms for device keys.
             * @category Models
             */
            (function (DeviceKeyAlgorithm) {
                DeviceKeyAlgorithm["Ed25519"] = "ed25519";
                DeviceKeyAlgorithm["Curve25519"] = "curve25519";
            })(DeviceKeyAlgorithm || (DeviceKeyAlgorithm = {}));
            exports_6("DeviceKeyAlgorithm", DeviceKeyAlgorithm);
        }
    };
});
System.register("storage/ICryptoSecureStorageProvider", [], function (exports_7, context_7) {
    "use strict";
    var __moduleName = context_7 && context_7.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("storage/ICryptoStorageProvider", [], function (exports_8, context_8) {
    "use strict";
    var __moduleName = context_8 && context_8.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("storage/IAppserviceStorageProvider", [], function (exports_9, context_9) {
    "use strict";
    var __moduleName = context_9 && context_9.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("storage/MemoryStorageProvider", [], function (exports_10, context_10) {
    "use strict";
    var MemoryStorageProvider;
    var __moduleName = context_10 && context_10.id;
    return {
        setters: [],
        execute: function () {
            /**
             * A storage provider that persists no information by keeping it all in memory.
             * @category Storage providers
             */
            MemoryStorageProvider = class MemoryStorageProvider {
                constructor() {
                    this.namespaced = new Map();
                    this.appserviceUsers = {};
                    this.appserviceTransactions = {};
                    this.kvStore = {};
                }
                setSyncToken(token) {
                    this.syncToken = token;
                }
                getSyncToken() {
                    return this.syncToken;
                }
                setFilter(filter) {
                    this.filter = filter;
                }
                getFilter() {
                    return this.filter;
                }
                addRegisteredUser(userId) {
                    this.appserviceUsers[userId] = {
                        registered: true,
                    };
                }
                isUserRegistered(userId) {
                    return this.appserviceUsers[userId] && this.appserviceUsers[userId].registered;
                }
                isTransactionCompleted(transactionId) {
                    return !!this.appserviceTransactions[transactionId];
                }
                setTransactionCompleted(transactionId) {
                    this.appserviceTransactions[transactionId] = true;
                }
                readValue(key) {
                    return this.kvStore[key];
                }
                storeValue(key, value) {
                    this.kvStore[key] = value;
                }
                storageForUser(userId) {
                    if (!this.namespaced.has(userId)) {
                        this.namespaced.set(userId, new MemoryStorageProvider());
                    }
                    return this.namespaced.get(userId);
                }
            };
            exports_10("MemoryStorageProvider", MemoryStorageProvider);
        }
    };
});
System.register("metrics/names", [], function (exports_11, context_11) {
    "use strict";
    var METRIC_MATRIX_CLIENT_FUNCTION_CALL, METRIC_MATRIX_CLIENT_FAILED_FUNCTION_CALL, METRIC_MATRIX_CLIENT_SUCCESSFUL_FUNCTION_CALL, METRIC_IDENTITY_CLIENT_FUNCTION_CALL, METRIC_IDENTITY_CLIENT_FAILED_FUNCTION_CALL, METRIC_IDENTITY_CLIENT_SUCCESSFUL_FUNCTION_CALL, METRIC_INTENT_FUNCTION_CALL, METRIC_INTENT_FAILED_FUNCTION_CALL, METRIC_INTENT_SUCCESSFUL_FUNCTION_CALL;
    var __moduleName = context_11 && context_11.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Time-series metric for how long a function call takes on MatrixClient. Uses a MatrixClientCallContext.
             * @category Metrics
             */
            exports_11("METRIC_MATRIX_CLIENT_FUNCTION_CALL", METRIC_MATRIX_CLIENT_FUNCTION_CALL = "matrix_client_function_call");
            /**
             * Counter metric for failed function calls on a MatrixClient. Uses a MatrixClientCallContext.
             * @category Metrics
             */
            exports_11("METRIC_MATRIX_CLIENT_FAILED_FUNCTION_CALL", METRIC_MATRIX_CLIENT_FAILED_FUNCTION_CALL = "matrix_client_failed_function_call");
            /**
             * Counter metric for successful function calls on a MatrixClient. Uses a MatrixClientCallContext.
             * @category Metrics
             */
            exports_11("METRIC_MATRIX_CLIENT_SUCCESSFUL_FUNCTION_CALL", METRIC_MATRIX_CLIENT_SUCCESSFUL_FUNCTION_CALL = "matrix_client_successful_function_call");
            /**
             * Time-series metric for how long a function call takes on an IdentityClient. Uses an IdentityClientCallContext.
             * @category Metrics
             */
            exports_11("METRIC_IDENTITY_CLIENT_FUNCTION_CALL", METRIC_IDENTITY_CLIENT_FUNCTION_CALL = "identity_client_function_call");
            /**
             * Counter metric for failed function calls on an IdentityClient. Uses an IdentityClientCallContext.
             * @category Metrics
             */
            exports_11("METRIC_IDENTITY_CLIENT_FAILED_FUNCTION_CALL", METRIC_IDENTITY_CLIENT_FAILED_FUNCTION_CALL = "identity_client_failed_function_call");
            /**
             * Counter metric for successful function calls on an IdentityClient. Uses an IdentityClientCallContext.
             * @category Metrics
             */
            exports_11("METRIC_IDENTITY_CLIENT_SUCCESSFUL_FUNCTION_CALL", METRIC_IDENTITY_CLIENT_SUCCESSFUL_FUNCTION_CALL = "identity_client_successful_function_call");
            /**
             * Time-series metric for how long a function call takes on an Intent. Uses a IntentCallContext.
             * @category Metrics
             */
            exports_11("METRIC_INTENT_FUNCTION_CALL", METRIC_INTENT_FUNCTION_CALL = "intent_function_call");
            /**
             * Counter metric for failed function calls on an Intent. Uses a IntentCallContext.
             * @category Metrics
             */
            exports_11("METRIC_INTENT_FAILED_FUNCTION_CALL", METRIC_INTENT_FAILED_FUNCTION_CALL = "intent_failed_function_call");
            /**
             * Counter metric for successful function calls on an Intent. Uses a IntentCallContext.
             * @category Metrics
             */
            exports_11("METRIC_INTENT_SUCCESSFUL_FUNCTION_CALL", METRIC_INTENT_SUCCESSFUL_FUNCTION_CALL = "intent_successful_function_call");
        }
    };
});
System.register("models/OpenIDConnect", [], function (exports_12, context_12) {
    "use strict";
    var __moduleName = context_12 && context_12.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("logging/ILogger", [], function (exports_13, context_13) {
    "use strict";
    var __moduleName = context_13 && context_13.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("logging/ConsoleLogger", [], function (exports_14, context_14) {
    "use strict";
    var ConsoleLogger;
    var __moduleName = context_14 && context_14.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Logs to the console in a plain format. This is the default logger.
             * @category Logging
             */
            ConsoleLogger = class ConsoleLogger {
                trace(module, ...messageOrObject) {
                    console.trace(module, ...messageOrObject);
                }
                debug(module, ...messageOrObject) {
                    console.debug(module, ...messageOrObject);
                }
                error(module, ...messageOrObject) {
                    console.error(module, ...messageOrObject);
                }
                info(module, ...messageOrObject) {
                    console.log(module, ...messageOrObject);
                }
                warn(module, ...messageOrObject) {
                    console.warn(module, ...messageOrObject);
                }
            };
            exports_14("ConsoleLogger", ConsoleLogger);
        }
    };
});
System.register("logging/LogService", ["logging/ConsoleLogger"], function (exports_15, context_15) {
    "use strict";
    var ConsoleLogger_1, LogLevel, LogService;
    var __moduleName = context_15 && context_15.id;
    /**
     * Extracts the useful part of a request's error into something loggable.
     * @param {Error} err The error to parse.
     * @returns {*} The extracted error, or the given error if unaltered.
     * @category Logging
     */
    function extractRequestError(err) {
        if (err === null || err === void 0 ? void 0 : err['body']) {
            return err['body'];
        }
        return err;
    }
    exports_15("extractRequestError", extractRequestError);
    return {
        setters: [
            function (ConsoleLogger_1_1) {
                ConsoleLogger_1 = ConsoleLogger_1_1;
            }
        ],
        execute: function () {
            /**
             * The log levels to log at.
             * @category Logging
             */
            LogLevel = class LogLevel {
                constructor(level, sequence) {
                    this.level = level;
                    this.sequence = sequence;
                }
                includes(level) {
                    return level.sequence >= this.sequence;
                }
                toString() {
                    return this.level;
                }
                static fromString(level, defaultLevel = LogLevel.DEBUG) {
                    if (!level)
                        return defaultLevel;
                    if (level.toUpperCase() === LogLevel.TRACE.level)
                        return LogLevel.TRACE;
                    if (level.toUpperCase() === LogLevel.DEBUG.level)
                        return LogLevel.DEBUG;
                    if (level.toUpperCase() === LogLevel.INFO.level)
                        return LogLevel.INFO;
                    if (level.toUpperCase() === LogLevel.WARN.level)
                        return LogLevel.WARN;
                    if (level.toUpperCase() === LogLevel.ERROR.level)
                        return LogLevel.ERROR;
                    return defaultLevel;
                }
            };
            exports_15("LogLevel", LogLevel);
            /**
             * The TRACE channel
             */
            LogLevel.TRACE = new LogLevel("TRACE", -1);
            /**
             * The DEBUG channel
             */
            LogLevel.DEBUG = new LogLevel("DEBUG", 0);
            /**
             * The INFO channel
             */
            LogLevel.INFO = new LogLevel("INFO", 1);
            /**
             * The WARN channel
             */
            LogLevel.WARN = new LogLevel("WARN", 2);
            /**
             * The ERROR channel
             */
            LogLevel.ERROR = new LogLevel("ERROR", 3);
            /**
             * Service class for logging in the bot-sdk
             * @category Logging
             */
            LogService = class LogService {
                constructor() {
                }
                /**
                 * The level at which the LogService is running.
                 */
                static get level() {
                    return this.logLevel;
                }
                /**
                 * Sets the log level for this logger. Defaults to DEBUG.
                 * @param {LogLevel} level the new log level
                 */
                static setLevel(level) {
                    LogService.logLevel = level || LogLevel.DEBUG;
                }
                /**
                 * Sets a new logger for the Log Service
                 * @param {ILogger} logger the new logger
                 */
                static setLogger(logger) {
                    LogService.logger = logger;
                }
                /**
                 * Mutes a module from the logger.
                 * @param {string} name The module name to mute.
                 */
                static muteModule(name) {
                    LogService.mutedModules.push(name);
                }
                /**
                 * Logs to the TRACE channel
                 * @param {string} module The module being logged
                 * @param {any[]} messageOrObject The data to log
                 */
                static trace(module, ...messageOrObject) {
                    if (!LogService.logLevel.includes(LogLevel.TRACE))
                        return;
                    if (LogService.mutedModules.includes(module))
                        return;
                    LogService.logger.trace(module, ...messageOrObject);
                }
                /**
                 * Logs to the DEBUG channel
                 * @param {string} module The module being logged
                 * @param {any[]} messageOrObject The data to log
                 */
                static debug(module, ...messageOrObject) {
                    if (!LogService.logLevel.includes(LogLevel.DEBUG))
                        return;
                    if (LogService.mutedModules.includes(module))
                        return;
                    LogService.logger.debug(module, ...messageOrObject);
                }
                /**
                 * Logs to the ERROR channel
                 * @param {string} module The module being logged
                 * @param {any[]} messageOrObject The data to log
                 */
                static error(module, ...messageOrObject) {
                    if (!LogService.logLevel.includes(LogLevel.ERROR))
                        return;
                    if (LogService.mutedModules.includes(module))
                        return;
                    LogService.logger.error(module, ...messageOrObject);
                }
                /**
                 * Logs to the INFO channel
                 * @param {string} module The module being logged
                 * @param {any[]} messageOrObject The data to log
                 */
                static info(module, ...messageOrObject) {
                    if (!LogService.logLevel.includes(LogLevel.INFO))
                        return;
                    if (LogService.mutedModules.includes(module))
                        return;
                    LogService.logger.info(module, ...messageOrObject);
                }
                /**
                 * Logs to the WARN channel
                 * @param {string} module The module being logged
                 * @param {any[]} messageOrObject The data to log
                 */
                static warn(module, ...messageOrObject) {
                    if (!LogService.logLevel.includes(LogLevel.WARN))
                        return;
                    if (LogService.mutedModules.includes(module))
                        return;
                    LogService.logger.warn(module, ...messageOrObject);
                }
            };
            exports_15("LogService", LogService);
            LogService.logger = new ConsoleLogger_1.ConsoleLogger();
            LogService.logLevel = LogLevel.INFO;
            LogService.mutedModules = [];
        }
    };
});
System.register("request", ["request"], function (exports_16, context_16) {
    "use strict";
    var origRequestFn, requestFn;
    var __moduleName = context_16 && context_16.id;
    /**
     * Sets the function to use for performing HTTP requests. Must be compatible with `request`.
     * @param fn The new request function.
     * @category Unit testing
     */
    function setRequestFn(fn) {
        requestFn = fn;
    }
    exports_16("setRequestFn", setRequestFn);
    /**
     * Gets the `request`-compatible function for performing HTTP requests.
     * @returns The request function.
     * @category Unit testing
     */
    function getRequestFn() {
        return requestFn;
    }
    exports_16("getRequestFn", getRequestFn);
    return {
        setters: [
            function (origRequestFn_1) {
                origRequestFn = origRequestFn_1;
            }
        ],
        execute: function () {
            requestFn = origRequestFn;
        }
    };
});
System.register("http", ["logging/LogService", "request"], function (exports_17, context_17) {
    "use strict";
    var LogService_1, request_1, lastRequestId;
    var __moduleName = context_17 && context_17.id;
    /**
     * Performs a web request to a server.
     * @category Unit testing
     * @param {string} baseUrl The base URL to apply to the call.
     * @param {"GET"|"POST"|"PUT"|"DELETE"} method The HTTP method to use in the request
     * @param {string} endpoint The endpoint to call. For example: "/_matrix/client/r0/account/whoami"
     * @param {any} qs The query string to send. Optional.
     * @param {any} body The request body to send. Optional. Will be converted to JSON unless the type is a Buffer.
     * @param {any} headers Additional headers to send in the request.
     * @param {number} timeout The number of milliseconds to wait before timing out.
     * @param {boolean} raw If true, the raw response will be returned instead of the response body.
     * @param {string} contentType The content type to send. Only used if the `body` is a Buffer.
     * @param {string} noEncoding Set to true to disable encoding, and return a Buffer. Defaults to false
     * @returns {Promise<any>} Resolves to the response (body), rejected if a non-2xx status code was returned.
     */
    function doHttpRequest(baseUrl, method, endpoint, qs = null, body = null, headers = {}, timeout = 60000, raw = false, contentType = "application/json", noEncoding = false) {
        if (!endpoint.startsWith('/')) {
            endpoint = '/' + endpoint;
        }
        const requestId = ++lastRequestId;
        const url = baseUrl + endpoint;
        // This is logged at info so that when a request fails people can figure out which one.
        LogService_1.LogService.debug("MatrixHttpClient (REQ-" + requestId + ")", method + " " + url);
        // Don't log the request unless we're in debug mode. It can be large.
        if (LogService_1.LogService.level.includes(LogService_1.LogLevel.TRACE)) {
            if (qs)
                LogService_1.LogService.trace("MatrixHttpClient (REQ-" + requestId + ")", "qs = " + JSON.stringify(qs));
            if (body && !Buffer.isBuffer(body))
                LogService_1.LogService.trace("MatrixHttpClient (REQ-" + requestId + ")", "body = " + JSON.stringify(this.redactObjectForLogging(body)));
            if (body && Buffer.isBuffer(body))
                LogService_1.LogService.trace("MatrixHttpClient (REQ-" + requestId + ")", "body = <Buffer>");
        }
        const params = {
            uri: url,
            method: method,
            qs: qs,
            // If this is undefined, then a string will be returned. If it's null, a Buffer will be returned.
            encoding: noEncoding === false ? undefined : null,
            useQuerystring: true,
            qsStringifyOptions: {
                options: { arrayFormat: 'repeat' },
            },
            timeout: timeout,
            headers: headers,
        };
        if (body) {
            if (Buffer.isBuffer(body)) {
                params.headers["Content-Type"] = contentType;
                params.body = body;
            }
            else {
                params.headers["Content-Type"] = "application/json";
                params.body = JSON.stringify(body);
            }
        }
        return new Promise((resolve, reject) => {
            request_1.getRequestFn()(params, (err, response, resBody) => {
                if (err) {
                    LogService_1.LogService.error("MatrixHttpClient (REQ-" + requestId + ")", err);
                    reject(err);
                }
                else {
                    if (typeof (resBody) === 'string') {
                        try {
                            resBody = JSON.parse(resBody);
                        }
                        catch (e) {
                        }
                    }
                    if (typeof (response.body) === 'string') {
                        try {
                            response.body = JSON.parse(response.body);
                        }
                        catch (e) {
                        }
                    }
                    const respIsBuffer = (response.body instanceof Buffer);
                    // Don't log the body unless we're in debug mode. They can be large.
                    if (LogService_1.LogService.level.includes(LogService_1.LogLevel.TRACE)) {
                        const redactedBody = respIsBuffer ? '<Buffer>' : redactObjectForLogging(response.body);
                        LogService_1.LogService.trace("MatrixHttpClient (REQ-" + requestId + " RESP-H" + response.statusCode + ")", redactedBody);
                    }
                    if (response.statusCode < 200 || response.statusCode >= 300) {
                        const redactedBody = respIsBuffer ? '<Buffer>' : redactObjectForLogging(response.body);
                        LogService_1.LogService.error("MatrixHttpClient (REQ-" + requestId + ")", redactedBody);
                        reject(response);
                    }
                    else
                        resolve(raw ? response : resBody);
                }
            });
        });
    }
    exports_17("doHttpRequest", doHttpRequest);
    function redactObjectForLogging(input) {
        if (!input)
            return input;
        const fieldsToRedact = [
            'access_token',
            'password',
            'new_password',
        ];
        const redactFn = (i) => {
            if (!i)
                return i;
            // Don't treat strings like arrays/objects
            if (typeof i === 'string')
                return i;
            if (Array.isArray(i)) {
                const rebuilt = [];
                for (const v of i) {
                    rebuilt.push(redactFn(v));
                }
                return rebuilt;
            }
            if (i instanceof Object) {
                const rebuilt = {};
                for (const key of Object.keys(i)) {
                    if (fieldsToRedact.includes(key)) {
                        rebuilt[key] = '<redacted>';
                    }
                    else {
                        rebuilt[key] = redactFn(i[key]);
                    }
                }
                return rebuilt;
            }
            return i; // It's a primitive value
        };
        return redactFn(input);
    }
    exports_17("redactObjectForLogging", redactObjectForLogging);
    return {
        setters: [
            function (LogService_1_1) {
                LogService_1 = LogService_1_1;
            },
            function (request_1_1) {
                request_1 = request_1_1;
            }
        ],
        execute: function () {
            lastRequestId = 0;
        }
    };
});
System.register("models/Policies", [], function (exports_18, context_18) {
    "use strict";
    var __moduleName = context_18 && context_18.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("metrics/IMetricListener", [], function (exports_19, context_19) {
    "use strict";
    var __moduleName = context_19 && context_19.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("metrics/Metrics", ["index"], function (exports_20, context_20) {
    "use strict";
    var __1, Metrics;
    var __moduleName = context_20 && context_20.id;
    return {
        setters: [
            function (__1_1) {
                __1 = __1_1;
            }
        ],
        execute: function () {
            /**
             * Tracks metrics.
             * @category Metrics
             */
            Metrics = class Metrics {
                /**
                 * Creates a new Metrics handler with optional parent handler. When
                 * a parent handler is defined, metrics will be automatically published
                 * upwards to the parent.
                 * @param {Metrics} parent Optional parent for upstream metrics.
                 */
                constructor(parent = null) {
                    this.listeners = [];
                    this.requestStartTimes = {};
                    this.uid = 0;
                    if (parent !== null) {
                        this.registerListener({
                            onIncrement(metricName, context, amount) {
                                parent.listeners.forEach(h => h.onIncrement(metricName, context, amount));
                            },
                            onDecrement(metricName, context, amount) {
                                parent.listeners.forEach(h => h.onDecrement(metricName, context, amount));
                            },
                            onReset(metricName, context) {
                                parent.listeners.forEach(h => h.onReset(metricName, context));
                            },
                            onStartMetric(metricName, context) {
                                parent.listeners.forEach(h => h.onStartMetric(metricName, context));
                            },
                            onEndMetric(metricName, context, timeMs) {
                                parent.listeners.forEach(h => h.onEndMetric(metricName, context, timeMs));
                            },
                        });
                    }
                }
                /**
                 * Registers a metric listener.
                 * @param {IMetricListener} listener The listener.
                 */
                registerListener(listener) {
                    this.listeners.push(listener);
                }
                /**
                 * De-registers a metric listener.
                 * @param {IMetricListener} listener The listener.
                 */
                unregisterListener(listener) {
                    const idx = this.listeners.indexOf(listener);
                    if (idx !== -1)
                        this.listeners.splice(idx, 1);
                }
                /**
                 * Starts a timer on a metric.
                 * @param {string} metricName The metric name.
                 * @param {IMetricContext} context The metric context. Expected to have a unique ID.
                 */
                start(metricName, context) {
                    this.requestStartTimes[context.uniqueId] = new Date().getTime();
                    this.listeners.forEach(h => h.onStartMetric(metricName, context));
                }
                /**
                 * Ends a timer on a metric.
                 * @param {string} metricName The metric name.
                 * @param {IMetricContext} context The metric context. Expected to have a unique ID.
                 */
                end(metricName, context) {
                    const timeMs = (new Date().getTime()) - this.requestStartTimes[context.uniqueId];
                    delete this.requestStartTimes[context.uniqueId];
                    this.listeners.forEach(h => h.onEndMetric(metricName, context, timeMs));
                    // Trim the context for logging
                    const trimmedContext = {};
                    for (const key of Object.keys(context)) {
                        if (key === 'client') {
                            const client = context[key];
                            trimmedContext[key] = `<MatrixClient ${client['userId'] || 'NoCachedUserID'}>`;
                        }
                        else if (key === 'intent') {
                            const intent = context[key];
                            trimmedContext[key] = `<Intent ${intent['userId'] || 'NoImpersonatedUserID'}>`;
                        }
                        else {
                            trimmedContext[key] = context[key];
                        }
                    }
                    __1.LogService.trace("Metrics", metricName, trimmedContext, timeMs);
                }
                /**
                 * Increments a metric.
                 * @param {string} metricName The metric name.
                 * @param {IMetricContext} context The metric context. Expected to have a unique ID.
                 * @param {number} amount The amount.
                 */
                increment(metricName, context, amount) {
                    this.listeners.forEach(h => h.onIncrement(metricName, context, amount));
                }
                /**
                 * Decrements a metric.
                 * @param {string} metricName The metric name.
                 * @param {IMetricContext} context The metric context. Expected to have a unique ID.
                 * @param {number} amount The amount.
                 */
                decrement(metricName, context, amount) {
                    this.listeners.forEach(h => h.onDecrement(metricName, context, amount));
                }
                /**
                 * Resets a metric.
                 * @param {string} metricName The metric name.
                 * @param {IMetricContext} context The metric context. Expected to have a unique ID.
                 */
                reset(metricName, context) {
                    this.listeners.forEach(h => h.onReset(metricName, context));
                }
                /**
                 * Assigns a unique ID to the context object, returning it back.
                 * @param {IMetricContext} context The context to modify.
                 * @returns {IMetricContext} The provided context.
                 */
                assignUniqueContextId(context) {
                    context.uniqueId = `${new Date().getTime()}-${this.uid++}`;
                    return context;
                }
            };
            exports_20("Metrics", Metrics);
        }
    };
});
System.register("models/Threepid", [], function (exports_21, context_21) {
    "use strict";
    var __moduleName = context_21 && context_21.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("helpers/UnpaddedBase64", [], function (exports_22, context_22) {
    "use strict";
    var UnpaddedBase64;
    var __moduleName = context_22 && context_22.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Unpadded Base64 utilities for Matrix.
             * @category Utilities
             */
            UnpaddedBase64 = class UnpaddedBase64 {
                constructor() {
                }
                /**
                 * Encodes a buffer to Unpadded Base64
                 * @param {Buffer} buf The buffer to encode.
                 * @returns {string} The Unpadded Base64 string
                 */
                static encodeBuffer(buf) {
                    return buf.toString('base64').replace(/[=]*$/g, '');
                }
                /**
                 * Encodes a string to Unpadded Base64
                 * @param {string} str The string to encode.
                 * @returns {string} The Unpadded Base64 string
                 */
                static encodeString(str) {
                    return UnpaddedBase64.encodeBuffer(new Buffer(str));
                }
                /**
                 * Encodes a buffer to Unpadded Base64 (URL Safe Edition)
                 * @param {Buffer} buf The buffer to encode.
                 * @returns {string} The Unpadded Base64 string
                 */
                static encodeBufferUrlSafe(buf) {
                    return UnpaddedBase64.encodeBuffer(buf).replace(/\+/g, '-').replace(/\//g, '_');
                }
                /**
                 * Encodes a string to Unpadded Base64 (URL Safe Edition)
                 * @param {string} str The string to encode.
                 * @returns {string} The Unpadded Base64 string
                 */
                static encodeStringUrlSafe(str) {
                    return UnpaddedBase64.encodeBufferUrlSafe(new Buffer(str));
                }
            };
            exports_22("UnpaddedBase64", UnpaddedBase64);
        }
    };
});
System.register("models/MatrixProfile", ["index"], function (exports_23, context_23) {
    "use strict";
    var __2, MatrixProfile;
    var __moduleName = context_23 && context_23.id;
    return {
        setters: [
            function (__2_1) {
                __2 = __2_1;
            }
        ],
        execute: function () {
            /**
             * Represents a user's profile, possibly in a room.
             * @category Models
             */
            MatrixProfile = class MatrixProfile {
                /**
                 * Creates a new profile representation for a user.
                 * @param {string} userId The user ID the profile is for.
                 * @param {MatrixProfile} profile The profile itself.
                 */
                constructor(userId, profile) {
                    this.userId = userId;
                    this.profile = profile;
                }
                /**
                 * The display name for the user. This will always return a value, though it
                 * may be based upon their user ID if no explicit display name is set.
                 */
                get displayName() {
                    var _a;
                    if (!((_a = this.profile) === null || _a === void 0 ? void 0 : _a.displayname))
                        return new __2.UserID(this.userId).localpart;
                    return this.profile.displayname;
                }
                /**
                 * The avatar URL for the user. If the user does not have an avatar, this will
                 * be null.
                 */
                get avatarUrl() {
                    var _a;
                    return ((_a = this.profile) === null || _a === void 0 ? void 0 : _a.avatar_url) || null; // enforce null over boolean semantics
                }
                /**
                 * A mention pill for this user.
                 */
                get mention() {
                    return __2.MentionPill.withDisplayName(this.userId, this.displayName);
                }
            };
            exports_23("MatrixProfile", MatrixProfile);
        }
    };
});
System.register("models/IdentityServerModels", [], function (exports_24, context_24) {
    "use strict";
    var __moduleName = context_24 && context_24.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("identity/IdentityClient", ["http", "metrics/decorators", "metrics/Metrics", "crypto", "helpers/UnpaddedBase64", "models/MatrixProfile"], function (exports_25, context_25) {
    "use strict";
    var http_1, decorators_1, Metrics_1, crypto, UnpaddedBase64_1, MatrixProfile_1, IdentityClient;
    var __moduleName = context_25 && context_25.id;
    return {
        setters: [
            function (http_1_1) {
                http_1 = http_1_1;
            },
            function (decorators_1_1) {
                decorators_1 = decorators_1_1;
            },
            function (Metrics_1_1) {
                Metrics_1 = Metrics_1_1;
            },
            function (crypto_1) {
                crypto = crypto_1;
            },
            function (UnpaddedBase64_1_1) {
                UnpaddedBase64_1 = UnpaddedBase64_1_1;
            },
            function (MatrixProfile_1_1) {
                MatrixProfile_1 = MatrixProfile_1_1;
            }
        ],
        execute: function () {
            /**
             * A way to access an Identity Server using the Identity Service API from a MatrixClient.
             * @category Identity Servers
             */
            IdentityClient = class IdentityClient {
                constructor(accessToken, serverUrl, matrixClient) {
                    this.accessToken = accessToken;
                    this.serverUrl = serverUrl;
                    this.matrixClient = matrixClient;
                    this.metrics = new Metrics_1.Metrics();
                }
                /**
                 * Gets account information for the logged in user.
                 * @returns {Promise<IdentityServerAccount>} Resolves to the account information
                 */
                getAccount() {
                    return this.doRequest("GET", "/_matrix/identity/v2/account");
                }
                /**
                 * Gets the terms of service for which the identity server has.
                 * @returns {Promise<Policies>} Resolves to the policies of the server.
                 */
                getTermsOfService() {
                    return this.doRequest("GET", "/_matrix/identity/v2/terms");
                }
                /**
                 * Accepts a given set of URLs from Policy objects returned by the server. This implies acceptance of
                 * the terms. Note that this will not update the user's account data to consider these terms accepted
                 * in the future - that is an exercise left to the caller.
                 * @param {string[]} termsUrls The URLs to count as accepted.
                 * @returns {Promise<void>} Resolves when complete.
                 */
                acceptTerms(termsUrls) {
                    return this.doRequest("POST", "/_matrix/identity/v2/terms", null, {
                        user_accepts: termsUrls,
                    });
                }
                /**
                 * Accepts all the terms of service offered by the identity server. Note that this is only meant to be
                 * used by automated bots where terms acceptance is implicit - the terms of service need to be presented
                 * to the user in most cases.
                 * @returns {Promise<void>} Resolves when complete.
                 */
                acceptAllTerms() {
                    return __awaiter(this, void 0, void 0, function* () {
                        const terms = yield this.getTermsOfService();
                        const urls = new Set();
                        for (const policy of Object.values(terms.policies)) {
                            let chosenLang = policy["en"];
                            if (!chosenLang) {
                                chosenLang = policy[Object.keys(policy).find(k => k !== "version")];
                            }
                            if (!chosenLang)
                                continue; // skip - invalid
                            urls.add(chosenLang.url);
                        }
                        return yield this.acceptTerms(Array.from(urls));
                    });
                }
                /**
                 * Looks up a series of third party identifiers (email addresses or phone numbers) to see if they have
                 * associated mappings. The returned array will be ordered the same as the input, and have falsey values
                 * in place of any failed/missing lookups (eg: no mapping).
                 * @param {Threepid[]} identifiers The identifiers to look up.
                 * @param {boolean} allowPlaintext If true, the function will accept the server's offer to use plaintext
                 * lookups when no other methods are available. The function will always prefer hashed methods.
                 * @returns {Promise<string[]>} Resolves to the user IDs (or falsey values) in the same order as the input.
                 */
                lookup(identifiers, allowPlaintext = false) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const hashInfo = yield this.doRequest("GET", "/_matrix/identity/v2/hash_details");
                        if (!(hashInfo === null || hashInfo === void 0 ? void 0 : hashInfo["algorithms"]))
                            throw new Error("Server not supported: invalid response");
                        const algorithms = hashInfo === null || hashInfo === void 0 ? void 0 : hashInfo["algorithms"];
                        let algorithm = algorithms.find(a => a === "sha256");
                        if (!algorithm && allowPlaintext)
                            algorithm = algorithms.find(a => a === "none");
                        if (!algorithm)
                            throw new Error("No supported hashing algorithm found");
                        const body = {
                            algorithm,
                            pepper: hashInfo["lookup_pepper"],
                            addresses: [],
                        };
                        for (const pid of identifiers) {
                            let transformed = null;
                            switch (algorithm) {
                                case "none":
                                    transformed = `${pid.address.toLowerCase()} ${pid.kind}`;
                                    break;
                                case "sha256":
                                    transformed = UnpaddedBase64_1.UnpaddedBase64.encodeBufferUrlSafe(crypto.createHash("sha256")
                                        .update(`${pid.address.toLowerCase()} ${pid.kind} ${body.pepper}`).digest());
                                    break;
                                default:
                                    throw new Error("Unsupported hashing algorithm (programming error)");
                            }
                            body.addresses.push(transformed);
                        }
                        const resp = yield this.doRequest("POST", "/_matrix/identity/v2/lookup", null, body);
                        const mappings = (resp === null || resp === void 0 ? void 0 : resp["mappings"]) || {};
                        const mxids = [];
                        for (const addr of body.addresses) {
                            mxids.push(mappings[addr]);
                        }
                        return mxids;
                    });
                }
                /**
                 * Creates a third party email invite. This will store the invite in the identity server, but
                 * not publish the invite to the room - the caller is expected to handle the remaining part. Note
                 * that this function is not required to be called when using the Client-Server API for inviting
                 * third party addresses to a room. This will make several calls into the room state to populate
                 * the invite details, therefore the inviter (the client backing this identity client) must be
                 * present in the room.
                 * @param {string} emailAddress The email address to invite.
                 * @param {string} roomId The room ID to invite to.
                 * @returns {Promise<IdentityServerInvite>} Resolves to the identity server's stored invite.
                 */
                makeEmailInvite(emailAddress, roomId) {
                    var _a, _b, _c, _d;
                    return __awaiter(this, void 0, void 0, function* () {
                        const req = {
                            address: emailAddress,
                            medium: "email",
                            room_id: roomId,
                            sender: yield this.matrixClient.getUserId(),
                        };
                        const tryFetch = (eventType, stateKey) => __awaiter(this, void 0, void 0, function* () {
                            try {
                                return yield this.matrixClient.getRoomStateEvent(roomId, eventType, stateKey);
                            }
                            catch (e) {
                                return null;
                            }
                        });
                        const canonicalAlias = (_a = (yield tryFetch("m.room.canonical_alias", ""))) === null || _a === void 0 ? void 0 : _a["alias"];
                        const roomName = (_b = (yield tryFetch("m.room.name", ""))) === null || _b === void 0 ? void 0 : _b["name"];
                        req["room_alias"] = canonicalAlias;
                        req["room_avatar_url"] = (_c = (yield tryFetch("m.room.avatar", ""))) === null || _c === void 0 ? void 0 : _c["url"];
                        req["room_name"] = roomName || canonicalAlias;
                        req["room_join_rules"] = (_d = (yield tryFetch("m.room.join_rules", ""))) === null || _d === void 0 ? void 0 : _d["join_rule"];
                        let profileInfo;
                        try {
                            profileInfo = yield this.matrixClient.getUserProfile(yield this.matrixClient.getUserId());
                        }
                        catch (e) {
                            // ignore
                        }
                        const senderProfile = new MatrixProfile_1.MatrixProfile(yield this.matrixClient.getUserId(), profileInfo);
                        req["sender_avatar_url"] = senderProfile.avatarUrl;
                        req["sender_display_name"] = senderProfile.displayName;
                        const inviteReq = {};
                        for (const entry of Object.entries(req)) {
                            if (!!entry[1])
                                inviteReq[entry[0]] = entry[1];
                        }
                        const qs = {};
                        if (this.brand)
                            qs['brand'] = this.brand;
                        return yield this.doRequest("POST", "/_matrix/identity/v2/store-invite", qs, inviteReq);
                    });
                }
                /**
                 * Performs a web request to the server, applying appropriate authorization headers for
                 * this client.
                 * @param {"GET"|"POST"|"PUT"|"DELETE"} method The HTTP method to use in the request
                 * @param {string} endpoint The endpoint to call. For example: "/_matrix/identity/v2/account"
                 * @param {any} qs The query string to send. Optional.
                 * @param {any} body The request body to send. Optional. Will be converted to JSON unless the type is a Buffer.
                 * @param {number} timeout The number of milliseconds to wait before timing out.
                 * @param {boolean} raw If true, the raw response will be returned instead of the response body.
                 * @param {string} contentType The content type to send. Only used if the `body` is a Buffer.
                 * @param {string} noEncoding Set to true to disable encoding, and return a Buffer. Defaults to false
                 * @returns {Promise<any>} Resolves to the response (body), rejected if a non-2xx status code was returned.
                 */
                doRequest(method, endpoint, qs = null, body = null, timeout = 60000, raw = false, contentType = "application/json", noEncoding = false) {
                    const headers = {};
                    if (this.accessToken) {
                        headers["Authorization"] = `Bearer ${this.accessToken}`;
                    }
                    return http_1.doHttpRequest(this.serverUrl, method, endpoint, qs, body, headers, timeout, raw, contentType, noEncoding);
                }
                /**
                 * Gets an instance of an identity client.
                 * @param {OpenIDConnectToken} oidc The OpenID Connect token to register to the identity server with.
                 * @param {string} serverUrl The full URL where the identity server can be reached at.
                 */
                static acquire(oidc, serverUrl, mxClient) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const account = yield http_1.doHttpRequest(serverUrl, "POST", "/_matrix/identity/v2/account/register", null, oidc);
                        return new IdentityClient(account['token'], serverUrl, mxClient);
                    });
                }
            };
            __decorate([
                decorators_1.timedIdentityClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Promise)
            ], IdentityClient.prototype, "getAccount", null);
            __decorate([
                decorators_1.timedIdentityClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Promise)
            ], IdentityClient.prototype, "getTermsOfService", null);
            __decorate([
                decorators_1.timedIdentityClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Array]),
                __metadata("design:returntype", Promise)
            ], IdentityClient.prototype, "acceptTerms", null);
            __decorate([
                decorators_1.timedIdentityClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Promise)
            ], IdentityClient.prototype, "acceptAllTerms", null);
            __decorate([
                decorators_1.timedIdentityClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Array, Object]),
                __metadata("design:returntype", Promise)
            ], IdentityClient.prototype, "lookup", null);
            __decorate([
                decorators_1.timedIdentityClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String]),
                __metadata("design:returntype", Promise)
            ], IdentityClient.prototype, "makeEmailInvite", null);
            __decorate([
                decorators_1.timedIdentityClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object, Object, Object, Object, Object, Object, Object]),
                __metadata("design:returntype", Promise)
            ], IdentityClient.prototype, "doRequest", null);
            exports_25("IdentityClient", IdentityClient);
        }
    };
});
System.register("metrics/contexts", [], function (exports_26, context_26) {
    "use strict";
    var __moduleName = context_26 && context_26.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("metrics/decorators", ["metrics/names"], function (exports_27, context_27) {
    "use strict";
    var names_1;
    var __moduleName = context_27 && context_27.id;
    /**
     * Times a MatrixClient function call for metrics.
     * @category Metrics
     */
    function timedMatrixClientFunctionCall() {
        return function (target, propertyKey, descriptor) {
            const originalMethod = descriptor.value;
            descriptor.value = function (...args) {
                const metrics = this.metrics;
                const context = metrics.assignUniqueContextId({
                    functionName: propertyKey,
                    client: this,
                });
                metrics.start(names_1.METRIC_MATRIX_CLIENT_FUNCTION_CALL, context);
                let result;
                let exception;
                try {
                    result = originalMethod.apply(this, args);
                }
                catch (e) {
                    exception = e;
                    result = Promise.reject(e);
                }
                let promise = result;
                if (!(result instanceof Promise) && result !== null && result !== undefined) {
                    promise = Promise.resolve(result);
                }
                promise
                    .then(() => metrics.increment(names_1.METRIC_MATRIX_CLIENT_SUCCESSFUL_FUNCTION_CALL, context, 1))
                    .catch(() => metrics.increment(names_1.METRIC_MATRIX_CLIENT_FAILED_FUNCTION_CALL, context, 1))
                    .finally(() => metrics.end(names_1.METRIC_MATRIX_CLIENT_FUNCTION_CALL, context));
                if (exception)
                    throw exception;
                return result;
            };
        };
    }
    exports_27("timedMatrixClientFunctionCall", timedMatrixClientFunctionCall);
    /**
     * Times an IdentityClient function call for metrics.
     * @category Metrics
     */
    function timedIdentityClientFunctionCall() {
        return function (target, propertyKey, descriptor) {
            const originalMethod = descriptor.value;
            descriptor.value = function (...args) {
                const metrics = this.metrics;
                const context = metrics.assignUniqueContextId({
                    functionName: propertyKey,
                    client: this,
                });
                metrics.start(names_1.METRIC_IDENTITY_CLIENT_FUNCTION_CALL, context);
                let result;
                let exception;
                try {
                    result = originalMethod.apply(this, args);
                }
                catch (e) {
                    exception = e;
                    result = Promise.reject(e);
                }
                let promise = result;
                if (!(result instanceof Promise) && result !== null && result !== undefined) {
                    promise = Promise.resolve(result);
                }
                promise
                    .then(() => metrics.increment(names_1.METRIC_IDENTITY_CLIENT_SUCCESSFUL_FUNCTION_CALL, context, 1))
                    .catch(() => metrics.increment(names_1.METRIC_IDENTITY_CLIENT_FAILED_FUNCTION_CALL, context, 1))
                    .finally(() => metrics.end(names_1.METRIC_IDENTITY_CLIENT_FUNCTION_CALL, context));
                if (exception)
                    throw exception;
                return result;
            };
        };
    }
    exports_27("timedIdentityClientFunctionCall", timedIdentityClientFunctionCall);
    /**
     * Times an Intent function call for metrics.
     * @category Metrics
     */
    function timedIntentFunctionCall() {
        return function (target, propertyKey, descriptor) {
            const originalMethod = descriptor.value;
            descriptor.value = function (...args) {
                const metrics = this.metrics;
                const context = metrics.assignUniqueContextId({
                    functionName: propertyKey,
                    client: this.client,
                    intent: this,
                });
                metrics.start(names_1.METRIC_INTENT_FUNCTION_CALL, context);
                let result;
                let exception;
                try {
                    result = originalMethod.apply(this, args);
                }
                catch (e) {
                    exception = e;
                    result = Promise.reject(e);
                }
                let promise = result;
                if (!(result instanceof Promise) && result !== null && result !== undefined) {
                    promise = Promise.resolve(result);
                }
                promise
                    .then(() => metrics.increment(names_1.METRIC_INTENT_SUCCESSFUL_FUNCTION_CALL, context, 1))
                    .catch(() => metrics.increment(names_1.METRIC_INTENT_FAILED_FUNCTION_CALL, context, 1))
                    .finally(() => metrics.end(names_1.METRIC_INTENT_FUNCTION_CALL, context));
                if (exception)
                    throw exception;
                return result;
            };
        };
    }
    exports_27("timedIntentFunctionCall", timedIntentFunctionCall);
    return {
        setters: [
            function (names_1_1) {
                names_1 = names_1_1;
            }
        ],
        execute: function () {
        }
    };
});
System.register("models/MSC2176", [], function (exports_28, context_28) {
    "use strict";
    var __moduleName = context_28 && context_28.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("appservice/UnstableAppserviceApis", [], function (exports_29, context_29) {
    "use strict";
    var UnstableAppserviceApis;
    var __moduleName = context_29 && context_29.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Unstable APIs that shouldn't be used in most circumstances for appservices.
             * @category Unstable APIs
             */
            UnstableAppserviceApis = class UnstableAppserviceApis {
                constructor(client) {
                    this.client = client;
                    this.requestId = 0;
                }
                /**
                 * Send several historical events into a room.
                 * @see https://github.com/matrix-org/matrix-doc/pull/2716
                 * @param {string} roomId The roomID to send to.
                 * @param {string} prevEventId The event ID where this batch will be inserted
                 * @param {string} chunkId The chunk ID returned from a previous call. Set falsy to start at the beginning.
                 * @param {any[]} events A set of event contents for events to be inserted into the room.
                 * @param {any[]} stateEventsAtStart A set of state events to be inserted into the room. Defaults to empty.
                 * @returns A set of eventIds and the next chunk ID
                 */
                sendHistoricalEventBatch(roomId, prevEventId, events, stateEventsAtStart = [], chunkId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("POST", `/_matrix/client/unstable/org.matrix.msc2716/rooms/${encodeURIComponent(roomId)}/batch_send`, {
                            prev_event: prevEventId,
                            chunk_id: chunkId,
                        }, {
                            events,
                            state_events_at_start: stateEventsAtStart,
                        });
                    });
                }
                /**
                 * Sends an event to the given room with a given timestamp.
                 * @param {string} roomId the room ID to send the event to
                 * @param {string} eventType the type of event to send
                 * @param {string} content the event body to send
                 * @param {number} ts The origin_server_ts of the new event
                 * @returns {Promise<string>} resolves to the event ID that represents the event
                 */
                sendEventWithTimestamp(roomId, eventType, content, ts) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const txnId = `${(new Date().getTime())}__inc_appts${++this.requestId}`;
                        const response = yield this.client.doRequest("PUT", `/_matrix/client/r0/rooms/${encodeURIComponent(roomId)}/send/${encodeURIComponent(eventType)}/${encodeURIComponent(txnId)}`, { ts }, content);
                        return response.event_id;
                    });
                }
                /**
                 * Sends a state event to the given room with a given timestamp.
                 * @param {string} roomId the room ID to send the event to
                 * @param {string} type the event type to send
                 * @param {string} stateKey the state key to send, should not be null
                 * @param {string} content the event body to send
                 * @param {number} ts The origin_server_ts of the new event
                 * @returns {Promise<string>} resolves to the event ID that represents the message
                 */
                sendStateEventWithTimestamp(roomId, type, stateKey, content, ts) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.client.doRequest("PUT", `/_matrix/client/r0/rooms/${encodeURIComponent(roomId)}/state/${encodeURIComponent(type)}/${encodeURIComponent(stateKey)}`, { ts }, content);
                        return response.event_id;
                    });
                }
            };
            exports_29("UnstableAppserviceApis", UnstableAppserviceApis);
        }
    };
});
System.register("appservice/Intent", ["index", "metrics/decorators", "appservice/UnstableAppserviceApis"], function (exports_30, context_30) {
    "use strict";
    var __3, decorators_2, UnstableAppserviceApis_1, Intent;
    var __moduleName = context_30 && context_30.id;
    return {
        setters: [
            function (__3_1) {
                __3 = __3_1;
            },
            function (decorators_2_1) {
                decorators_2 = decorators_2_1;
            },
            function (UnstableAppserviceApis_1_1) {
                UnstableAppserviceApis_1 = UnstableAppserviceApis_1_1;
            }
        ],
        execute: function () {
            /**
             * An Intent is an intelligent client that tracks things like the user's membership
             * in rooms to ensure the action being performed is possible. This is very similar
             * to how Intents work in the matrix-js-sdk in that the Intent will ensure that the
             * user is joined to the room before posting a message, for example.
             * @category Application services
             */
            Intent = class Intent {
                /**
                 * Creates a new intent. Intended to be created by application services.
                 * @param {IAppserviceOptions} options The options for the application service.
                 * @param {string} impersonateUserId The user ID to impersonate.
                 * @param {Appservice} appservice The application service itself.
                 */
                constructor(options, impersonateUserId, appservice) {
                    this.options = options;
                    this.impersonateUserId = impersonateUserId;
                    this.appservice = appservice;
                    this.knownJoinedRooms = [];
                    this.metrics = new __3.Metrics(appservice.metrics);
                    this.storage = options.storage;
                    this.cryptoStorage = options.cryptoStorage;
                    this.makeClient(false);
                }
                makeClient(withCrypto, accessToken) {
                    var _a, _b, _c;
                    let cryptoStore;
                    const storage = (_b = (_a = this.storage) === null || _a === void 0 ? void 0 : _a.storageForUser) === null || _b === void 0 ? void 0 : _b.call(_a, this.userId);
                    if (withCrypto) {
                        cryptoStore = (_c = this.cryptoStorage) === null || _c === void 0 ? void 0 : _c.storageForUser(this.userId);
                        if (!cryptoStore) {
                            throw new Error("Tried to set up client with crypto when not available");
                        }
                        if (!storage) {
                            throw new Error("Tried to set up client with crypto, but no persistent storage");
                        }
                    }
                    this.client = new __3.MatrixClient(this.options.homeserverUrl, accessToken !== null && accessToken !== void 0 ? accessToken : this.options.registration.as_token, storage, cryptoStore);
                    this.client.metrics = new __3.Metrics(this.appservice.metrics); // Metrics only go up by one parent
                    this.unstableApisInstance = new UnstableAppserviceApis_1.UnstableAppserviceApis(this.client);
                    if (this.impersonateUserId !== this.appservice.botUserId) {
                        this.client.impersonateUserId(this.impersonateUserId);
                    }
                    if (this.options.joinStrategy) {
                        this.client.setJoinStrategy(this.options.joinStrategy);
                    }
                }
                /**
                 * Gets the user ID this intent is for.
                 */
                get userId() {
                    return this.impersonateUserId;
                }
                /**
                 * Gets the underlying MatrixClient that powers this Intent.
                 */
                get underlyingClient() {
                    return this.client;
                }
                /**
                 * Gets the unstable API access class. This is generally not recommended to be
                 * used by appservices.
                 * @return {UnstableAppserviceApis} The unstable API access class.
                 */
                get unstableApis() {
                    return this.unstableApisInstance;
                }
                /**
                 * Sets up crypto on the client if it hasn't already been set up.
                 * @returns {Promise<void>} Resolves when complete.
                 */
                enableEncryption() {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (!this.cryptoSetupPromise) {
                            this.cryptoSetupPromise = new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
                                var _a, _b;
                                try {
                                    // Prepare a client first
                                    // XXX: We work around servers that don't support device_id impersonation
                                    yield this.ensureRegistered();
                                    const storage = (_b = (_a = this.storage) === null || _a === void 0 ? void 0 : _a.storageForUser) === null || _b === void 0 ? void 0 : _b.call(_a, this.userId);
                                    // noinspection ES6RedundantAwait
                                    const accessToken = yield Promise.resolve(storage === null || storage === void 0 ? void 0 : storage.readValue("accessToken"));
                                    if (!accessToken) {
                                        const loginBody = {
                                            type: "uk.half-shot.msc2778.login.application_service",
                                            identifier: {
                                                type: "m.id.user",
                                                user: this.userId,
                                            },
                                        };
                                        this.client.impersonateUserId(null); // avoid confusing homeserver
                                        const res = yield this.client.doRequest("POST", "/_matrix/client/r0/login", {}, loginBody);
                                        this.makeClient(true, res['access_token']);
                                        storage.storeValue("accessToken", this.client.accessToken);
                                    }
                                    else {
                                        this.makeClient(true, accessToken);
                                    }
                                    // // Populate the crypto store with basic information (to avoid server hit)
                                    // const devices = await this.client.getOwnDevices();
                                    // const deviceId = devices.find(d => d.device_id)?.device_id;
                                    // if (deviceId) {
                                    //     this.client.impersonateUserId(this.userId, deviceId);
                                    //     // await this.client.cryptoStore.setDeviceId(deviceId);
                                    // } else {
                                    //     // noinspection ExceptionCaughtLocallyJS
                                    //     throw new Error("Unable to establish a device ID");
                                    // }
                                    // Now set up crypto
                                    yield this.client.crypto.prepare(yield this.client.getJoinedRooms());
                                    resolve();
                                }
                                catch (e) {
                                    reject(e);
                                }
                            }));
                        }
                        return this.cryptoSetupPromise;
                    });
                }
                /**
                 * Gets the joined rooms for the intent. Note that by working around
                 * the intent to join rooms may yield inaccurate results.
                 * @returns {Promise<string[]>} Resolves to an array of room IDs where
                 * the intent is joined.
                 */
                getJoinedRooms() {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.ensureRegistered();
                        if (this.knownJoinedRooms.length === 0)
                            yield this.refreshJoinedRooms();
                        return this.knownJoinedRooms.map(r => r); // clone
                    });
                }
                /**
                 * Leaves the given room.
                 * @param {string} roomId The room ID to leave
                 * @returns {Promise<any>} Resolves when the room has been left.
                 */
                leaveRoom(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.ensureRegistered();
                        return this.client.leaveRoom(roomId).then(() => __awaiter(this, void 0, void 0, function* () {
                            // Recalculate joined rooms now that we've left a room
                            yield this.refreshJoinedRooms();
                        }));
                    });
                }
                /**
                 * Joins the given room
                 * @param {string} roomIdOrAlias the room ID or alias to join
                 * @returns {Promise<string>} resolves to the joined room ID
                 */
                joinRoom(roomIdOrAlias) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.ensureRegistered();
                        return this.client.joinRoom(roomIdOrAlias).then((roomId) => __awaiter(this, void 0, void 0, function* () {
                            // Recalculate joined rooms now that we've joined a room
                            yield this.refreshJoinedRooms();
                            return roomId;
                        }));
                    });
                }
                /**
                 * Sends a text message to a room.
                 * @param {string} roomId The room ID to send text to.
                 * @param {string} body The message body to send.
                 * @param {"m.text" | "m.emote" | "m.notice"} msgtype The message type to send.
                 * @returns {Promise<string>} Resolves to the event ID of the sent message.
                 */
                sendText(roomId, body, msgtype = "m.text") {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.sendEvent(roomId, { body: body, msgtype: msgtype });
                    });
                }
                /**
                 * Sends an event to a room.
                 * @param {string} roomId The room ID to send the event to.
                 * @param {any} content The content of the event.
                 * @returns {Promise<string>} Resolves to the event ID of the sent event.
                 */
                sendEvent(roomId, content) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.ensureRegisteredAndJoined(roomId);
                        return this.client.sendMessage(roomId, content);
                    });
                }
                /**
                 * Ensures the user is registered and joined to the given room.
                 * @param {string} roomId The room ID to join
                 * @returns {Promise<any>} Resolves when complete
                 */
                ensureRegisteredAndJoined(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.ensureRegistered();
                        yield this.ensureJoined(roomId);
                    });
                }
                /**
                 * Ensures the user is joined to the given room
                 * @param {string} roomId The room ID to join
                 * @returns {Promise<any>} Resolves when complete
                 */
                ensureJoined(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (this.knownJoinedRooms.indexOf(roomId) !== -1) {
                            return;
                        }
                        yield this.refreshJoinedRooms();
                        if (this.knownJoinedRooms.indexOf(roomId) !== -1) {
                            return;
                        }
                        const returnedRoomId = yield this.client.joinRoom(roomId);
                        if (!this.knownJoinedRooms.includes(returnedRoomId)) {
                            this.knownJoinedRooms.push(returnedRoomId);
                        }
                        return returnedRoomId;
                    });
                }
                /**
                 * Refreshes which rooms the user is joined to, potentially saving time on
                 * calls like ensureJoined()
                 * @returns {Promise<string[]>} Resolves to the joined room IDs for the user.
                 */
                refreshJoinedRooms() {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.knownJoinedRooms = yield this.client.getJoinedRooms();
                        return this.knownJoinedRooms.map(r => r); // clone
                    });
                }
                /**
                 * Ensures the user is registered
                 * @returns {Promise<any>} Resolves when complete
                 */
                ensureRegistered() {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (!(yield Promise.resolve(this.storage.isUserRegistered(this.userId)))) {
                            try {
                                const result = yield this.client.doRequest("POST", "/_matrix/client/r0/register", null, {
                                    type: "m.login.application_service",
                                    username: this.userId.substring(1).split(":")[0],
                                });
                                // HACK: Workaround for unit tests
                                if (result['errcode']) {
                                    // noinspection ExceptionCaughtLocallyJS
                                    throw { body: result };
                                }
                            }
                            catch (err) {
                                if (typeof (err.body) === "string")
                                    err.body = JSON.parse(err.body);
                                if (err.body && err.body["errcode"] === "M_USER_IN_USE") {
                                    yield Promise.resolve(this.storage.addRegisteredUser(this.userId));
                                    if (this.userId === this.appservice.botUserId) {
                                        return null;
                                    }
                                    else {
                                        __3.LogService.error("Appservice", "Error registering user: User ID is in use");
                                        return null;
                                    }
                                }
                                else {
                                    __3.LogService.error("Appservice", "Encountered error registering user: ");
                                    __3.LogService.error("Appservice", __3.extractRequestError(err));
                                }
                                throw err;
                            }
                            yield Promise.resolve(this.storage.addRegisteredUser(this.userId));
                        }
                    });
                }
            };
            __decorate([
                decorators_2.timedIntentFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Promise)
            ], Intent.prototype, "enableEncryption", null);
            __decorate([
                decorators_2.timedIntentFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Promise)
            ], Intent.prototype, "getJoinedRooms", null);
            __decorate([
                decorators_2.timedIntentFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], Intent.prototype, "leaveRoom", null);
            __decorate([
                decorators_2.timedIntentFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], Intent.prototype, "joinRoom", null);
            __decorate([
                decorators_2.timedIntentFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String, String]),
                __metadata("design:returntype", Promise)
            ], Intent.prototype, "sendText", null);
            __decorate([
                decorators_2.timedIntentFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, Object]),
                __metadata("design:returntype", Promise)
            ], Intent.prototype, "sendEvent", null);
            __decorate([
                decorators_2.timedIntentFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], Intent.prototype, "ensureRegisteredAndJoined", null);
            __decorate([
                decorators_2.timedIntentFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], Intent.prototype, "ensureJoined", null);
            __decorate([
                decorators_2.timedIntentFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Promise)
            ], Intent.prototype, "refreshJoinedRooms", null);
            __decorate([
                decorators_2.timedIntentFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Promise)
            ], Intent.prototype, "ensureRegistered", null);
            exports_30("Intent", Intent);
        }
    };
});
System.register("appservice/MatrixBridge", [], function (exports_31, context_31) {
    "use strict";
    var REMOTE_USER_INFO_ACCOUNT_DATA_EVENT_TYPE, REMOTE_ROOM_INFO_ACCOUNT_DATA_EVENT_TYPE, REMOTE_USER_MAP_ACCOUNT_DATA_EVENT_TYPE_PREFIX, REMOTE_ROOM_MAP_ACCOUNT_DATA_EVENT_TYPE_PREFIX, MatrixBridge;
    var __moduleName = context_31 && context_31.id;
    return {
        setters: [],
        execute: function () {
            exports_31("REMOTE_USER_INFO_ACCOUNT_DATA_EVENT_TYPE", REMOTE_USER_INFO_ACCOUNT_DATA_EVENT_TYPE = "io.t2bot.sdk.bot.remote_user_info");
            exports_31("REMOTE_ROOM_INFO_ACCOUNT_DATA_EVENT_TYPE", REMOTE_ROOM_INFO_ACCOUNT_DATA_EVENT_TYPE = "io.t2bot.sdk.bot.remote_room_info");
            exports_31("REMOTE_USER_MAP_ACCOUNT_DATA_EVENT_TYPE_PREFIX", REMOTE_USER_MAP_ACCOUNT_DATA_EVENT_TYPE_PREFIX = "io.t2bot.sdk.bot.remote_user_map");
            exports_31("REMOTE_ROOM_MAP_ACCOUNT_DATA_EVENT_TYPE_PREFIX", REMOTE_ROOM_MAP_ACCOUNT_DATA_EVENT_TYPE_PREFIX = "io.t2bot.sdk.bot.remote_room_map");
            /**
             * Utility class for common operations performed by bridges (represented
             * as appservices).
             *
             * The storage utilities are not intended for bridges which allow 1:many
             * relationships with the remote network.
             *
             * Bridges are generally expected to create their own classes which extend
             * the IRemoteRoomInfo and IRemoteUserInfo interfaces and serialize to JSON
             * cleanly. The serialized version of these classes is persisted in various
             * account data locations for future lookups.
             * @category Application services
             */
            MatrixBridge = class MatrixBridge {
                constructor(appservice) {
                    this.appservice = appservice;
                }
                /**
                 * Gets information about a remote user.
                 * @param {Intent} userIntent The Matrix user intent to get information on.
                 * @returns {Promise<IRemoteUserInfo>} Resolves to the remote user information.
                 */
                getRemoteUserInfo(userIntent) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield userIntent.ensureRegistered();
                        return userIntent.underlyingClient.getAccountData(REMOTE_USER_INFO_ACCOUNT_DATA_EVENT_TYPE);
                    });
                }
                /**
                 * Sets information about a remote user. Calling this function will map the
                 * provided remote user ID to the intent's owner.
                 * @param {Intent} userIntent The Matrix user intent to store information on.
                 * @param {IRemoteUserInfo} remoteInfo The remote user information to store
                 * @returns {Promise<any>} Resolves when the information has been updated.
                 */
                setRemoteUserInfo(userIntent, remoteInfo) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield userIntent.ensureRegistered();
                        yield userIntent.underlyingClient.setAccountData(REMOTE_USER_INFO_ACCOUNT_DATA_EVENT_TYPE, remoteInfo);
                        yield this.updateRemoteUserMapping(userIntent.userId, remoteInfo.id);
                    });
                }
                /**
                 * Gets information about a remote room.
                 * @param {string} matrixRoomId The Matrix room ID to get information on.
                 * @returns {Promise<IRemoteRoomInfo>} Resolves to the remote room information.
                 */
                getRemoteRoomInfo(matrixRoomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const bridgeBot = this.appservice.botIntent;
                        yield bridgeBot.ensureRegistered();
                        // We do not need to ensure the user is joined to the room because we can associate
                        // room account data with any arbitrary room.
                        return bridgeBot.underlyingClient.getRoomAccountData(REMOTE_ROOM_INFO_ACCOUNT_DATA_EVENT_TYPE, matrixRoomId);
                    });
                }
                /**
                 * Sets information about a remote room. Calling this function will map the
                 * provided remote room ID to the matrix room ID.
                 * @param {string} matrixRoomId The Matrix room ID to store information on.
                 * @param {IRemoteRoomInfo} remoteInfo The remote room information to store
                 * @returns {Promise<any>} Resolves when the information has been updated.
                 */
                setRemoteRoomInfo(matrixRoomId, remoteInfo) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const bridgeBot = this.appservice.botIntent;
                        yield bridgeBot.ensureRegistered();
                        // We do not need to ensure the user is joined to the room because we can associate
                        // room account data with any arbitrary room.
                        yield bridgeBot.underlyingClient.setRoomAccountData(REMOTE_ROOM_INFO_ACCOUNT_DATA_EVENT_TYPE, matrixRoomId, remoteInfo);
                        yield this.updateRemoteRoomMapping(matrixRoomId, remoteInfo.id);
                    });
                }
                /**
                 * Gets the Matrix room ID for the provided remote room ID.
                 * @param {string} remoteRoomId The remote room ID to look up.
                 * @returns {Promise<string>} Resolves to the Matrix room ID.
                 */
                getMatrixRoomIdForRemote(remoteRoomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const eventType = `${REMOTE_ROOM_MAP_ACCOUNT_DATA_EVENT_TYPE_PREFIX}.${remoteRoomId}`;
                        const bridgeBot = this.appservice.botIntent;
                        yield bridgeBot.ensureRegistered();
                        const result = yield bridgeBot.underlyingClient.getAccountData(eventType);
                        return result['id'];
                    });
                }
                /**
                 * Gets a Matrix user intent for the provided remote user ID.
                 * @param {string} remoteUserId The remote user ID to look up.
                 * @returns {Promise<Intent>} Resolves to the Matrix user intent.
                 */
                getIntentForRemote(remoteUserId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const eventType = `${REMOTE_USER_MAP_ACCOUNT_DATA_EVENT_TYPE_PREFIX}.${remoteUserId}`;
                        const bridgeBot = this.appservice.botIntent;
                        yield bridgeBot.ensureRegistered();
                        const result = yield bridgeBot.underlyingClient.getAccountData(eventType);
                        return this.appservice.getIntentForUserId(result['id']);
                    });
                }
                updateRemoteUserMapping(matrixUserId, remoteUserId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const eventType = `${REMOTE_USER_MAP_ACCOUNT_DATA_EVENT_TYPE_PREFIX}.${remoteUserId}`;
                        const bridgeBot = this.appservice.botIntent;
                        yield bridgeBot.ensureRegistered();
                        yield bridgeBot.underlyingClient.setAccountData(eventType, { id: matrixUserId });
                    });
                }
                updateRemoteRoomMapping(matrixRoomId, remoteRoomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const eventType = `${REMOTE_ROOM_MAP_ACCOUNT_DATA_EVENT_TYPE_PREFIX}.${remoteRoomId}`;
                        const bridgeBot = this.appservice.botIntent;
                        yield bridgeBot.ensureRegistered();
                        yield bridgeBot.underlyingClient.setAccountData(eventType, { id: matrixRoomId });
                    });
                }
            };
            exports_31("MatrixBridge", MatrixBridge);
        }
    };
});
System.register("appservice/http_responses", [], function (exports_32, context_32) {
    "use strict";
    var __moduleName = context_32 && context_32.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("appservice/Appservice", ["express", "appservice/Intent", "index", "events", "morgan", "appservice/MatrixBridge", "lru-cache"], function (exports_33, context_33) {
    "use strict";
    var express, Intent_1, __4, events_1, morgan, MatrixBridge_1, LRU, Appservice;
    var __moduleName = context_33 && context_33.id;
    return {
        setters: [
            function (express_1) {
                express = express_1;
            },
            function (Intent_1_1) {
                Intent_1 = Intent_1_1;
            },
            function (__4_1) {
                __4 = __4_1;
            },
            function (events_1_1) {
                events_1 = events_1_1;
            },
            function (morgan_1) {
                morgan = morgan_1;
            },
            function (MatrixBridge_1_1) {
                MatrixBridge_1 = MatrixBridge_1_1;
            },
            function (LRU_1) {
                LRU = LRU_1;
            }
        ],
        execute: function () {
            /**
             * Represents an application service. This provides helper utilities such as tracking
             * of user intents (clients that are aware of their membership in rooms).
             * @category Application services
             */
            Appservice = class Appservice extends events_1.EventEmitter {
                /**
                 * Creates a new application service.
                 * @param {IAppserviceOptions} options The options for the application service.
                 */
                constructor(options) {
                    super();
                    this.options = options;
                    /**
                     * The metrics instance for this appservice. This will raise all metrics
                     * from this appservice instance as well as any intents/MatrixClients created
                     * by the appservice.
                     */
                    this.metrics = new __4.Metrics();
                    this.bridgeInstance = new MatrixBridge_1.MatrixBridge(this);
                    this.app = express();
                    this.eventProcessors = {};
                    this.pendingTransactions = {};
                    options.joinStrategy = new __4.AppserviceJoinRoomStrategy(options.joinStrategy, this);
                    if (!options.intentOptions)
                        options.intentOptions = {};
                    if (!options.intentOptions.maxAgeMs)
                        options.intentOptions.maxAgeMs = 60 * 60 * 1000;
                    if (!options.intentOptions.maxCached)
                        options.intentOptions.maxCached = 10000;
                    this.intentsCache = new LRU({
                        max: options.intentOptions.maxCached,
                        maxAge: options.intentOptions.maxAgeMs,
                    });
                    this.registration = options.registration;
                    // If protocol is not defined, define an empty array.
                    if (!this.registration.protocols) {
                        this.registration.protocols = [];
                    }
                    this.storage = options.storage || new __4.MemoryStorageProvider();
                    options.storage = this.storage;
                    this.cryptoStorage = options.cryptoStorage;
                    this.app.use(express.json({ limit: Number.MAX_SAFE_INTEGER })); // disable limits, use a reverse proxy
                    this.app.use(morgan("combined"));
                    // ETag headers break the tests sometimes, and we don't actually need them anyways for
                    // appservices - none of this should be cached.
                    this.app.set('etag', false);
                    this.app.get("/users/:userId", this.onUser.bind(this));
                    this.app.get("/rooms/:roomAlias", this.onRoomAlias.bind(this));
                    this.app.put("/transactions/:txnId", this.onTransaction.bind(this));
                    this.app.get("/_matrix/app/v1/users/:userId", this.onUser.bind(this));
                    this.app.get("/_matrix/app/v1/rooms/:roomAlias", this.onRoomAlias.bind(this));
                    this.app.put("/_matrix/app/v1/transactions/:txnId", this.onTransaction.bind(this));
                    this.app.get("/_matrix/app/v1/thirdparty/protocol/:protocol", this.onThirdpartyProtocol.bind(this));
                    this.app.get("/_matrix/app/v1/thirdparty/user/:protocol", this.onThirdpartyUser.bind(this));
                    this.app.get("/_matrix/app/v1/thirdparty/user", this.onThirdpartyUser.bind(this));
                    this.app.get("/_matrix/app/v1/thirdparty/location/:protocol", this.onThirdpartyLocation.bind(this));
                    this.app.get("/_matrix/app/v1/thirdparty/location", this.onThirdpartyLocation.bind(this));
                    // Everything else can 404
                    if (!this.registration.namespaces || !this.registration.namespaces.users || this.registration.namespaces.users.length === 0) {
                        throw new Error("No user namespaces in registration");
                    }
                    if (this.registration.namespaces.users.length !== 1) {
                        throw new Error("Too many user namespaces registered: expecting exactly one");
                    }
                    let userPrefix = (this.registration.namespaces.users[0].regex || "").split(":")[0];
                    if (!userPrefix.endsWith(".*") && !userPrefix.endsWith(".+")) {
                        this.userPrefix = null;
                    }
                    else {
                        this.userPrefix = userPrefix.substring(0, userPrefix.length - 2); // trim off the .* part
                    }
                    if (!this.registration.namespaces || !this.registration.namespaces.aliases || this.registration.namespaces.aliases.length === 0 || this.registration.namespaces.aliases.length !== 1) {
                        this.aliasPrefix = null;
                    }
                    else {
                        this.aliasPrefix = (this.registration.namespaces.aliases[0].regex || "").split(":")[0];
                        if (!this.aliasPrefix.endsWith(".*") && !this.aliasPrefix.endsWith(".+")) {
                            this.aliasPrefix = null;
                        }
                        else {
                            this.aliasPrefix = this.aliasPrefix.substring(0, this.aliasPrefix.length - 2); // trim off the .* part
                        }
                    }
                }
                /**
                 * Gets the express app instance which is serving requests. Not recommended for
                 * general usage, but may be used to append routes to the web server.
                 */
                get expressAppInstance() {
                    return this.app;
                }
                /**
                 * Gets the bridge-specific APIs for this application service.
                 */
                get bridge() {
                    return this.bridgeInstance;
                }
                /**
                 * Get the application service's "bot" user ID (the sender_localpart).
                 */
                get botUserId() {
                    return this.getUserId(this.registration.sender_localpart);
                }
                /**
                 * Get the application service's "bot" Intent (the sender_localpart).
                 * @returns {Intent} The intent for the application service itself.
                 */
                get botIntent() {
                    return this.getIntentForUserId(this.botUserId);
                }
                /**
                 * Get the application service's "bot" MatrixClient (the sender_localpart).
                 * Normally the botIntent should be used to ensure that the bot user is safely
                 * handled.
                 * @returns {MatrixClient} The client for the application service itself.
                 */
                get botClient() {
                    return this.botIntent.underlyingClient;
                }
                /**
                 * Starts the application service, opening the bind address to begin processing requests.
                 * @returns {Promise<void>} resolves when started
                 */
                begin() {
                    return new Promise((resolve, reject) => {
                        this.appServer = this.app.listen(this.options.port, this.options.bindAddress, () => resolve());
                    }).then(() => __awaiter(this, void 0, void 0, function* () {
                        var _a;
                        if ((_a = this.options.intentOptions) === null || _a === void 0 ? void 0 : _a.encryption) {
                            yield this.botIntent.enableEncryption();
                        }
                        else {
                            yield this.botIntent.ensureRegistered();
                        }
                    }));
                }
                /**
                 * Stops the application service, freeing the web server.
                 */
                stop() {
                    if (!this.appServer)
                        return;
                    this.appServer.close();
                }
                /**
                 * Gets an intent for a given localpart. The user ID will be formed with the domain name given
                 * in the constructor.
                 * @param localpart The localpart to get an Intent for.
                 * @returns {Intent} An Intent for the user.
                 */
                getIntent(localpart) {
                    return this.getIntentForUserId(this.getUserId(localpart));
                }
                /**
                 * Gets a full user ID for a given localpart. The user ID will be formed with the domain name given
                 * in the constructor.
                 * @param localpart The localpart to get a user ID for.
                 * @returns {string} The user's ID.
                 */
                getUserId(localpart) {
                    return `@${localpart}:${this.options.homeserverName}`;
                }
                /**
                 * Gets an Intent for a given user suffix. The prefix is automatically detected from the registration
                 * options.
                 * @param suffix The user's suffix
                 * @returns {Intent} An Intent for the user.
                 */
                getIntentForSuffix(suffix) {
                    return this.getIntentForUserId(this.getUserIdForSuffix(suffix));
                }
                /**
                 * Gets a full user ID for a given suffix. The prefix is automatically detected from the registration
                 * options.
                 * @param suffix The user's suffix
                 * @returns {string} The user's ID.
                 */
                getUserIdForSuffix(suffix) {
                    if (!this.userPrefix) {
                        throw new Error(`Cannot use getUserIdForSuffix, provided namespace did not include a valid suffix`);
                    }
                    return `${this.userPrefix}${suffix}:${this.options.homeserverName}`;
                }
                /**
                 * Gets an Intent for a given user ID.
                 * @param {string} userId The user ID to get an Intent for.
                 * @returns {Intent} An Intent for the user.
                 */
                getIntentForUserId(userId) {
                    let intent = this.intentsCache.get(userId);
                    if (!intent) {
                        intent = new Intent_1.Intent(this.options, userId, this);
                        this.intentsCache.set(userId, intent);
                        if (this.options.intentOptions.encryption) {
                            intent.enableEncryption().catch(e => {
                                __4.LogService.error("Appservice", `Failed to set up crypto on intent ${userId}`, e);
                                throw e; // re-throw to cause unhandled exception
                            });
                        }
                    }
                    return intent;
                }
                /**
                 * Gets the suffix for the provided user ID. If the user ID is not a namespaced
                 * user, this will return a falsey value.
                 * @param {string} userId The user ID to parse
                 * @returns {string} The suffix from the user ID.
                 */
                getSuffixForUserId(userId) {
                    if (!this.userPrefix) {
                        throw new Error(`Cannot use getUserIdForSuffix, provided namespace did not include a valid suffix`);
                    }
                    if (!userId || !userId.startsWith(this.userPrefix) || !userId.endsWith(`:${this.options.homeserverName}`)) {
                        // Invalid ID
                        return null;
                    }
                    return userId
                        .split('')
                        .slice(this.userPrefix.length)
                        .reverse()
                        .slice(this.options.homeserverName.length + 1)
                        .reverse()
                        .join('');
                }
                /**
                 * Determines if a given user ID is namespaced by this application service.
                 * @param {string} userId The user ID to check
                 * @returns {boolean} true if the user is namespaced, false otherwise
                 */
                isNamespacedUser(userId) {
                    var _a;
                    return userId === this.botUserId ||
                        !!((_a = this.registration.namespaces) === null || _a === void 0 ? void 0 : _a.users.find(({ regex }) => new RegExp(regex).test(userId)));
                }
                /**
                 * Gets a full alias for a given localpart. The alias will be formed with the domain name given
                 * in the constructor.
                 * @param localpart The localpart to get an alias for.
                 * @returns {string} The alias.
                 */
                getAlias(localpart) {
                    return `#${localpart}:${this.options.homeserverName}`;
                }
                /**
                 * Gets a full alias for a given suffix. The prefix is automatically detected from the registration
                 * options.
                 * @param suffix The alias's suffix
                 * @returns {string} The alias.
                 */
                getAliasForSuffix(suffix) {
                    if (!this.aliasPrefix) {
                        throw new Error("Invalid configured alias prefix");
                    }
                    return `${this.aliasPrefix}${suffix}:${this.options.homeserverName}`;
                }
                /**
                 * Gets the localpart of an alias for a given suffix. The prefix is automatically detected from the registration
                 * options. Useful for the createRoom endpoint.
                 * @param suffix The alias's suffix
                 * @returns {string} The alias localpart.
                 */
                getAliasLocalpartForSuffix(suffix) {
                    if (!this.aliasPrefix) {
                        throw new Error("Invalid configured alias prefix");
                    }
                    return `${this.aliasPrefix.substr(1)}${suffix}`;
                }
                /**
                 * Gets the suffix for the provided alias. If the alias is not a namespaced
                 * alias, this will return a falsey value.
                 * @param {string} alias The alias to parse
                 * @returns {string} The suffix from the alias.
                 */
                getSuffixForAlias(alias) {
                    if (!this.aliasPrefix) {
                        throw new Error("Invalid configured alias prefix");
                    }
                    if (!alias || !this.isNamespacedAlias(alias)) {
                        // Invalid ID
                        return null;
                    }
                    return alias
                        .split('')
                        .slice(this.aliasPrefix.length)
                        .reverse()
                        .slice(this.options.homeserverName.length + 1)
                        .reverse()
                        .join('');
                }
                /**
                 * Determines if a given alias is namespaced by this application service.
                 * @param {string} alias The alias to check
                 * @returns {boolean} true if the alias is namespaced, false otherwise
                 */
                isNamespacedAlias(alias) {
                    if (!this.aliasPrefix) {
                        throw new Error("Invalid configured alias prefix");
                    }
                    return alias.startsWith(this.aliasPrefix) && alias.endsWith(":" + this.options.homeserverName);
                }
                /**
                 * Adds a preprocessor to the event pipeline. When this appservice encounters an event, it
                 * will try to run it through the preprocessors it can in the order they were added.
                 * @param {IPreprocessor} preprocessor the preprocessor to add
                 */
                addPreprocessor(preprocessor) {
                    if (!preprocessor)
                        throw new Error("Preprocessor cannot be null");
                    const eventTypes = preprocessor.getSupportedEventTypes();
                    if (!eventTypes)
                        return; // Nothing to do
                    for (const eventType of eventTypes) {
                        if (!this.eventProcessors[eventType])
                            this.eventProcessors[eventType] = [];
                        this.eventProcessors[eventType].push(preprocessor);
                    }
                }
                /**
                 * Sets the visibility of a room in the appservice's room directory.
                 * @param {string} networkId The network ID to group the room under.
                 * @param {string} roomId The room ID to manipulate the visibility of.
                 * @param {"public" | "private"} visibility The visibility to set for the room.
                 * @return {Promise<any>} resolves when the visibility has been updated.
                 */
                setRoomDirectoryVisibility(networkId, roomId, visibility) {
                    roomId = encodeURIComponent(roomId);
                    networkId = encodeURIComponent(networkId);
                    return this.botClient.doRequest("PUT", `/_matrix/client/r0/directory/list/appservice/${networkId}/${roomId}`, null, {
                        visibility,
                    });
                }
                processEphemeralEvent(event) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (!event)
                            return event;
                        if (!this.eventProcessors[event["type"]])
                            return event;
                        for (const processor of this.eventProcessors[event["type"]]) {
                            yield processor.processEvent(event, this.botIntent.underlyingClient, __4.EventKind.EphemeralEvent);
                        }
                        return event;
                    });
                }
                processEvent(event) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (!event)
                            return event;
                        if (!this.eventProcessors[event["type"]])
                            return event;
                        for (const processor of this.eventProcessors[event["type"]]) {
                            yield processor.processEvent(event, this.botIntent.underlyingClient, __4.EventKind.RoomEvent);
                        }
                        return event;
                    });
                }
                processMembershipEvent(event) {
                    if (!event["content"])
                        return;
                    const targetMembership = event["content"]["membership"];
                    if (targetMembership === "join") {
                        this.emit("room.join", event["room_id"], event);
                    }
                    else if (targetMembership === "ban" || targetMembership === "leave") {
                        this.emit("room.leave", event["room_id"], event);
                    }
                    else if (targetMembership === "invite") {
                        this.emit("room.invite", event["room_id"], event);
                    }
                }
                isAuthed(req) {
                    let providedToken = req.query ? req.query["access_token"] : null;
                    if (req.headers && req.headers["Authorization"]) {
                        const authHeader = req.headers["Authorization"];
                        if (!authHeader.startsWith("Bearer "))
                            providedToken = null;
                        else
                            providedToken = authHeader.substring("Bearer ".length);
                    }
                    return providedToken === this.registration.hs_token;
                }
                onTransaction(req, res) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (!this.isAuthed(req)) {
                            res.status(401).json({ errcode: "AUTH_FAILED", error: "Authentication failed" });
                            return;
                        }
                        if (typeof (req.body) !== "object") {
                            res.status(400).json({ errcode: "BAD_REQUEST", error: "Expected JSON" });
                            return;
                        }
                        if (!req.body["events"] || !Array.isArray(req.body["events"])) {
                            res.status(400).json({ errcode: "BAD_REQUEST", error: "Invalid JSON: expected events" });
                            return;
                        }
                        const txnId = req.params["txnId"];
                        if (yield Promise.resolve(this.storage.isTransactionCompleted(txnId))) {
                            res.status(200).json({});
                            return;
                        }
                        if (this.pendingTransactions[txnId]) {
                            try {
                                yield this.pendingTransactions[txnId];
                                res.status(200).json({});
                            }
                            catch (e) {
                                __4.LogService.error("Appservice", e);
                                res.status(500).json({});
                            }
                            return;
                        }
                        __4.LogService.info("Appservice", "Processing transaction " + txnId);
                        this.pendingTransactions[txnId] = new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
                            var _a;
                            // Process EDUs first to give the best chance at decryption
                            if (Array.isArray(req.body["de.sorunome.msc2409.ephemeral"])) {
                                for (let event of req.body["de.sorunome.msc2409.ephemeral"]) {
                                    __4.LogService.info("Appservice", `Processing ephemeral event of type ${event["type"]}`);
                                    event = yield this.processEphemeralEvent(event);
                                    // These events aren't tied to rooms, so just emit them generically
                                    this.emit("ephemeral.event", event);
                                    if (event["type"] === "m.room.encrypted") {
                                        const toUser = event["to_user_id"];
                                        try {
                                            const intent = this.getIntentForUserId(toUser);
                                            yield intent.enableEncryption();
                                            yield ((_a = intent.underlyingClient.crypto) === null || _a === void 0 ? void 0 : _a.processInboundDeviceMessage(event));
                                        }
                                        catch (e) {
                                            __4.LogService.error("Appservice", `Error handling encrypted to-device message sent to ${toUser}`, e);
                                        }
                                    }
                                }
                            }
                            for (let event of req.body["events"]) {
                                __4.LogService.info("Appservice", `Processing event of type ${event["type"]}`);
                                event = yield this.processEvent(event);
                                if (event['type'] === 'm.room.encrypted' && this.cryptoStorage) {
                                    this.emit("room.encrypted_event", event["room_id"], event);
                                    try {
                                        const encrypted = new __4.EncryptedRoomEvent(event);
                                        const roomId = event['room_id'];
                                        try {
                                            event = (yield this.botClient.crypto.decryptRoomEvent(encrypted, roomId)).raw;
                                            event = yield this.processEvent(event);
                                            this.emit("room.decrypted_event", roomId, event);
                                            // For logging purposes: show that the event was decrypted
                                            __4.LogService.info("Appservice", `Processing decrypted event of type ${event["type"]}`);
                                        }
                                        catch (e1) {
                                            __4.LogService.warn("Appservice", `Bot client was not able to decrypt ${roomId} ${event['event_id']} - trying other intents`);
                                            // Try to figure out which clients might be able to decrypt this
                                            // TODO: Consider puppet bridges where the bot won't be in the room
                                            // See https://github.com/turt2live/matrix-bot-sdk/issues/161
                                            // noinspection ExceptionCaughtLocallyJS
                                            throw e1;
                                        }
                                    }
                                    catch (e) {
                                        __4.LogService.error("Appservice", `Decryption error on ${event['room_id']} ${event['event_id']}`, e);
                                        this.emit("room.failed_decryption", event['room_id'], event, e);
                                    }
                                }
                                this.emit("room.event", event["room_id"], event);
                                if (event['type'] === 'm.room.message') {
                                    this.emit("room.message", event["room_id"], event);
                                }
                                if (event['type'] === 'm.room.member' && this.isNamespacedUser(event['state_key'])) {
                                    this.processMembershipEvent(event);
                                }
                                if (event['type'] === 'm.room.tombstone' && event['state_key'] === '') {
                                    this.emit("room.archived", event['room_id'], event);
                                }
                                if (event['type'] === 'm.room.create' && event['state_key'] === '' && event['content'] && event['content']['predecessor']) {
                                    this.emit("room.upgraded", event['room_id'], event);
                                }
                            }
                            resolve();
                        }));
                        try {
                            yield this.pendingTransactions[txnId];
                            yield Promise.resolve(this.storage.setTransactionCompleted(txnId));
                            res.status(200).json({});
                        }
                        catch (e) {
                            __4.LogService.error("Appservice", e);
                            res.status(500).json({});
                        }
                    });
                }
                onUser(req, res) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (!this.isAuthed(req)) {
                            res.status(401).json({ errcode: "AUTH_FAILED", error: "Authentication failed" });
                            return;
                        }
                        const userId = req.params["userId"];
                        this.emit("query.user", userId, (result) => __awaiter(this, void 0, void 0, function* () {
                            if (result.then)
                                result = yield result;
                            if (result === false) {
                                res.status(404).json({ errcode: "USER_DOES_NOT_EXIST", error: "User not created" });
                            }
                            else {
                                const intent = this.getIntentForUserId(userId);
                                yield intent.ensureRegistered();
                                if (result.display_name)
                                    yield intent.underlyingClient.setDisplayName(result.display_name);
                                if (result.avatar_mxc)
                                    yield intent.underlyingClient.setAvatarUrl(result.avatar_mxc);
                                res.status(200).json(result); // return result for debugging + testing
                            }
                        }));
                    });
                }
                onRoomAlias(req, res) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (!this.isAuthed(req)) {
                            res.status(401).json({ errcode: "AUTH_FAILED", error: "Authentication failed" });
                            return;
                        }
                        const roomAlias = req.params["roomAlias"];
                        this.emit("query.room", roomAlias, (result) => __awaiter(this, void 0, void 0, function* () {
                            if (result.then)
                                result = yield result;
                            if (result === false) {
                                res.status(404).json({ errcode: "ROOM_DOES_NOT_EXIST", error: "Room not created" });
                            }
                            else {
                                const intent = this.botIntent;
                                yield intent.ensureRegistered();
                                result["room_alias_name"] = roomAlias.substring(1).split(':')[0];
                                result["__roomId"] = yield intent.underlyingClient.createRoom(result);
                                res.status(200).json(result); // return result for debugging + testing
                            }
                        }));
                    });
                }
                onThirdpartyProtocol(req, res) {
                    if (!this.isAuthed(req)) {
                        res.status(401).json({ errcode: "AUTH_FAILED", error: "Authentication failed" });
                        return;
                    }
                    const protocol = req.params["protocol"];
                    if (!this.registration.protocols.includes(protocol)) {
                        res.status(404).json({
                            errcode: "PROTOCOL_NOT_HANDLED",
                            error: "Protocol is not handled by this appservice"
                        });
                        return;
                    }
                    this.emit("thirdparty.protocol", protocol, (protocolResponse) => {
                        res.status(200).json(protocolResponse);
                    });
                }
                handleThirdpartyObject(req, res, objType, matrixId) {
                    if (!this.isAuthed(req)) {
                        res.status(401).json({ errcode: "AUTH_FAILED", error: "Authentication failed" });
                        return;
                    }
                    const protocol = req.params["protocol"];
                    const responseFunc = (items) => {
                        if (items && items.length > 0) {
                            res.status(200).json(items);
                            return;
                        }
                        res.status(404).json({
                            errcode: "NO_MAPPING_FOUND",
                            error: "No mappings found"
                        });
                    };
                    // Lookup remote objects(s)
                    if (protocol) { // If protocol is given, we are looking up a objects based on fields
                        if (!this.registration.protocols.includes(protocol)) {
                            res.status(404).json({
                                errcode: "PROTOCOL_NOT_HANDLED",
                                error: "Protocol is not handled by this appservice"
                            });
                            return;
                        }
                        // Remove the access_token
                        delete req.query.access_token;
                        this.emit(`thirdparty.${objType}.remote`, protocol, req.query, responseFunc);
                        return;
                    }
                    else if (matrixId) { // If a user ID is given, we are looking up a remote objects based on a id
                        this.emit(`thirdparty.${objType}.matrix`, matrixId, responseFunc);
                        return;
                    }
                    res.status(400).json({
                        errcode: "INVALID_PARAMETERS",
                        error: "Invalid parameters given"
                    });
                }
                onThirdpartyUser(req, res) {
                    return this.handleThirdpartyObject(req, res, "user", req.query["userid"]);
                }
                onThirdpartyLocation(req, res) {
                    return this.handleThirdpartyObject(req, res, "location", req.query["alias"]);
                }
            };
            exports_33("Appservice", Appservice);
        }
    };
});
System.register("e2ee/RoomTracker", [], function (exports_34, context_34) {
    "use strict";
    var RoomTracker;
    var __moduleName = context_34 && context_34.id;
    return {
        setters: [],
        execute: function () {
            // noinspection ES6RedundantAwait
            /**
             * Tracks room encryption status for a MatrixClient.
             * @category Encryption
             */
            RoomTracker = class RoomTracker {
                constructor(client) {
                    this.client = client;
                    this.client.on("room.join", (roomId) => {
                        // noinspection JSIgnoredPromiseFromCall
                        this.queueRoomCheck(roomId);
                    });
                    this.client.on("room.event", (roomId, event) => {
                        if (event['type'] === 'm.room.encryption' && event['state_key'] === '') {
                            // noinspection JSIgnoredPromiseFromCall
                            this.queueRoomCheck(roomId);
                        }
                    });
                }
                /**
                 * Prepares the room tracker to track the given rooms.
                 * @param {string[]} roomIds The room IDs to track. This should be the joined rooms set.
                 */
                prepare(roomIds) {
                    return __awaiter(this, void 0, void 0, function* () {
                        for (const roomId of roomIds) {
                            yield this.queueRoomCheck(roomId);
                        }
                    });
                }
                /**
                 * Queues a room check for the tracker. If the room needs an update to the store, an
                 * update will be made.
                 * @param {string} roomId The room ID to check.
                 */
                queueRoomCheck(roomId) {
                    var _a;
                    return __awaiter(this, void 0, void 0, function* () {
                        const config = yield this.client.cryptoStore.getRoom(roomId);
                        if (config) {
                            if (config.algorithm !== undefined) {
                                return; // assume no change to encryption config
                            }
                        }
                        let encEvent;
                        try {
                            encEvent = yield this.client.getRoomStateEvent(roomId, "m.room.encryption", "");
                            encEvent.algorithm = (_a = encEvent.algorithm) !== null && _a !== void 0 ? _a : 'UNKNOWN';
                        }
                        catch (e) {
                            return; // failure == no encryption
                        }
                        yield this.client.cryptoStore.storeRoom(roomId, encEvent);
                    });
                }
                /**
                 * Gets the room's crypto configuration, as known by the underlying store. If the room is
                 * not encrypted then this will return an empty object.
                 * @param {string} roomId The room ID to get the config for.
                 * @returns {Promise<Partial<EncryptionEventContent>>} Resolves to the encryption config.
                 */
                getRoomCryptoConfig(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        let config = yield this.client.cryptoStore.getRoom(roomId);
                        if (!config) {
                            yield this.queueRoomCheck(roomId);
                            config = yield this.client.cryptoStore.getRoom(roomId);
                        }
                        if (!config) {
                            return {};
                        }
                        return config;
                    });
                }
            };
            exports_34("RoomTracker", RoomTracker);
        }
    };
});
System.register("e2ee/decorators", [], function (exports_35, context_35) {
    "use strict";
    var __moduleName = context_35 && context_35.id;
    /**
     * Flags a MatrixClient function as needing end-to-end encryption enabled.
     * @category Encryption
     */
    function requiresCrypto() {
        return function (target, propertyKey, descriptor) {
            const originalMethod = descriptor.value;
            descriptor.value = function (...args) {
                const client = this;
                if (!client.crypto) {
                    throw new Error("End-to-end encryption is not enabled");
                }
                return originalMethod.apply(this, args);
            };
        };
    }
    exports_35("requiresCrypto", requiresCrypto);
    /**
     * Flags a CryptoClient function as needing the CryptoClient to be ready.
     * @category Encryption
     */
    function requiresReady() {
        return function (target, propertyKey, descriptor) {
            const originalMethod = descriptor.value;
            descriptor.value = function (...args) {
                const crypto = this;
                if (!crypto.isReady) {
                    throw new Error("End-to-end encryption has not initialized");
                }
                return originalMethod.apply(this, args);
            };
        };
    }
    exports_35("requiresReady", requiresReady);
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("e2ee/DeviceTracker", ["logging/LogService", "models/Crypto"], function (exports_36, context_36) {
    "use strict";
    var LogService_2, Crypto_1, DeviceTracker;
    var __moduleName = context_36 && context_36.id;
    return {
        setters: [
            function (LogService_2_1) {
                LogService_2 = LogService_2_1;
            },
            function (Crypto_1_1) {
                Crypto_1 = Crypto_1_1;
            }
        ],
        execute: function () {
            /**
             * Tracks user devices for encryption operations.
             * @category Encryption
             */
            DeviceTracker = class DeviceTracker {
                constructor(client) {
                    this.client = client;
                    this.deviceListUpdates = {};
                }
                /**
                 * Gets the device lists for the given user IDs. Outdated device lists will be updated before
                 * returning.
                 * @param {string[]} userIds The user IDs to get the device lists of.
                 * @returns {Promise<Record<string, UserDevice[]>>} Resolves to a map of user ID to device list.
                 * If a user has no devices, they may be excluded from the result or appear as an empty array.
                 */
                getDevicesFor(userIds) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const outdatedUserIds = [];
                        for (const userId of userIds) {
                            const isOutdated = yield this.client.cryptoStore.isUserOutdated(userId);
                            if (isOutdated)
                                outdatedUserIds.push(userId);
                        }
                        yield this.updateUsersDeviceLists(outdatedUserIds);
                        const userDeviceMap = {};
                        for (const userId of userIds) {
                            userDeviceMap[userId] = yield this.client.cryptoStore.getActiveUserDevices(userId);
                        }
                        return userDeviceMap;
                    });
                }
                /**
                 * Flags multiple user's device lists as outdated, optionally queuing an immediate update.
                 * @param {string} userIds The user IDs to flag the device lists of.
                 * @param {boolean} resync True (default) to queue an immediate update, false otherwise.
                 * @returns {Promise<void>} Resolves when the flagging has completed. Will wait for the resync
                 * if requested too.
                 */
                flagUsersOutdated(userIds, resync = true) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.client.cryptoStore.flagUsersOutdated(userIds);
                        if (resync) {
                            yield this.updateUsersDeviceLists(userIds);
                        }
                    });
                }
                /**
                 * Updates multiple user's device lists regardless of outdated flag.
                 * @param {string[]} userIds The user IDs to update.
                 * @returns {Promise<void>} Resolves when complete.
                 */
                updateUsersDeviceLists(userIds) {
                    return __awaiter(this, void 0, void 0, function* () {
                        // We wait for the lock, but still run through with our update just in case we are lagged.
                        // This can happen if the server is slow to reply to device list queries, but a user is
                        // changing information about their device a lot.
                        const existingPromises = userIds.map(u => this.deviceListUpdates[u]).filter(p => !!p);
                        if (existingPromises.length > 0) {
                            yield Promise.all(existingPromises);
                        }
                        const promise = new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
                            var _a, _b;
                            try {
                                const resp = yield this.client.getUserDevices(userIds);
                                for (const userId of Object.keys(resp.device_keys)) {
                                    if (!userIds.includes(userId)) {
                                        LogService_2.LogService.warn("DeviceTracker", `Server returned unexpected user ID: ${userId} - ignoring user`);
                                        continue;
                                    }
                                    const validated = [];
                                    for (const deviceId of Object.keys(resp.device_keys[userId])) {
                                        const device = resp.device_keys[userId][deviceId];
                                        if (device.user_id !== userId || device.device_id !== deviceId) {
                                            LogService_2.LogService.warn("DeviceTracker", `Server appears to be lying about device lists: ${userId} ${deviceId} has unexpected device ${device.user_id} ${device.device_id} listed - ignoring device`);
                                            continue;
                                        }
                                        const ed25519 = device.keys[`${Crypto_1.DeviceKeyAlgorithm.Ed25519}:${deviceId}`];
                                        const curve25519 = device.keys[`${Crypto_1.DeviceKeyAlgorithm.Curve25519}:${deviceId}`];
                                        if (!ed25519 || !curve25519) {
                                            LogService_2.LogService.warn("DeviceTracker", `Device ${userId} ${deviceId} is missing either an Ed25519 or Curve25519 key - ignoring device`);
                                            continue;
                                        }
                                        const currentDevices = yield this.client.cryptoStore.getAllUserDevices(userId);
                                        const existingDevice = currentDevices.find(d => d.device_id === deviceId);
                                        if (existingDevice) {
                                            const existingEd25519 = existingDevice.keys[`${Crypto_1.DeviceKeyAlgorithm.Ed25519}:${deviceId}`];
                                            if (existingEd25519 !== ed25519) {
                                                LogService_2.LogService.warn("DeviceTracker", `Device ${userId} ${deviceId} appears compromised: Ed25519 key changed - ignoring device`);
                                                continue;
                                            }
                                        }
                                        const signature = (_b = (_a = device.signatures) === null || _a === void 0 ? void 0 : _a[userId]) === null || _b === void 0 ? void 0 : _b[`${Crypto_1.DeviceKeyAlgorithm.Ed25519}:${deviceId}`];
                                        if (!signature) {
                                            LogService_2.LogService.warn("DeviceTracker", `Device ${userId} ${deviceId} is missing a signature - ignoring device`);
                                            continue;
                                        }
                                        const validSignature = yield this.client.crypto.verifySignature(device, ed25519, signature);
                                        if (!validSignature) {
                                            LogService_2.LogService.warn("DeviceTracker", `Device ${userId} ${deviceId} has an invalid signature - ignoring device`);
                                            continue;
                                        }
                                        validated.push(device);
                                    }
                                    yield this.client.cryptoStore.setActiveUserDevices(userId, validated);
                                }
                            }
                            catch (e) {
                                LogService_2.LogService.error("DeviceTracker", "Error updating device lists:", e);
                                // return reject(e);
                            }
                            resolve();
                        }));
                        userIds.forEach(u => this.deviceListUpdates[u] = promise);
                        yield promise;
                    });
                }
            };
            exports_36("DeviceTracker", DeviceTracker);
        }
    };
});
System.register("models/events/EncryptedRoomEvent", ["models/events/RoomEvent"], function (exports_37, context_37) {
    "use strict";
    var RoomEvent_2, EncryptedRoomEvent;
    var __moduleName = context_37 && context_37.id;
    return {
        setters: [
            function (RoomEvent_2_1) {
                RoomEvent_2 = RoomEvent_2_1;
            }
        ],
        execute: function () {
            /**
             * Represents an m.room.encrypted room event
             * @category Matrix events
             */
            EncryptedRoomEvent = class EncryptedRoomEvent extends RoomEvent_2.RoomEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The encryption algorithm used on the event. Should match the m.room.encryption
                 * state config.
                 */
                get algorithm() {
                    return this.content.algorithm;
                }
                /**
                 * The Megolm encrypted payload information.
                 */
                get megolmProperties() {
                    return this.content;
                }
            };
            exports_37("EncryptedRoomEvent", EncryptedRoomEvent);
        }
    };
});
System.register("models/events/InvalidEventError", [], function (exports_38, context_38) {
    "use strict";
    var InvalidEventError, EventRedactedError;
    var __moduleName = context_38 && context_38.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Thrown when an event is invalid.
             * @category Matrix events
             */
            InvalidEventError = class InvalidEventError extends Error {
                constructor(message = null) {
                    super(message);
                }
            };
            exports_38("InvalidEventError", InvalidEventError);
            /**
             * Thrown when an event is redacted.
             * @category Matrix events
             */
            EventRedactedError = class EventRedactedError extends InvalidEventError {
                constructor(message = null) {
                    super(message);
                }
            };
            exports_38("EventRedactedError", EventRedactedError);
        }
    };
});
System.register("models/events/MessageEvent", ["models/events/RoomEvent", "models/events/InvalidEventError"], function (exports_39, context_39) {
    "use strict";
    var RoomEvent_3, InvalidEventError_1, MessageEvent;
    var __moduleName = context_39 && context_39.id;
    return {
        setters: [
            function (RoomEvent_3_1) {
                RoomEvent_3 = RoomEvent_3_1;
            },
            function (InvalidEventError_1_1) {
                InvalidEventError_1 = InvalidEventError_1_1;
            }
        ],
        execute: function () {
            /**
             * Represents an m.room.message room event
             * @category Matrix events
             */
            MessageEvent = class MessageEvent extends RoomEvent_3.RoomEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * Whether or not the event is redacted (or looked redacted).
                 */
                get isRedacted() {
                    // Presume the event redacted if we're missing a body or message type
                    const noContent = !this.content.body && this.content.body !== "";
                    const noMsgtype = !this.content.msgtype && this.content.msgtype !== "";
                    return noContent || noMsgtype;
                }
                /**
                 * The message's type.
                 */
                get messageType() {
                    const type = this.content.msgtype;
                    if (!type && type !== "")
                        throw new InvalidEventError_1.EventRedactedError("missing msgtype");
                    return type;
                }
                /**
                 * The `body` of the message.
                 */
                get textBody() {
                    const body = this.content.body;
                    if (!body && body !== "")
                        throw new InvalidEventError_1.EventRedactedError("missing body");
                    return body;
                }
                /**
                 * The `external_url` of the message, if it exists
                 */
                get externalUrl() {
                    return this.content.external_url || undefined;
                }
            };
            exports_39("MessageEvent", MessageEvent);
        }
    };
});
System.register("b64", [], function (exports_40, context_40) {
    "use strict";
    var __moduleName = context_40 && context_40.id;
    /**
     * Encodes Base64.
     * @category Utilities
     * @param {ArrayBuffer | Uint8Array} b The buffer to encode.
     * @returns {string} The Base64 string.
     */
    function encodeBase64(b) {
        return Buffer.from(b).toString('base64');
    }
    exports_40("encodeBase64", encodeBase64);
    /**
     * Encodes Unpadded Base64.
     * @category Utilities
     * @param {ArrayBuffer | Uint8Array} b The buffer to encode.
     * @returns {string} The Base64 string.
     */
    function encodeUnpaddedBase64(b) {
        return encodeBase64(b).replace(/=+/g, '');
    }
    exports_40("encodeUnpaddedBase64", encodeUnpaddedBase64);
    /**
     * Encodes URL-Safe Unpadded Base64.
     * @category Utilities
     * @param {ArrayBuffer | Uint8Array} b The buffer to encode.
     * @returns {string} The Base64 string.
     */
    function encodeUnpaddedUrlSafeBase64(b) {
        return encodeUnpaddedBase64(b).replace(/\+/g, '-').replace(/\//g, '_');
    }
    exports_40("encodeUnpaddedUrlSafeBase64", encodeUnpaddedUrlSafeBase64);
    /**
     * Decodes Base64.
     * @category Utilities
     * @param {string} s The Base64 string.
     * @returns {Uint8Array} The encoded data as a buffer.
     */
    function decodeBase64(s) {
        return Buffer.from(s, 'base64');
    }
    exports_40("decodeBase64", decodeBase64);
    /**
     * Decodes Unpadded Base64.
     * @category Utilities
     * @param {string} s The Base64 string.
     * @returns {Uint8Array} The encoded data as a buffer.
     */
    function decodeUnpaddedBase64(s) {
        return decodeBase64(s); // yay, it's the same
    }
    exports_40("decodeUnpaddedBase64", decodeUnpaddedBase64);
    /**
     * Decodes URL-Safe Unpadded Base64.
     * @category Utilities
     * @param {string} s The Base64 string.
     * @returns {Uint8Array} The encoded data as a buffer.
     */
    function decodeUnpaddedUrlSafeBase64(s) {
        return decodeUnpaddedBase64(s.replace(/-/g, '+').replace(/_/g, '/'));
    }
    exports_40("decodeUnpaddedUrlSafeBase64", decodeUnpaddedUrlSafeBase64);
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("e2ee/CryptoClient", ["logging/LogService", "@matrix-org/olm", "crypto", "another-json", "models/Crypto", "e2ee/decorators", "e2ee/RoomTracker", "e2ee/DeviceTracker", "models/events/EncryptionEvent", "models/events/EncryptedRoomEvent", "models/events/RoomEvent", "b64", "stream"], function (exports_41, context_41) {
    "use strict";
    var LogService_3, Olm, crypto, anotherJson, Crypto_2, decorators_3, RoomTracker_1, DeviceTracker_1, EncryptionEvent_1, EncryptedRoomEvent_1, RoomEvent_4, b64_1, stream_1, CryptoClient;
    var __moduleName = context_41 && context_41.id;
    return {
        setters: [
            function (LogService_3_1) {
                LogService_3 = LogService_3_1;
            },
            function (Olm_1) {
                Olm = Olm_1;
            },
            function (crypto_2) {
                crypto = crypto_2;
            },
            function (anotherJson_1) {
                anotherJson = anotherJson_1;
            },
            function (Crypto_2_1) {
                Crypto_2 = Crypto_2_1;
            },
            function (decorators_3_1) {
                decorators_3 = decorators_3_1;
            },
            function (RoomTracker_1_1) {
                RoomTracker_1 = RoomTracker_1_1;
            },
            function (DeviceTracker_1_1) {
                DeviceTracker_1 = DeviceTracker_1_1;
            },
            function (EncryptionEvent_1_1) {
                EncryptionEvent_1 = EncryptionEvent_1_1;
            },
            function (EncryptedRoomEvent_1_1) {
                EncryptedRoomEvent_1 = EncryptedRoomEvent_1_1;
            },
            function (RoomEvent_4_1) {
                RoomEvent_4 = RoomEvent_4_1;
            },
            function (b64_1_1) {
                b64_1 = b64_1_1;
            },
            function (stream_1_1) {
                stream_1 = stream_1_1;
            }
        ],
        execute: function () {
            /**
             * Manages encryption for a MatrixClient. Get an instance from a MatrixClient directly
             * rather than creating one manually.
             * @category Encryption
             */
            CryptoClient = class CryptoClient {
                constructor(client) {
                    this.client = client;
                    this.ready = false;
                    this.roomTracker = new RoomTracker_1.RoomTracker(this.client);
                    this.deviceTracker = new DeviceTracker_1.DeviceTracker(this.client);
                }
                /**
                 * The device ID for the MatrixClient.
                 */
                get clientDeviceId() {
                    return this.deviceId;
                }
                /**
                 * Whether or not the crypto client is ready to be used. If not ready, prepare() should be called.
                 * @see prepare
                 */
                get isReady() {
                    return this.ready;
                }
                getOlmAccount() {
                    return __awaiter(this, void 0, void 0, function* () {
                        const account = new Olm.Account();
                        account.unpickle(this.pickleKey, yield this.client.cryptoStore.getPickledAccount());
                        return account;
                    });
                }
                storeAndFreeOlmAccount(account) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const pickled = account.pickle(this.pickleKey);
                        yield this.client.cryptoStore.setPickledAccount(pickled);
                        account.free();
                    });
                }
                /**
                 * Prepares the crypto client for usage.
                 * @param {string[]} roomIds The room IDs the MatrixClient is joined to.
                 */
                prepare(roomIds) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.roomTracker.prepare(roomIds);
                        const storedDeviceId = yield this.client.cryptoStore.getDeviceId();
                        if (storedDeviceId) {
                            this.deviceId = storedDeviceId;
                        }
                        else {
                            const deviceId = (yield this.client.getWhoAmI())['device_id'];
                            if (!deviceId) {
                                throw new Error("Encryption not possible: server not revealing device ID");
                            }
                            this.deviceId = deviceId;
                            yield this.client.cryptoStore.setDeviceId(this.deviceId);
                        }
                        LogService_3.LogService.debug("CryptoClient", "Starting with device ID:", this.deviceId);
                        // We should be in a ready enough shape to kick off Olm
                        yield Olm.init();
                        let pickled = yield this.client.cryptoStore.getPickledAccount();
                        let pickleKey = yield this.client.cryptoStore.getPickleKey();
                        const account = new Olm.Account();
                        const makeReady = () => {
                            const keys = JSON.parse(account.identity_keys());
                            this.deviceCurve25519 = keys['curve25519'];
                            this.deviceEd25519 = keys['ed25519'];
                            this.pickleKey = pickleKey;
                            this.maxOTKs = account.max_number_of_one_time_keys();
                            this.ready = true;
                        };
                        try {
                            if (!pickled || !pickleKey) {
                                LogService_3.LogService.debug("CryptoClient", "Creating new Olm account: previous session lost or not set up");
                                const hasPickleKey = !!pickleKey;
                                account.create();
                                pickleKey = pickleKey !== null && pickleKey !== void 0 ? pickleKey : crypto.randomBytes(64).toString('hex');
                                pickled = account.pickle(pickleKey);
                                if (!hasPickleKey)
                                    yield this.client.cryptoStore.setPickleKey(pickleKey);
                                yield this.client.cryptoStore.setPickledAccount(pickled);
                                makeReady();
                                const counts = yield this.client.uploadDeviceKeys([
                                    Crypto_2.EncryptionAlgorithm.MegolmV1AesSha2,
                                    Crypto_2.EncryptionAlgorithm.OlmV1Curve25519AesSha2,
                                ], {
                                    [`${Crypto_2.DeviceKeyAlgorithm.Ed25519}:${this.deviceId}`]: this.deviceEd25519,
                                    [`${Crypto_2.DeviceKeyAlgorithm.Curve25519}:${this.deviceId}`]: this.deviceCurve25519,
                                });
                                yield this.updateCounts(counts);
                            }
                            else {
                                account.unpickle(pickleKey, pickled);
                                makeReady();
                                yield this.updateCounts(yield this.client.checkOneTimeKeyCounts());
                            }
                        }
                        finally {
                            account.free();
                        }
                    });
                }
                /**
                 * Checks if a room is encrypted.
                 * @param {string} roomId The room ID to check.
                 * @returns {Promise<boolean>} Resolves to true if encrypted, false otherwise.
                 */
                isRoomEncrypted(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const config = yield this.roomTracker.getRoomCryptoConfig(roomId);
                        return !!(config === null || config === void 0 ? void 0 : config.algorithm);
                    });
                }
                /**
                 * Updates the One Time Key counts, potentially triggering an async upload of more
                 * one time keys.
                 * @param {OTKCounts} counts The current counts to work within.
                 * @returns {Promise<void>} Resolves when complete.
                 */
                updateCounts(counts) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const have = counts[Crypto_2.OTKAlgorithm.Signed] || 0;
                        const need = Math.floor(this.maxOTKs / 2) - have;
                        if (need <= 0)
                            return;
                        LogService_3.LogService.debug("CryptoClient", `Creating ${need} more OTKs`);
                        const account = yield this.getOlmAccount();
                        try {
                            account.generate_one_time_keys(need);
                            const { curve25519: keys } = JSON.parse(account.one_time_keys());
                            const signed = {};
                            for (const keyId in keys) {
                                if (!keys.hasOwnProperty(keyId))
                                    continue;
                                const obj = { key: keys[keyId] };
                                obj['signatures'] = yield this.sign(obj);
                                signed[`${Crypto_2.OTKAlgorithm.Signed}:${keyId}`] = obj;
                            }
                            yield this.client.uploadDeviceOneTimeKeys(signed);
                            account.mark_keys_as_published();
                        }
                        finally {
                            yield this.storeAndFreeOlmAccount(account);
                        }
                    });
                }
                /**
                 * Updates the client's fallback key.
                 * @returns {Promise<void>} Resolves when complete.
                 */
                updateFallbackKey() {
                    return __awaiter(this, void 0, void 0, function* () {
                        const account = yield this.getOlmAccount();
                        try {
                            account.generate_fallback_key();
                            const key = JSON.parse(account.fallback_key());
                            const keyId = Object.keys(key[Crypto_2.OTKAlgorithm.Unsigned])[0];
                            const obj = {
                                key: key[Crypto_2.OTKAlgorithm.Unsigned][keyId],
                                fallback: true,
                            };
                            const signatures = yield this.sign(obj);
                            const fallback = {
                                keyId: keyId,
                                key: Object.assign(Object.assign({}, obj), { signatures: signatures }),
                            };
                            yield this.client.uploadFallbackKey(fallback);
                        }
                        finally {
                            yield this.storeAndFreeOlmAccount(account);
                        }
                    });
                }
                /**
                 * Signs an object using the device keys.
                 * @param {object} obj The object to sign.
                 * @returns {Promise<Signatures>} The signatures for the object.
                 */
                sign(obj) {
                    return __awaiter(this, void 0, void 0, function* () {
                        obj = JSON.parse(JSON.stringify(obj));
                        const existingSignatures = obj['signatures'] || {};
                        delete obj['signatures'];
                        delete obj['unsigned'];
                        const account = yield this.getOlmAccount();
                        try {
                            const sig = account.sign(anotherJson.stringify(obj));
                            return Object.assign({ [yield this.client.getUserId()]: {
                                    [`${Crypto_2.DeviceKeyAlgorithm.Ed25519}:${this.deviceId}`]: sig,
                                } }, existingSignatures);
                        }
                        finally {
                            account.free();
                        }
                    });
                }
                /**
                 * Verifies a signature on an object.
                 * @param {object} obj The signed object.
                 * @param {string} key The key which has supposedly signed the object.
                 * @param {string} signature The advertised signature.
                 * @returns {Promise<boolean>} Resolves to true if a valid signature, false otherwise.
                 */
                verifySignature(obj, key, signature) {
                    return __awaiter(this, void 0, void 0, function* () {
                        obj = JSON.parse(JSON.stringify(obj));
                        delete obj['signatures'];
                        delete obj['unsigned'];
                        const util = new Olm.Utility();
                        try {
                            const message = anotherJson.stringify(obj);
                            util.ed25519_verify(key, message, signature);
                        }
                        catch (e) {
                            // Assume it's a verification failure
                            return false;
                        }
                        finally {
                            util.free();
                        }
                        return true;
                    });
                }
                /**
                 * Flags multiple user's device lists as outdated, optionally queuing an immediate update.
                 * @param {string} userIds The user IDs to flag the device lists of.
                 * @param {boolean} resync True (default) to queue an immediate update, false otherwise.
                 * @returns {Promise<void>} Resolves when the device lists have been flagged. Will also wait
                 * for the resync if one was requested.
                 */
                flagUsersDeviceListsOutdated(userIds, resync = true) {
                    return this.deviceTracker.flagUsersOutdated(userIds, resync);
                }
                /**
                 * Gets or creates Olm sessions for the given users and devices. Where sessions cannot be created,
                 * the user/device will be excluded from the returned map.
                 * @param {Record<string, string[]>} userDeviceMap Map of user IDs to device IDs
                 * @param {boolean} force If true, force creation of a session for the referenced users.
                 * @returns {Promise<Record<string, Record<string, IOlmSession>>>} Resolves to a map of user ID to device
                 * ID to session. Users/devices which cannot have sessions made will not be included, thus the object
                 * may be empty.
                 */
                getOrCreateOlmSessions(userDeviceMap, force = false) {
                    var _a, _b;
                    return __awaiter(this, void 0, void 0, function* () {
                        const otkClaimRequest = {};
                        const userDeviceSessionIds = {};
                        const myUserId = yield this.client.getUserId();
                        const myDeviceId = this.clientDeviceId;
                        for (const userId of Object.keys(userDeviceMap)) {
                            for (const deviceId of userDeviceMap[userId]) {
                                if (userId === myUserId && deviceId === myDeviceId) {
                                    // Skip creating a session for our own device
                                    continue;
                                }
                                const existingSession = force ? null : (yield this.client.cryptoStore.getCurrentOlmSession(userId, deviceId));
                                if (existingSession) {
                                    if (!userDeviceSessionIds[userId])
                                        userDeviceSessionIds[userId] = {};
                                    userDeviceSessionIds[userId][deviceId] = existingSession;
                                }
                                else {
                                    if (!otkClaimRequest[userId])
                                        otkClaimRequest[userId] = {};
                                    otkClaimRequest[userId][deviceId] = Crypto_2.OTKAlgorithm.Signed;
                                }
                            }
                        }
                        if (Object.keys(otkClaimRequest).length > 0) {
                            const claimed = yield this.client.claimOneTimeKeys(otkClaimRequest);
                            for (const userId of Object.keys(claimed.one_time_keys)) {
                                if (!otkClaimRequest[userId]) {
                                    LogService_3.LogService.warn("CryptoClient", `Server injected unexpected user: ${userId} - not claiming keys`);
                                    continue;
                                }
                                const storedDevices = yield this.client.cryptoStore.getActiveUserDevices(userId);
                                for (const deviceId of Object.keys(claimed.one_time_keys[userId])) {
                                    try {
                                        if (!otkClaimRequest[userId][deviceId]) {
                                            LogService_3.LogService.warn("CryptoClient", `Server provided an unexpected device in claim response (skipping): ${userId} ${deviceId}`);
                                            continue;
                                        }
                                        const device = storedDevices.find(d => d.user_id === userId && d.device_id === deviceId);
                                        if (!device) {
                                            LogService_3.LogService.warn("CryptoClient", `Failed to handle claimed OTK: unable to locate stored device for user: ${userId} ${deviceId}`);
                                            continue;
                                        }
                                        const deviceKeyLabel = `${Crypto_2.DeviceKeyAlgorithm.Ed25519}:${deviceId}`;
                                        const keyId = Object.keys(claimed.one_time_keys[userId][deviceId])[0];
                                        const signedKey = claimed.one_time_keys[userId][deviceId][keyId];
                                        const signature = (_b = (_a = signedKey === null || signedKey === void 0 ? void 0 : signedKey.signatures) === null || _a === void 0 ? void 0 : _a[userId]) === null || _b === void 0 ? void 0 : _b[deviceKeyLabel];
                                        if (!signature) {
                                            LogService_3.LogService.warn("CryptoClient", `Failed to find appropriate signature for claimed OTK ${userId} ${deviceId}`);
                                            continue;
                                        }
                                        const verified = yield this.verifySignature(signedKey, device.keys[deviceKeyLabel], signature);
                                        if (!verified) {
                                            LogService_3.LogService.warn("CryptoClient", `Invalid signature for claimed OTK ${userId} ${deviceId}`);
                                            continue;
                                        }
                                        // TODO: Handle spec rate limiting
                                        // Clients should rate-limit the number of sessions it creates per device that it receives a message
                                        // from. Clients should not create a new session with another device if it has already created one
                                        // for that given device in the past 1 hour.
                                        // Finally, we can create a session. We do this on each loop just in case something goes wrong given
                                        // we don't have app-level transaction support here. We want to persist as many outbound sessions as
                                        // we can before exploding.
                                        const account = yield this.getOlmAccount();
                                        const session = new Olm.Session();
                                        try {
                                            const curveDeviceKey = device.keys[`${Crypto_2.DeviceKeyAlgorithm.Curve25519}:${deviceId}`];
                                            session.create_outbound(account, curveDeviceKey, signedKey.key);
                                            const storedSession = {
                                                sessionId: session.session_id(),
                                                lastDecryptionTs: Date.now(),
                                                pickled: session.pickle(this.pickleKey),
                                            };
                                            yield this.client.cryptoStore.storeOlmSession(userId, deviceId, storedSession);
                                            if (!userDeviceSessionIds[userId])
                                                userDeviceSessionIds[userId] = {};
                                            userDeviceSessionIds[userId][deviceId] = storedSession;
                                        }
                                        finally {
                                            session.free();
                                            yield this.storeAndFreeOlmAccount(account);
                                        }
                                    }
                                    catch (e) {
                                        LogService_3.LogService.warn("CryptoClient", `Unable to verify signature of claimed OTK ${userId} ${deviceId}:`, e);
                                    }
                                }
                            }
                        }
                        return userDeviceSessionIds;
                    });
                }
                encryptAndSendOlmMessage(device, session, type, content) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const olmSession = new Olm.Session();
                        try {
                            olmSession.unpickle(this.pickleKey, session.pickled);
                            const payload = {
                                keys: {
                                    ed25519: this.deviceEd25519,
                                },
                                recipient_keys: {
                                    ed25519: device.keys[`${Crypto_2.DeviceKeyAlgorithm.Ed25519}:${device.device_id}`],
                                },
                                recipient: device.user_id,
                                sender: yield this.client.getUserId(),
                                content: content,
                                type: type,
                            };
                            const encrypted = olmSession.encrypt(JSON.stringify(payload));
                            yield this.client.cryptoStore.storeOlmSession(device.user_id, device.device_id, {
                                pickled: olmSession.pickle(this.pickleKey),
                                lastDecryptionTs: session.lastDecryptionTs,
                                sessionId: olmSession.session_id(),
                            });
                            const message = {
                                algorithm: Crypto_2.EncryptionAlgorithm.OlmV1Curve25519AesSha2,
                                ciphertext: {
                                    [device.keys[`${Crypto_2.DeviceKeyAlgorithm.Curve25519}:${device.device_id}`]]: encrypted,
                                },
                                sender_key: this.deviceCurve25519,
                            };
                            yield this.client.sendToDevices("m.room.encrypted", {
                                [device.user_id]: {
                                    [device.device_id]: message,
                                },
                            });
                        }
                        finally {
                            olmSession.free();
                        }
                    });
                }
                /**
                 * Encrypts the details of a room event, returning an encrypted payload to be sent in an
                 * `m.room.encrypted` event to the room. If needed, this function will send decryption keys
                 * to the appropriate devices in the room (this happens when the Megolm session rotates or
                 * gets created).
                 * @param {string} roomId The room ID to encrypt within. If the room is not encrypted, an
                 * error is thrown.
                 * @param {string} eventType The event type being encrypted.
                 * @param {any} content The event content being encrypted.
                 * @returns {Promise<IMegolmEncrypted>} Resolves to the encrypted content for an `m.room.encrypted` event.
                 */
                encryptRoomEvent(roomId, eventType, content) {
                    var _a, _b;
                    return __awaiter(this, void 0, void 0, function* () {
                        if (!(yield this.isRoomEncrypted(roomId))) {
                            throw new Error("Room is not encrypted");
                        }
                        let relatesTo;
                        if (content['m.relates_to']) {
                            relatesTo = JSON.parse(JSON.stringify(content['m.relates_to']));
                            delete content['m.relates_to'];
                        }
                        const now = (new Date()).getTime();
                        let currentSession = yield this.client.cryptoStore.getCurrentOutboundGroupSession(roomId);
                        if (currentSession && (currentSession.expiresTs <= now || currentSession.usesLeft <= 0)) {
                            currentSession = null; // force rotation
                        }
                        if (!currentSession) {
                            // Make a new session, either because we don't have one or it rotated.
                            const roomConfig = new EncryptionEvent_1.EncryptionEvent({
                                type: "m.room.encryption",
                                state_key: "",
                                content: yield this.roomTracker.getRoomCryptoConfig(roomId),
                            });
                            const newSession = new Olm.OutboundGroupSession();
                            try {
                                newSession.create();
                                const pickled = newSession.pickle(this.pickleKey);
                                currentSession = {
                                    sessionId: newSession.session_id(),
                                    roomId: roomId,
                                    pickled: pickled,
                                    isCurrent: true,
                                    usesLeft: roomConfig.rotationPeriodMessages,
                                    expiresTs: now + roomConfig.rotationPeriodMs,
                                };
                                // Store the session as an inbound session up front. This is to ensure that we have the
                                // earliest possible ratchet available to our own decryption functions. We don't store
                                // the outbound session here as it is stored earlier on.
                                yield this.storeInboundGroupSession({
                                    room_id: roomId,
                                    session_id: newSession.session_id(),
                                    session_key: newSession.session_key(),
                                    algorithm: Crypto_2.EncryptionAlgorithm.MegolmV1AesSha2,
                                }, yield this.client.getUserId(), this.clientDeviceId);
                            }
                            finally {
                                newSession.free();
                            }
                        }
                        // TODO: Include invited members?
                        const memberUserIds = yield this.client.getJoinedRoomMembers(roomId);
                        const devices = yield this.deviceTracker.getDevicesFor(memberUserIds);
                        const session = new Olm.OutboundGroupSession();
                        try {
                            session.unpickle(this.pickleKey, currentSession.pickled);
                            const neededSessions = {};
                            for (const userId of Object.keys(devices)) {
                                neededSessions[userId] = devices[userId].map(d => d.device_id);
                            }
                            const olmSessions = yield this.getOrCreateOlmSessions(neededSessions);
                            for (const userId of Object.keys(devices)) {
                                for (const device of devices[userId]) {
                                    const olmSession = (_a = olmSessions[userId]) === null || _a === void 0 ? void 0 : _a[device.device_id];
                                    if (!olmSession) {
                                        LogService_3.LogService.warn("CryptoClient", `Unable to send Megolm session to ${userId} ${device.device_id}: No Olm session`);
                                        continue;
                                    }
                                    const lastSession = yield this.client.cryptoStore.getLastSentOutboundGroupSession(userId, device.device_id, roomId);
                                    if ((lastSession === null || lastSession === void 0 ? void 0 : lastSession.sessionId) !== session.session_id() || session.message_index() < ((_b = lastSession === null || lastSession === void 0 ? void 0 : lastSession.index) !== null && _b !== void 0 ? _b : Number.MAX_SAFE_INTEGER)) {
                                        yield this.encryptAndSendOlmMessage(device, olmSession, "m.room_key", {
                                            algorithm: Crypto_2.EncryptionAlgorithm.MegolmV1AesSha2,
                                            room_id: roomId,
                                            session_id: session.session_id(),
                                            session_key: session.session_key(),
                                        });
                                        yield this.client.cryptoStore.storeSentOutboundGroupSession(currentSession, session.message_index(), device);
                                    }
                                }
                            }
                            // Encrypt after to avoid UNKNOWN_MESSAGE_INDEX errors on remote end
                            const encrypted = session.encrypt(JSON.stringify({
                                type: eventType,
                                content: content,
                                room_id: roomId,
                            }));
                            currentSession.pickled = session.pickle(this.pickleKey);
                            currentSession.usesLeft--;
                            yield this.client.cryptoStore.storeOutboundGroupSession(currentSession);
                            const body = {
                                sender_key: this.deviceCurve25519,
                                ciphertext: encrypted,
                                session_id: session.session_id(),
                                device_id: this.clientDeviceId,
                            };
                            if (relatesTo) {
                                body['m.relates_to'] = relatesTo;
                            }
                            return Object.assign(Object.assign({}, body), { algorithm: Crypto_2.EncryptionAlgorithm.MegolmV1AesSha2 });
                        }
                        finally {
                            session.free();
                        }
                    });
                }
                /**
                 * Decrypts a room event. Currently only supports Megolm-encrypted events (default for this SDK).
                 * @param {EncryptedRoomEvent} event The encrypted event.
                 * @param {string} roomId The room ID where the event was sent.
                 * @returns {Promise<RoomEvent<unknown>>} Resolves to a decrypted room event, or rejects/throws with
                 * an error if the event is undecryptable.
                 */
                decryptRoomEvent(event, roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (event.algorithm !== Crypto_2.EncryptionAlgorithm.MegolmV1AesSha2) {
                            throw new Error("Unable to decrypt: Unknown algorithm");
                        }
                        const encrypted = event.megolmProperties;
                        const senderDevice = yield this.client.cryptoStore.getActiveUserDevice(event.sender, encrypted.device_id);
                        if (!senderDevice) {
                            throw new Error("Unable to decrypt: Unknown device for sender");
                        }
                        if (senderDevice.keys[`${Crypto_2.DeviceKeyAlgorithm.Curve25519}:${senderDevice.device_id}`] !== encrypted.sender_key) {
                            throw new Error("Unable to decrypt: Device key mismatch");
                        }
                        const storedSession = yield this.client.cryptoStore.getInboundGroupSession(event.sender, encrypted.device_id, roomId, encrypted.session_id);
                        if (!storedSession) {
                            throw new Error("Unable to decrypt: Unknown inbound session ID");
                        }
                        const session = new Olm.InboundGroupSession();
                        try {
                            session.unpickle(this.pickleKey, storedSession.pickled);
                            const cleartext = session.decrypt(encrypted.ciphertext);
                            const eventBody = JSON.parse(cleartext.plaintext);
                            const messageIndex = cleartext.message_index;
                            const existingEventId = yield this.client.cryptoStore.getEventForMessageIndex(roomId, storedSession.sessionId, messageIndex);
                            if (existingEventId && existingEventId !== event.eventId) {
                                throw new Error("Unable to decrypt: Message replay attack");
                            }
                            yield this.client.cryptoStore.setMessageIndexForEvent(roomId, event.eventId, storedSession.sessionId, messageIndex);
                            storedSession.pickled = session.pickle(this.pickleKey);
                            yield this.client.cryptoStore.storeInboundGroupSession(storedSession);
                            return new RoomEvent_4.RoomEvent(Object.assign(Object.assign({}, event.raw), { type: eventBody.type || "io.t2bot.unknown", content: (typeof (eventBody.content) === 'object') ? eventBody.content : {} }));
                        }
                        finally {
                            session.free();
                        }
                    });
                }
                /**
                 * Handles an inbound to-device message, decrypting it if needed. This will not throw
                 * under normal circumstances and should always resolve successfully.
                 * @param {IToDeviceMessage<IOlmEncrypted>} message The message to process.
                 * @returns {Promise<void>} Resolves when complete. Should never fail.
                 */
                processInboundDeviceMessage(message) {
                    var _a, _b, _c, _d;
                    return __awaiter(this, void 0, void 0, function* () {
                        if (!(message === null || message === void 0 ? void 0 : message.content) || !(message === null || message === void 0 ? void 0 : message.sender) || !(message === null || message === void 0 ? void 0 : message.type)) {
                            LogService_3.LogService.warn("CryptoClient", "Received invalid encrypted message");
                            return;
                        }
                        try {
                            if (message.type === "m.room.encrypted") {
                                if (((_a = message.content) === null || _a === void 0 ? void 0 : _a['algorithm']) !== Crypto_2.EncryptionAlgorithm.OlmV1Curve25519AesSha2) {
                                    LogService_3.LogService.warn("CryptoClient", "Received encrypted message with unknown encryption algorithm");
                                    return;
                                }
                                const myMessage = (_b = message.content.ciphertext) === null || _b === void 0 ? void 0 : _b[this.deviceCurve25519];
                                if (!myMessage) {
                                    LogService_3.LogService.warn("CryptoClient", "Received encrypted message not intended for us (ignoring message)");
                                    return;
                                }
                                if (!Number.isFinite(myMessage.type) || !myMessage.body) {
                                    LogService_3.LogService.warn("CryptoClient", "Received invalid encrypted message (ignoring message)");
                                    return;
                                }
                                let userDevices = yield this.client.cryptoStore.getActiveUserDevices(message.sender);
                                let senderDevice = userDevices.find(d => d.keys[`${Crypto_2.DeviceKeyAlgorithm.Curve25519}:${d.device_id}`] === message.content.sender_key);
                                if (!senderDevice) {
                                    LogService_3.LogService.warn("CryptoClient", "Received encrypted message from unknown identity key (trying resync):", message.content.sender_key);
                                    yield this.flagUsersDeviceListsOutdated([message.sender], true);
                                    // try again
                                    userDevices = yield this.client.cryptoStore.getActiveUserDevices(message.sender);
                                    senderDevice = userDevices.find(d => d.keys[`${Crypto_2.DeviceKeyAlgorithm.Curve25519}:${d.device_id}`] === message.content.sender_key);
                                }
                                if (!senderDevice) {
                                    LogService_3.LogService.warn("CryptoClient", "Received encrypted message from unknown identity key (ignoring message):", message.content.sender_key);
                                    return;
                                }
                                const sessions = yield this.client.cryptoStore.getOlmSessions(senderDevice.user_id, senderDevice.device_id);
                                let trySession;
                                for (const storedSession of sessions) {
                                    const checkSession = new Olm.Session();
                                    try {
                                        checkSession.unpickle(this.pickleKey, storedSession.pickled);
                                        if (checkSession.matches_inbound(myMessage.body)) {
                                            trySession = storedSession;
                                            break;
                                        }
                                    }
                                    finally {
                                        checkSession.free();
                                    }
                                }
                                if (myMessage.type === 0 && !trySession) {
                                    // Store the session because we can
                                    const inboundSession = new Olm.Session();
                                    const account = yield this.getOlmAccount();
                                    try {
                                        inboundSession.create_inbound_from(account, message.content.sender_key, myMessage.body);
                                        account.remove_one_time_keys(inboundSession);
                                        trySession = {
                                            pickled: inboundSession.pickle(this.pickleKey),
                                            sessionId: inboundSession.session_id(),
                                            lastDecryptionTs: Date.now(),
                                        };
                                        yield this.client.cryptoStore.storeOlmSession(senderDevice.user_id, senderDevice.device_id, trySession);
                                    }
                                    finally {
                                        inboundSession.free();
                                        yield this.storeAndFreeOlmAccount(account);
                                    }
                                }
                                if (myMessage.type !== 0 && !trySession) {
                                    LogService_3.LogService.warn("CryptoClient", "Unable to find suitable session for encrypted to-device message; Establishing new session");
                                    yield this.establishNewOlmSession(senderDevice);
                                    return;
                                }
                                // Try decryption (finally)
                                const session = new Olm.Session();
                                let decrypted;
                                try {
                                    session.unpickle(this.pickleKey, trySession.pickled);
                                    decrypted = JSON.parse(session.decrypt(myMessage.type, myMessage.body));
                                }
                                catch (e) {
                                    LogService_3.LogService.warn("CryptoClient", "Decryption error with to-device message, assuming corrupted session and re-establishing.", e);
                                    yield this.establishNewOlmSession(senderDevice);
                                    return;
                                }
                                finally {
                                    session.free();
                                }
                                const wasForUs = decrypted.recipient === (yield this.client.getUserId());
                                const wasFromThem = decrypted.sender === message.sender;
                                const hasType = typeof (decrypted.type) === 'string';
                                const hasContent = !!decrypted.content && typeof (decrypted.content) === 'object';
                                const ourKeyMatches = ((_c = decrypted.recipient_keys) === null || _c === void 0 ? void 0 : _c.ed25519) === this.deviceEd25519;
                                const theirKeyMatches = ((_d = decrypted.keys) === null || _d === void 0 ? void 0 : _d.ed25519) === senderDevice.keys[`${Crypto_2.DeviceKeyAlgorithm.Ed25519}:${senderDevice.device_id}`];
                                if (!wasForUs || !wasFromThem || !hasType || !hasContent || !ourKeyMatches || !theirKeyMatches) {
                                    LogService_3.LogService.warn("CryptoClient", "Successfully decrypted to-device message, but it failed validation. Ignoring message.", {
                                        wasForUs,
                                        wasFromThem,
                                        hasType,
                                        hasContent,
                                        ourKeyMatches,
                                        theirKeyMatches,
                                    });
                                    return;
                                }
                                trySession.lastDecryptionTs = Date.now();
                                yield this.client.cryptoStore.storeOlmSession(senderDevice.user_id, senderDevice.device_id, trySession);
                                if (decrypted.type === "m.room_key") {
                                    yield this.handleInboundRoomKey(decrypted, senderDevice, message);
                                }
                                else if (decrypted.type === "m.dummy") {
                                    // success! Nothing to do.
                                }
                                else {
                                    LogService_3.LogService.warn("CryptoClient", `Unknown decrypted to-device message type: ${decrypted.type}`);
                                }
                            }
                            else {
                                LogService_3.LogService.warn("CryptoClient", `Unknown to-device message type: ${message.type}`);
                            }
                        }
                        catch (e) {
                            LogService_3.LogService.error("CryptoClient", "Non-fatal error while processing to-device message:", e);
                        }
                    });
                }
                handleInboundRoomKey(message, device, original) {
                    var _a, _b, _c, _d, _e;
                    return __awaiter(this, void 0, void 0, function* () {
                        if (((_a = message.content) === null || _a === void 0 ? void 0 : _a.algorithm) !== Crypto_2.EncryptionAlgorithm.MegolmV1AesSha2) {
                            LogService_3.LogService.warn("CryptoClient", "Ignoring m.room_key for unknown encryption algorithm");
                            return;
                        }
                        if (!((_b = message.content) === null || _b === void 0 ? void 0 : _b.room_id) || !((_c = message.content) === null || _c === void 0 ? void 0 : _c.session_id) || !((_d = message.content) === null || _d === void 0 ? void 0 : _d.session_key)) {
                            LogService_3.LogService.warn("CryptoClient", "Ignoring invalid m.room_key");
                            return;
                        }
                        const deviceKey = device.keys[`${Crypto_2.DeviceKeyAlgorithm.Curve25519}:${device.device_id}`];
                        if (deviceKey !== ((_e = original.content) === null || _e === void 0 ? void 0 : _e.sender_key)) {
                            LogService_3.LogService.warn("CryptoClient", "Ignoring m.room_key message from unexpected sender");
                            return;
                        }
                        // See if we already know about this session (if we do: ignore the message)
                        const knownSession = yield this.client.cryptoStore.getInboundGroupSession(device.user_id, device.device_id, message.content.room_id, message.content.session_id);
                        if (knownSession) {
                            return; // ignore
                        }
                        yield this.storeInboundGroupSession(message.content, device.user_id, device.device_id);
                    });
                }
                storeInboundGroupSession(key, senderUserId, senderDeviceId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const inboundSession = new Olm.InboundGroupSession();
                        try {
                            inboundSession.create(key.session_key);
                            if (inboundSession.session_id() !== key.session_id) {
                                LogService_3.LogService.warn("CryptoClient", "Ignoring m.room_key with mismatched session_id");
                                return;
                            }
                            yield this.client.cryptoStore.storeInboundGroupSession({
                                roomId: key.room_id,
                                sessionId: key.session_id,
                                senderDeviceId: senderDeviceId,
                                senderUserId: senderUserId,
                                pickled: inboundSession.pickle(this.pickleKey),
                            });
                        }
                        finally {
                            inboundSession.free();
                        }
                    });
                }
                establishNewOlmSession(device) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const olmSessions = yield this.getOrCreateOlmSessions({
                            [device.user_id]: [device.device_id],
                        }, true);
                        // Share the session immediately
                        yield this.encryptAndSendOlmMessage(device, olmSessions[device.user_id][device.device_id], "m.dummy", {});
                    });
                }
                /**
                 * Encrypts a file for uploading in a room, returning the encrypted data and information
                 * to include in a message event (except media URL) for sending.
                 * @param {Buffer} file The file to encrypt.
                 * @returns {{buffer: Buffer, file: Omit<EncryptedFile, "url">}} Resolves to the encrypted
                 * contents and file information.
                 */
                encryptMedia(file) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const key = crypto.randomBytes(32);
                        const iv = new Uint8Array(16);
                        crypto.randomBytes(8).forEach((v, i) => iv[i] = v); // only fill high side to avoid 64bit overflow
                        const cipher = crypto.createCipheriv("aes-256-ctr", key, iv);
                        const buffers = [];
                        cipher.on('data', b => {
                            buffers.push(b);
                        });
                        const stream = new stream_1.PassThrough();
                        stream.pipe(cipher);
                        stream.end(file);
                        const finishPromise = new Promise(resolve => {
                            cipher.end(() => {
                                resolve(Buffer.concat(buffers));
                            });
                        });
                        const cipheredContent = yield finishPromise;
                        let sha256;
                        const util = new Olm.Utility();
                        try {
                            const arr = new Uint8Array(cipheredContent);
                            sha256 = util.sha256(arr);
                        }
                        finally {
                            util.free();
                        }
                        return {
                            buffer: Buffer.from(cipheredContent),
                            file: {
                                hashes: {
                                    sha256: sha256,
                                },
                                key: {
                                    alg: "A256CTR",
                                    ext: true,
                                    key_ops: ['encrypt', 'decrypt'],
                                    kty: "oct",
                                    k: b64_1.encodeUnpaddedUrlSafeBase64(key),
                                },
                                iv: b64_1.encodeUnpaddedBase64(iv),
                                v: 'v2',
                            },
                        };
                    });
                }
                /**
                 * Decrypts a previously-uploaded encrypted file, validating the fields along the way.
                 * @param {EncryptedFile} file The file to decrypt.
                 * @returns {Promise<Buffer>} Resolves to the decrypted file contents.
                 */
                decryptMedia(file) {
                    var _a, _b, _c, _d;
                    return __awaiter(this, void 0, void 0, function* () {
                        if (file.v !== "v2") {
                            throw new Error("Unknown encrypted file version");
                        }
                        if (((_a = file.key) === null || _a === void 0 ? void 0 : _a.kty) !== "oct" || ((_b = file.key) === null || _b === void 0 ? void 0 : _b.alg) !== "A256CTR" || ((_c = file.key) === null || _c === void 0 ? void 0 : _c.ext) !== true) {
                            throw new Error("Improper JWT: Missing or invalid fields");
                        }
                        if (!file.key.key_ops.includes("encrypt") || !file.key.key_ops.includes("decrypt")) {
                            throw new Error("Missing required key_ops");
                        }
                        if (!((_d = file.hashes) === null || _d === void 0 ? void 0 : _d.sha256)) {
                            throw new Error("Missing SHA256 hash");
                        }
                        const key = b64_1.decodeUnpaddedUrlSafeBase64(file.key.k);
                        const iv = b64_1.decodeUnpaddedBase64(file.iv);
                        const ciphered = (yield this.client.downloadContent(file.url)).data;
                        let sha256;
                        const util = new Olm.Utility();
                        try {
                            const arr = new Uint8Array(ciphered);
                            sha256 = util.sha256(arr);
                        }
                        finally {
                            util.free();
                        }
                        if (sha256 !== file.hashes.sha256) {
                            throw new Error("SHA256 mismatch");
                        }
                        const decipher = crypto.createDecipheriv("aes-256-ctr", key, iv);
                        const buffers = [];
                        decipher.on('data', b => {
                            buffers.push(b);
                        });
                        const stream = new stream_1.PassThrough();
                        stream.pipe(decipher);
                        stream.end(ciphered);
                        return new Promise(resolve => {
                            decipher.end(() => {
                                resolve(Buffer.concat(buffers));
                            });
                        });
                    });
                }
            };
            __decorate([
                decorators_3.requiresReady(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], CryptoClient.prototype, "isRoomEncrypted", null);
            __decorate([
                decorators_3.requiresReady(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object]),
                __metadata("design:returntype", Promise)
            ], CryptoClient.prototype, "updateCounts", null);
            __decorate([
                decorators_3.requiresReady(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Promise)
            ], CryptoClient.prototype, "updateFallbackKey", null);
            __decorate([
                decorators_3.requiresReady(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object]),
                __metadata("design:returntype", Promise)
            ], CryptoClient.prototype, "sign", null);
            __decorate([
                decorators_3.requiresReady(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, String, String]),
                __metadata("design:returntype", Promise)
            ], CryptoClient.prototype, "verifySignature", null);
            __decorate([
                decorators_3.requiresReady(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Array, Object]),
                __metadata("design:returntype", Promise)
            ], CryptoClient.prototype, "flagUsersDeviceListsOutdated", null);
            __decorate([
                decorators_3.requiresReady(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object]),
                __metadata("design:returntype", Promise)
            ], CryptoClient.prototype, "getOrCreateOlmSessions", null);
            __decorate([
                decorators_3.requiresReady(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object, String, Object]),
                __metadata("design:returntype", Promise)
            ], CryptoClient.prototype, "encryptAndSendOlmMessage", null);
            __decorate([
                decorators_3.requiresReady(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String, Object]),
                __metadata("design:returntype", Promise)
            ], CryptoClient.prototype, "encryptRoomEvent", null);
            __decorate([
                decorators_3.requiresReady(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [EncryptedRoomEvent_1.EncryptedRoomEvent, String]),
                __metadata("design:returntype", Promise)
            ], CryptoClient.prototype, "decryptRoomEvent", null);
            __decorate([
                decorators_3.requiresReady(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object]),
                __metadata("design:returntype", Promise)
            ], CryptoClient.prototype, "processInboundDeviceMessage", null);
            __decorate([
                decorators_3.requiresReady(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Buffer]),
                __metadata("design:returntype", Promise)
            ], CryptoClient.prototype, "encryptMedia", null);
            exports_41("CryptoClient", CryptoClient);
        }
    };
});
System.register("helpers/RichReply", ["sanitize-html"], function (exports_42, context_42) {
    "use strict";
    var sanitizeHtml, RichReply;
    var __moduleName = context_42 && context_42.id;
    return {
        setters: [
            function (sanitizeHtml_1) {
                sanitizeHtml = sanitizeHtml_1;
            }
        ],
        execute: function () {
            /**
             * Helper for creating rich replies.
             * @category Utilities
             */
            RichReply = class RichReply {
                constructor() {
                }
                /**
                 * Generates the event content required to reply to the provided event with the
                 * provided text.
                 * @param {string} roomId the room ID the event being replied to resides in
                 * @param {any} event the event to reply to
                 * @param {string} withText the plain text to reply with
                 * @param {string} withHtml the HTML to reply with
                 * @returns {any} the content of the event representing the reply
                 */
                static createFor(roomId, event, withText, withHtml) {
                    const originalBody = (event["content"] ? event["content"]["body"] : "") || "";
                    let originalHtml = (event["content"] ? event["content"]["formatted_body"] : "") || null;
                    if (originalHtml === null) {
                        originalHtml = sanitizeHtml(originalBody);
                    }
                    const fallbackText = "> <" + event["sender"] + "> " + originalBody.split("\n").join("\n> ");
                    const fallbackHtml = "<mx-reply><blockquote>"
                        + `<a href="https://matrix.to/#/${roomId}/${event["event_id"]}">In reply to</a> `
                        + `<a href="https://matrix.to/#/${event["sender"]}">${event["sender"]}</a>`
                        + "<br />" + originalHtml
                        + "</blockquote></mx-reply>";
                    return {
                        "m.relates_to": {
                            "m.in_reply_to": {
                                "event_id": event["event_id"],
                            },
                        },
                        "msgtype": "m.text",
                        "body": fallbackText + "\n\n" + withText,
                        "format": "org.matrix.custom.html",
                        "formatted_body": fallbackHtml + withHtml,
                    };
                }
            };
            exports_42("RichReply", RichReply);
        }
    };
});
System.register("helpers/Permalinks", [], function (exports_43, context_43) {
    "use strict";
    var Permalinks;
    var __moduleName = context_43 && context_43.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Functions for handling permalinks
             * @category Utilities
             */
            Permalinks = class Permalinks {
                constructor() {
                }
                // TODO: Encode permalinks
                static encodeViaArgs(servers) {
                    if (!servers || !servers.length)
                        return "";
                    return `?via=${servers.join("via=")}`;
                }
                /**
                 * Creates a room permalink.
                 * @param {string} roomIdOrAlias The room ID or alias to create a permalink for.
                 * @param {string[]} viaServers The servers to route the permalink through.
                 * @returns {string} A room permalink.
                 */
                static forRoom(roomIdOrAlias, viaServers = []) {
                    return `https://matrix.to/#/${roomIdOrAlias}${Permalinks.encodeViaArgs(viaServers)}`;
                }
                /**
                 * Creates a user permalink.
                 * @param {string} userId The user ID to create a permalink for.
                 * @returns {string} A user permalink.
                 */
                static forUser(userId) {
                    return `https://matrix.to/#/${userId}`;
                }
                /**
                 * Creates an event permalink.
                 * @param {string} roomIdOrAlias The room ID or alias to create a permalink in.
                 * @param {string} eventId The event ID to reference in the permalink.
                 * @param {string[]} viaServers The servers to route the permalink through.
                 * @returns {string} An event permalink.
                 */
                static forEvent(roomIdOrAlias, eventId, viaServers = []) {
                    return `https://matrix.to/#/${roomIdOrAlias}/${eventId}${Permalinks.encodeViaArgs(viaServers)}`;
                }
                /**
                 * Parses a permalink URL into usable parts.
                 * @param {string} matrixTo The matrix.to URL to parse.
                 * @returns {PermalinkParts} The parts of the permalink.
                 */
                static parseUrl(matrixTo) {
                    if (!matrixTo || !matrixTo.startsWith("https://matrix.to/#/")) {
                        throw new Error("Not a valid matrix.to URL");
                    }
                    const parts = matrixTo.substring("https://matrix.to/#/".length).split("/");
                    const entity = decodeURIComponent(parts[0]);
                    if (entity[0] === '@') {
                        return { userId: entity, roomIdOrAlias: undefined, eventId: undefined, viaServers: undefined };
                    }
                    else if (entity[0] === '#' || entity[0] === '!') {
                        if (parts.length === 1) {
                            return { roomIdOrAlias: entity, userId: undefined, eventId: undefined, viaServers: [] };
                        }
                        // rejoin the rest because v3 room can have slashes
                        const eventIdAndQuery = decodeURIComponent(parts.length > 1 ? parts.slice(1).join('/') : "");
                        const secondaryParts = eventIdAndQuery.split('?');
                        const eventId = secondaryParts[0];
                        const query = secondaryParts.length > 1 ? secondaryParts[1] : "";
                        const via = query.split("via=").filter(p => !!p);
                        return { roomIdOrAlias: entity, eventId: eventId, viaServers: via, userId: undefined };
                    }
                    throw new Error("Unexpected entity");
                }
            };
            exports_43("Permalinks", Permalinks);
        }
    };
});
System.register("helpers/MentionPill", ["helpers/Permalinks", "index"], function (exports_44, context_44) {
    "use strict";
    var Permalinks_1, __5, MentionPill;
    var __moduleName = context_44 && context_44.id;
    return {
        setters: [
            function (Permalinks_1_1) {
                Permalinks_1 = Permalinks_1_1;
            },
            function (__5_1) {
                __5 = __5_1;
            }
        ],
        execute: function () {
            /**
             * Represents a system for generating a mention pill for an entity.
             * @category Utilities
             */
            MentionPill = class MentionPill {
                constructor(entityPermalink, displayName) {
                    this.entityPermalink = entityPermalink;
                    this.displayName = displayName;
                }
                /**
                 * The HTML component of the mention.
                 */
                get html() {
                    return `<a href="${this.entityPermalink}">${this.displayName}</a>`;
                }
                /**
                 * The plain text component of the mention.
                 */
                get text() {
                    return this.displayName;
                }
                /**
                 * Creates a new mention for a user in an optional room.
                 * @param {string} userId The user ID the mention is for.
                 * @param {String} inRoomId Optional room ID the user is being mentioned in, for the aesthetics of the mention.
                 * @param {MatrixClient} client Optional client for creating a more pleasing mention.
                 * @returns {Promise<MentionPill>} Resolves to the user's mention.
                 */
                static forUser(userId, inRoomId = null, client = null) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const permalink = Permalinks_1.Permalinks.forUser(userId);
                        let displayName = userId;
                        try {
                            if (client) {
                                let profile = null;
                                if (inRoomId) {
                                    profile = yield client.getRoomStateEvent(inRoomId, "m.room.member", userId);
                                }
                                if (!profile) {
                                    profile = yield client.getUserProfile(userId);
                                }
                                if (profile['displayname']) {
                                    displayName = profile['displayname'];
                                }
                            }
                        }
                        catch (e) {
                            __5.LogService.warn("MentionPill", "Error getting profile", __5.extractRequestError(e));
                        }
                        return new MentionPill(permalink, displayName);
                    });
                }
                /**
                 * Creates a new mention for a room (not @room, but the room itself to be linked).
                 * @param {string} roomIdOrAlias The room ID or alias to mention.
                 * @param {MatrixClient} client Optional client for creating a more pleasing mention.
                 * @returns {Promise<MentionPill>} Resolves to the room's mention.
                 */
                static forRoom(roomIdOrAlias, client = null) {
                    return __awaiter(this, void 0, void 0, function* () {
                        let permalink = Permalinks_1.Permalinks.forRoom(roomIdOrAlias);
                        let displayProp = roomIdOrAlias;
                        try {
                            if (client) {
                                const roomId = yield client.resolveRoom(roomIdOrAlias);
                                const canonicalAlias = yield client.getRoomStateEvent(roomId, "m.room.canonical_alias", "");
                                if (canonicalAlias === null || canonicalAlias === void 0 ? void 0 : canonicalAlias.alias) {
                                    displayProp = canonicalAlias.alias;
                                    permalink = Permalinks_1.Permalinks.forRoom(displayProp);
                                }
                            }
                        }
                        catch (e) {
                            __5.LogService.warn("MentionPill", "Error getting room information", __5.extractRequestError(e));
                        }
                        return new MentionPill(permalink, displayProp);
                    });
                }
                /**
                 * Creates a mention from static information.
                 * @param {string} userId The user ID the mention is for.
                 * @param {string} displayName The user's display name.
                 * @returns {MentionPill} The mention for the user.
                 */
                static withDisplayName(userId, displayName) {
                    return new MentionPill(Permalinks_1.Permalinks.forUser(userId), displayName || userId);
                }
            };
            exports_44("MentionPill", MentionPill);
        }
    };
});
System.register("helpers/MatrixGlob", ["glob-to-regexp"], function (exports_45, context_45) {
    "use strict";
    var globToRegexp, MatrixGlob;
    var __moduleName = context_45 && context_45.id;
    return {
        setters: [
            function (globToRegexp_1) {
                globToRegexp = globToRegexp_1;
            }
        ],
        execute: function () {
            /**
             * Represents a common Matrix glob. This is commonly used
             * for server ACLs and similar functions.
             * @category Utilities
             */
            MatrixGlob = class MatrixGlob {
                /**
                 * Creates a new Matrix Glob
                 * @param {string} glob The glob to convert. Eg: "*.example.org"
                 */
                constructor(glob) {
                    const globRegex = globToRegexp(glob, {
                        extended: false,
                        globstar: false,
                    });
                    // We need to convert `?` manually because globToRegexp's extended mode
                    // does more than we want it to.
                    const replaced = globRegex.toString().replace(/\\\?/g, ".");
                    this.regex = new RegExp(replaced.substring(1, replaced.length - 1));
                }
                /**
                 * Tests the glob against a value, returning true if it matches.
                 * @param {string} val The value to test.
                 * @returns {boolean} True if the value matches the glob, false otherwise.
                 */
                test(val) {
                    return this.regex.test(val);
                }
            };
            exports_45("MatrixGlob", MatrixGlob);
        }
    };
});
System.register("models/events/MembershipEvent", ["models/events/RoomEvent", "models/events/InvalidEventError"], function (exports_46, context_46) {
    "use strict";
    var RoomEvent_5, InvalidEventError_2, MembershipEvent;
    var __moduleName = context_46 && context_46.id;
    return {
        setters: [
            function (RoomEvent_5_1) {
                RoomEvent_5 = RoomEvent_5_1;
            },
            function (InvalidEventError_2_1) {
                InvalidEventError_2 = InvalidEventError_2_1;
            }
        ],
        execute: function () {
            /**
             * Represents an m.room.member state event
             * @category Matrix events
             */
            MembershipEvent = class MembershipEvent extends RoomEvent_5.StateEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * True if the membership event targets the sender. False otherwise.
                 *
                 * This will typically by false for kicks and bans.
                 */
                get ownMembership() {
                    return this.membershipFor === this.sender;
                }
                /**
                 * The user ID the membership affects.
                 */
                get membershipFor() {
                    return this.stateKey;
                }
                /**
                 * The user's membership.
                 */
                get membership() {
                    const membership = this.content.membership;
                    if (!membership)
                        throw new InvalidEventError_2.InvalidEventError("no membership field in content");
                    return membership;
                }
                /**
                 * The user's effective membership.
                 */
                get effectiveMembership() {
                    if (this.membership === "join")
                        return "join";
                    if (this.membership === "invite")
                        return "invite";
                    return "leave";
                }
            };
            exports_46("MembershipEvent", MembershipEvent);
        }
    };
});
System.register("helpers/ProfileCache", ["lru-cache", "index", "models/events/MembershipEvent"], function (exports_47, context_47) {
    "use strict";
    var LRU, __6, MembershipEvent_1, ProfileCache;
    var __moduleName = context_47 && context_47.id;
    return {
        setters: [
            function (LRU_2) {
                LRU = LRU_2;
            },
            function (__6_1) {
                __6 = __6_1;
            },
            function (MembershipEvent_1_1) {
                MembershipEvent_1 = MembershipEvent_1_1;
            }
        ],
        execute: function () {
            /**
             * Functions for avoiding calls to profile endpoints. Useful for bots when
             * people are mentioned often or bridges which need profile information
             * often.
             * @category Utilities
             */
            ProfileCache = class ProfileCache {
                /**
                 * Creates a new profile cache.
                 * @param {number} maxEntries The maximum number of entries to cache.
                 * @param {number} maxAgeMs The maximum age of an entry in milliseconds.
                 * @param {MatrixClient} client The client to use to get profile updates.
                 */
                constructor(maxEntries, maxAgeMs, client) {
                    this.client = client;
                    this.cache = new LRU({
                        max: maxEntries,
                        maxAge: maxAgeMs,
                    });
                }
                getCacheKey(userId, roomId) {
                    return `${userId}@${roomId || '<none>'}`;
                }
                /**
                 * Watch for profile changes to cached entries with the provided client. The
                 * same client will also be used to update the user's profile in the cache.
                 * @param {MatrixClient} client The client to watch for profile changes with.
                 */
                watchWithClient(client) {
                    client.on("room.event", (roomId, event) => __awaiter(this, void 0, void 0, function* () {
                        if (!event['state_key'] || !event['content'] || event['type'] !== 'm.room.member')
                            return;
                        yield this.tryUpdateProfile(roomId, new MembershipEvent_1.MembershipEvent(event), client);
                    }));
                }
                /**
                 * Watch for profile changes to cached entries with the provided application
                 * service. The clientFn will be called to get the relevant client for any
                 * updates. If the clientFn is null, the appservice's bot user will be used.
                 * The clientFn takes two arguments: the user ID being updated and the room ID
                 * they are being updated in (shouldn't be null). The return value should be the
                 * MatrixClient to use, or null to use the appservice's bot client. The same
                 * client will be used to update the user's general profile, if that profile
                 * is cached.
                 * @param {Appservice} appservice The application service to watch for profile changes with.
                 * @param {Function} clientFn The function to use to acquire profile updates with. If null, the appservice's bot client will be used.
                 */
                watchWithAppservice(appservice, clientFn = null) {
                    if (!clientFn)
                        clientFn = () => appservice.botClient;
                    appservice.on("room.event", (roomId, event) => __awaiter(this, void 0, void 0, function* () {
                        if (!event['state_key'] || !event['content'] || event['type'] !== 'm.room.member')
                            return;
                        const memberEvent = new MembershipEvent_1.MembershipEvent(event);
                        let client = clientFn(memberEvent.membershipFor, roomId);
                        if (!client)
                            client = appservice.botClient;
                        yield this.tryUpdateProfile(roomId, memberEvent, client);
                    }));
                }
                /**
                 * Gets a profile for a user in optional room.
                 * @param {string} userId The user ID to get a profile for.
                 * @param {string|null} roomId Optional room ID to get a per-room profile for the user.
                 * @returns {Promise<MatrixProfile>} Resolves to the user's profile.
                 */
                getUserProfile(userId, roomId = null) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const cacheKey = this.getCacheKey(userId, roomId);
                        const cached = this.cache.get(cacheKey);
                        if (cached)
                            return Promise.resolve(cached);
                        const profile = yield this.getUserProfileWith(userId, roomId, this.client);
                        this.cache.set(cacheKey, profile);
                        return profile;
                    });
                }
                getUserProfileWith(userId, roomId, client) {
                    return __awaiter(this, void 0, void 0, function* () {
                        try {
                            if (roomId) {
                                const membership = yield client.getRoomStateEvent(roomId, "m.room.member", userId);
                                return new __6.MatrixProfile(userId, membership);
                            }
                            else {
                                const profile = yield client.getUserProfile(userId);
                                return new __6.MatrixProfile(userId, profile);
                            }
                        }
                        catch (e) {
                            __6.LogService.warn("ProfileCache", "Non-fatal error getting user profile. They might not exist.");
                            __6.LogService.warn("ProfileCache", __6.extractRequestError(e));
                            return new __6.MatrixProfile(userId, {});
                        }
                    });
                }
                tryUpdateProfile(roomId, memberEvent, client) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const roomCacheKey = this.getCacheKey(memberEvent.membershipFor, roomId);
                        const generalCacheKey = this.getCacheKey(memberEvent.membershipFor, null);
                        if (this.cache.has(roomCacheKey)) {
                            this.cache.set(roomCacheKey, new __6.MatrixProfile(memberEvent.membershipFor, memberEvent.content));
                        }
                        // TODO: Try and figure out semantics for this updating.
                        // Large accounts could cause hammering on the profile endpoint, but hopefully it is cached by the server.
                        if (this.cache.has(generalCacheKey)) {
                            const profile = yield this.getUserProfileWith(memberEvent.membershipFor, null, client);
                            this.cache.set(generalCacheKey, profile);
                        }
                    });
                }
            };
            exports_47("ProfileCache", ProfileCache);
        }
    };
});
System.register("helpers/MatrixEntity", [], function (exports_48, context_48) {
    "use strict";
    var MatrixEntity, UserID, RoomAlias;
    var __moduleName = context_48 && context_48.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Represents a Matrix entity
             * @category Utilities
             */
            MatrixEntity = class MatrixEntity {
                /**
                 * Creates a new Matrix entity
                 * @param {string} fullId The full ID of the entity
                 */
                constructor(fullId) {
                    this.fullId = fullId;
                    if (!fullId)
                        throw new Error("No entity ID provided");
                    if (fullId.length < 2)
                        throw new Error("ID too short");
                    const parts = fullId.split(/:/g);
                    this.entityLocalpart = parts[0].substring(1);
                    this.entityDomain = parts.splice(1).join(':');
                }
                /**
                 * The localpart for the entity
                 */
                get localpart() {
                    return this.entityLocalpart;
                }
                /**
                 * The domain for the entity
                 */
                get domain() {
                    return this.entityDomain;
                }
                // override
                toString() {
                    return this.fullId;
                }
            };
            exports_48("MatrixEntity", MatrixEntity);
            /**
             * Represents a Matrix user ID
             * @category Utilities
             */
            UserID = class UserID extends MatrixEntity {
                constructor(userId) {
                    super(userId);
                    if (!userId.startsWith("@")) {
                        throw new Error("Not a valid user ID");
                    }
                }
            };
            exports_48("UserID", UserID);
            /**
             * Represents a Matrix room alias
             * @category Utilities
             */
            RoomAlias = class RoomAlias extends MatrixEntity {
                constructor(alias) {
                    super(alias);
                    if (!alias.startsWith("#")) {
                        throw new Error("Not a valid room alias");
                    }
                }
            };
            exports_48("RoomAlias", RoomAlias);
        }
    };
});
System.register("logging/RichConsoleLogger", ["chalk"], function (exports_49, context_49) {
    "use strict";
    var chalk, RichConsoleLogger;
    var __moduleName = context_49 && context_49.id;
    return {
        setters: [
            function (chalk_1) {
                chalk = chalk_1;
            }
        ],
        execute: function () {
            /**
             * Prints to the console with colors and a format.
             * @category Logging
             */
            RichConsoleLogger = class RichConsoleLogger {
                constructor() {
                    this.chalkDebug = chalk.cyan;
                    this.chalkInfo = chalk.green;
                    this.chalkWarning = chalk.yellow;
                    this.chalkError = chalk.bold.red;
                    this.chalkTimestamp = chalk.grey;
                    this.chalkModule = chalk.grey;
                }
                getTimestamp() {
                    const now = new Date(Date.now()).toUTCString();
                    return this.chalkTimestamp(now);
                }
                trace(module, ...messageOrObject) {
                    console.trace(this.getTimestamp(), this.chalkDebug("[TRACE]"), this.chalkModule(`[${module}]`), ...messageOrObject);
                }
                debug(module, ...messageOrObject) {
                    console.debug(this.getTimestamp(), this.chalkDebug("[DEBUG]"), this.chalkModule(`[${module}]`), ...messageOrObject);
                }
                error(module, ...messageOrObject) {
                    console.error(this.getTimestamp(), this.chalkError("[ERROR]"), this.chalkModule(`[${module}]`), ...messageOrObject);
                }
                info(module, ...messageOrObject) {
                    console.log(this.getTimestamp(), this.chalkInfo("[INFO]"), this.chalkModule(`[${module}]`), ...messageOrObject);
                }
                warn(module, ...messageOrObject) {
                    console.warn(this.getTimestamp(), this.chalkWarning("[WARN]"), this.chalkModule(`[${module}]`), ...messageOrObject);
                }
            };
            exports_49("RichConsoleLogger", RichConsoleLogger);
        }
    };
});
System.register("mixins/AutojoinRoomsMixin", [], function (exports_50, context_50) {
    "use strict";
    var AutojoinRoomsMixin;
    var __moduleName = context_50 && context_50.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Automatically accepts invites for rooms
             * @category Mixins
             */
            AutojoinRoomsMixin = class AutojoinRoomsMixin {
                static setupOnClient(client) {
                    client.on("room.invite", (roomId, inviteEvent) => {
                        return client.joinRoom(roomId);
                    });
                }
                static setupOnAppservice(appservice, conditional = null) {
                    appservice.on("room.invite", (roomId, inviteEvent) => {
                        const isFromBot = appservice.botUserId === inviteEvent["sender"];
                        if (!isFromBot && conditional && !conditional(inviteEvent))
                            return;
                        const intent = appservice.getIntentForUserId(inviteEvent["state_key"]);
                        return intent.joinRoom(roomId);
                    });
                }
            };
            exports_50("AutojoinRoomsMixin", AutojoinRoomsMixin);
        }
    };
});
System.register("mixins/AutojoinUpgradedRoomsMixin", [], function (exports_51, context_51) {
    "use strict";
    var AutojoinUpgradedRoomsMixin;
    var __moduleName = context_51 && context_51.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Automatically tries to join upgraded rooms
             * @category Mixins
             */
            AutojoinUpgradedRoomsMixin = class AutojoinUpgradedRoomsMixin {
                static setupOnClient(client) {
                    client.on("room.archived", (roomId, tombstoneEvent) => {
                        if (!tombstoneEvent['content'])
                            return;
                        if (!tombstoneEvent['sender'])
                            return;
                        if (!tombstoneEvent['content']['replacement_room'])
                            return;
                        const serverName = tombstoneEvent['sender'].split(':').splice(1).join(':');
                        return client.joinRoom(tombstoneEvent['content']['replacement_room'], [serverName]);
                    });
                }
                static setupOnAppservice(appservice) {
                    appservice.on("room.archived", (roomId, tombstoneEvent) => __awaiter(this, void 0, void 0, function* () {
                        if (!tombstoneEvent['content'])
                            return;
                        if (!tombstoneEvent['sender'])
                            return;
                        if (!tombstoneEvent['content']['replacement_room'])
                            return;
                        const newRoomId = tombstoneEvent['content']['replacement_room'];
                        const serverName = tombstoneEvent['sender'].split(':').splice(1).join(':');
                        const botClient = appservice.botIntent.underlyingClient;
                        yield botClient.joinRoom(newRoomId, [serverName]);
                        const userIds = yield botClient.getJoinedRoomMembers(roomId);
                        const joinUserIds = userIds.filter(u => u !== appservice.botUserId && appservice.isNamespacedUser(u));
                        return yield Promise.all(joinUserIds.map(u => appservice.getIntentForUserId(u).joinRoom(newRoomId)));
                    }));
                }
            };
            exports_51("AutojoinUpgradedRoomsMixin", AutojoinUpgradedRoomsMixin);
        }
    };
});
System.register("models/events/PresenceEvent", ["models/events/Event"], function (exports_52, context_52) {
    "use strict";
    var Event_2, PresenceEvent;
    var __moduleName = context_52 && context_52.id;
    return {
        setters: [
            function (Event_2_1) {
                Event_2 = Event_2_1;
            }
        ],
        execute: function () {
            /**
             * Wraps a m.presence ephemeral event in Matrix
             * @category Matrix events
             */
            PresenceEvent = class PresenceEvent extends Event_2.MatrixEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The current presence state for the user.
                 */
                get presence() {
                    return this.content.presence;
                }
            };
            exports_52("PresenceEvent", PresenceEvent);
        }
    };
});
System.register("models/Presence", [], function (exports_53, context_53) {
    "use strict";
    var Presence;
    var __moduleName = context_53 && context_53.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Presence information for a user.
             * @category Models
             */
            Presence = class Presence {
                constructor(presence) {
                    this.presence = presence;
                }
                /**
                 * The state for this presence update.
                 */
                get state() {
                    return this.presence.presence;
                }
                /**
                 * The status message which accompanies this presence. May be falsey.
                 */
                get statusMessage() {
                    return this.presence.status_msg;
                }
                /**
                 * How long ago in milliseconds this presence was changed. May be falsey.
                 */
                get lastActiveAgo() {
                    return this.presence.last_active_ago;
                }
                /**
                 * Whether or not the user is currently active.
                 */
                get currentlyActive() {
                    return this.presence.currently_active;
                }
            };
            exports_53("Presence", Presence);
        }
    };
});
System.register("models/EventContext", [], function (exports_54, context_54) {
    "use strict";
    var __moduleName = context_54 && context_54.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("models/PowerLevelBounds", [], function (exports_55, context_55) {
    "use strict";
    var __moduleName = context_55 && context_55.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("simple-validation", [], function (exports_56, context_56) {
    "use strict";
    var __moduleName = context_56 && context_56.id;
    /**
     * Validate the 'order' parameter of a child space entry. It must be a
     * string between the range of \x20 - \x7F and contain no more than 50
     * characters.
     * @param {string} order The 'order' parameter of a m.space.child
     * @throws {Error} If the string is not valid
     * @returns {boolean} True if the string is valid
     */
    function validateSpaceOrderString(order) {
        if (typeof (order) !== 'string') {
            // Just in case, even though TS should catch this.
            throw Error('order is not a string');
        }
        if (order.length === 0) {
            throw Error('order cannot be empty');
        }
        if (order.length > 50) {
            throw Error('order is more than 50 characters and is disallowed');
        }
        if (!order.match(/^[\x20-\x7E]+$/)) {
            // String must be between this range
            throw Error('order contained characters outside the range of the spec.');
        }
        return true;
    }
    exports_56("validateSpaceOrderString", validateSpaceOrderString);
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("models/events/SpaceChildEvent", ["models/events/RoomEvent"], function (exports_57, context_57) {
    "use strict";
    var RoomEvent_6, SpaceChildEvent;
    var __moduleName = context_57 && context_57.id;
    return {
        setters: [
            function (RoomEvent_6_1) {
                RoomEvent_6 = RoomEvent_6_1;
            }
        ],
        execute: function () {
            /**
             * Represents an m.space.child state event
             * @category Matrix events
             */
            SpaceChildEvent = class SpaceChildEvent extends RoomEvent_6.StateEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The room ID of the space or room this child represents.
                 */
                get entityRoomId() {
                    return this.stateKey;
                }
                /**
                 * Whether or not this child is "active" or valid. Inactive children are
                 * not considered part of a space.
                 */
                get isActiveChild() {
                    var _a;
                    return !!((_a = this.viaServers) === null || _a === void 0 ? void 0 : _a.length);
                }
                /**
                 * The servers the client should provide to the homeserver when trying to
                 * join the entity (room). May be empty or falsey to denote the child is
                 * inactive.
                 */
                get viaServers() {
                    return this.content.via;
                }
                /**
                 * An optional short string to differentiate the rendering order of entities.
                 * @see validateSpaceOrderString
                 */
                get order() {
                    return this.content.order;
                }
                /**
                 * Whether or not the child is a suggested entity for users to join.
                 */
                get suggested() {
                    var _a;
                    return (_a = this.content.suggested) !== null && _a !== void 0 ? _a : false;
                }
            };
            exports_57("SpaceChildEvent", SpaceChildEvent);
        }
    };
});
System.register("models/Spaces", ["helpers/MatrixEntity", "simple-validation", "models/events/SpaceChildEvent"], function (exports_58, context_58) {
    "use strict";
    var MatrixEntity_1, simple_validation_1, SpaceChildEvent_1, Space;
    var __moduleName = context_58 && context_58.id;
    return {
        setters: [
            function (MatrixEntity_1_1) {
                MatrixEntity_1 = MatrixEntity_1_1;
            },
            function (simple_validation_1_1) {
                simple_validation_1 = simple_validation_1_1;
            },
            function (SpaceChildEvent_1_1) {
                SpaceChildEvent_1 = SpaceChildEvent_1_1;
            }
        ],
        execute: function () {
            /**
             * An instance representing a Matrix Space. A space is tied to a room.
             * @category Models
             */
            Space = class Space {
                constructor(roomId, client) {
                    this.roomId = roomId;
                    this.client = client;
                }
                /**
                 * Creates a new child space under this space.
                 * @param {SpaceCreateOptions} opts The options for the new space.
                 * @returns {Promise<Space>} Resolves to the created space.
                 */
                createChildSpace(opts) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const space = yield this.client.createSpace(opts);
                        yield this.addChildSpace(space, opts);
                        return space;
                    });
                }
                /**
                 * Adds a child space to the space. Must be joined to both spaces.
                 * @param {Space} space The space to add.
                 * @param {SpaceChildEntityOptions} childOpts Related options for the child's representation.
                 * @returns {Promise<Space>} Resolves when complete.
                 */
                addChildSpace(space, childOpts = {}) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.addChildRoom(space.roomId, childOpts);
                    });
                }
                /**
                 * Removes a child space from the space. Must be joined to the current space (not needed for child space).
                 * @param {Space} space The space to remove.
                 * @returns {Promise<void>} Resolves when complete.
                 */
                removeChildSpace(space) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.removeChildRoom(space.roomId);
                    });
                }
                /**
                 * Adds a child room to the space. Must be joined to both the room and the space.
                 * @param {string} roomId The room ID to add.
                 * @param {SpaceChildEntityOptions} childOpts Additional options for the child space.
                 * @returns {Promise<void>} Resolves when complete.
                 */
                addChildRoom(roomId, childOpts = {}) {
                    var _a;
                    return __awaiter(this, void 0, void 0, function* () {
                        const via = (_a = childOpts.via) !== null && _a !== void 0 ? _a : [new MatrixEntity_1.UserID(yield this.client.getUserId()).domain];
                        const childContent = { via };
                        if (childOpts.suggested)
                            childContent.suggested = childOpts.suggested;
                        if (childOpts.order) {
                            simple_validation_1.validateSpaceOrderString(childOpts.order);
                            childContent.order = childOpts.order;
                        }
                        yield this.client.sendStateEvent(this.roomId, "m.space.child", roomId, childContent);
                    });
                }
                /**
                 * Removes a child room from the space. Must be joined to the current space (not needed for child room).
                 * @param {string} roomId The room ID to remove.
                 * @returns {Promise<void>} Resolves when complete.
                 */
                removeChildRoom(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.client.sendStateEvent(this.roomId, "m.space.child", roomId, {});
                    });
                }
                /**
                 * Gets all the child rooms on the space. These may be spaces or other rooms.
                 * @returns {Promise<SpaceEntityMap>} Resolves to a map of children for this space.
                 */
                getChildEntities() {
                    return __awaiter(this, void 0, void 0, function* () {
                        const roomState = yield this.client.getRoomState(this.roomId);
                        let mapping = {};
                        roomState
                            .filter(s => s.type === "m.space.child")
                            .filter(s => { var _a; return (_a = s.content) === null || _a === void 0 ? void 0 : _a.via; })
                            .forEach(s => mapping[s.state_key] = new SpaceChildEvent_1.SpaceChildEvent(s));
                        return mapping;
                    });
                }
                /**
                 * Invite a user to the current space.
                 * @param {string} userId The user ID to invite.
                 * @returns {Promise<void>} Resolves when completed.
                 */
                inviteUser(userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.inviteUser(userId, this.roomId);
                    });
                }
            };
            exports_58("Space", Space);
        }
    };
});
System.register("models/Account", [], function (exports_59, context_59) {
    "use strict";
    var __moduleName = context_59 && context_59.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("models/events/EventKind", [], function (exports_60, context_60) {
    "use strict";
    var EventKind;
    var __moduleName = context_60 && context_60.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Represents the different kinds of events a bot/appservice might see.
             * @category Matrix events
             */
            (function (EventKind) {
                /**
                 * A room event. This could be a message event or a state event, and is associated with
                 * a room.
                 */
                EventKind["RoomEvent"] = "room";
                /**
                 * An ephemeral event, such as typing notifications or presence.
                 */
                EventKind["EphemeralEvent"] = "ephemeral";
            })(EventKind || (EventKind = {}));
            exports_60("EventKind", EventKind);
        }
    };
});
System.register("models/events/converter", ["models/events/MembershipEvent", "models/events/RoomEvent", "models/events/MessageEvent"], function (exports_61, context_61) {
    "use strict";
    var MembershipEvent_2, RoomEvent_7, MessageEvent_1;
    var __moduleName = context_61 && context_61.id;
    /**
     * Wraps a room event into a more suitable container.
     * @param {any} event The event object to wrap.
     * @returns {RoomEvent<any>} An instance of the most suitable container for the event.
     * @category Matrix events
     */
    function wrapRoomEvent(event) {
        if (!event)
            return null;
        if (typeof (event['state_key']) === 'string') {
            if (event['type'] === 'm.room.member') {
                return new MembershipEvent_2.MembershipEvent(event);
            }
            else {
                return new RoomEvent_7.StateEvent(event);
            }
        }
        else if (event['type'] === 'm.room.message') {
            const content = event['content'];
            const msgtype = content ? content['msgtype'] : null;
            if (msgtype === "m.text" || msgtype === "m.notice" || msgtype === "m.emote") {
                return new MessageEvent_1.MessageEvent(event);
            }
            else if (msgtype === "m.audio") {
                return new MessageEvent_1.MessageEvent(event);
            }
            else if (msgtype === "m.video") {
                return new MessageEvent_1.MessageEvent(event);
            }
            else if (msgtype === "m.image") {
                return new MessageEvent_1.MessageEvent(event);
            }
            else if (msgtype === "m.location") {
                return new MessageEvent_1.MessageEvent(event);
            }
            else {
                return new MessageEvent_1.MessageEvent(event);
            }
        }
        else {
            return new RoomEvent_7.RoomEvent(event);
        }
    }
    exports_61("wrapRoomEvent", wrapRoomEvent);
    return {
        setters: [
            function (MembershipEvent_2_1) {
                MembershipEvent_2 = MembershipEvent_2_1;
            },
            function (RoomEvent_7_1) {
                RoomEvent_7 = RoomEvent_7_1;
            },
            function (MessageEvent_1_1) {
                MessageEvent_1 = MessageEvent_1_1;
            }
        ],
        execute: function () {
        }
    };
});
System.register("models/events/AliasesEvent", ["models/events/RoomEvent"], function (exports_62, context_62) {
    "use strict";
    var RoomEvent_8, AliasesEvent;
    var __moduleName = context_62 && context_62.id;
    return {
        setters: [
            function (RoomEvent_8_1) {
                RoomEvent_8 = RoomEvent_8_1;
            }
        ],
        execute: function () {
            /**
             * Represents an m.room.aliases state event
             * @category Matrix events
             */
            AliasesEvent = class AliasesEvent extends RoomEvent_8.StateEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The domain the aliases belong to.
                 */
                get forDomain() {
                    return this.stateKey;
                }
                /**
                 * The aliases the domain has published to the room.
                 */
                get aliases() {
                    return this.content.aliases || [];
                }
            };
            exports_62("AliasesEvent", AliasesEvent);
        }
    };
});
System.register("models/events/CanonicalAliasEvent", ["models/events/RoomEvent"], function (exports_63, context_63) {
    "use strict";
    var RoomEvent_9, CanonicalAliasEvent;
    var __moduleName = context_63 && context_63.id;
    return {
        setters: [
            function (RoomEvent_9_1) {
                RoomEvent_9 = RoomEvent_9_1;
            }
        ],
        execute: function () {
            /**
             * Represents an m.room.canonical_alias state event
             * @category Matrix events
             */
            CanonicalAliasEvent = class CanonicalAliasEvent extends RoomEvent_9.StateEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The alias the room is considering canonical
                 */
                get aliases() {
                    return this.content.alias;
                }
            };
            exports_63("CanonicalAliasEvent", CanonicalAliasEvent);
        }
    };
});
System.register("models/events/CreateEvent", ["models/events/RoomEvent"], function (exports_64, context_64) {
    "use strict";
    var RoomEvent_10, CreateEvent;
    var __moduleName = context_64 && context_64.id;
    return {
        setters: [
            function (RoomEvent_10_1) {
                RoomEvent_10 = RoomEvent_10_1;
            }
        ],
        execute: function () {
            /**
             * Represents an m.room.create state event
             * @category Matrix events
             */
            CreateEvent = class CreateEvent extends RoomEvent_10.StateEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The user ID who created the room.
                 */
                get creator() {
                    return this.content.creator || this.sender;
                }
                /**
                 * The version of the room. Defaults to "1".
                 */
                get version() {
                    return this.content.room_version || "1";
                }
                /**
                 * Whether or not the room is federated. Default true (federated).
                 */
                get federated() {
                    return this.content['m.federate'] !== false;
                }
            };
            exports_64("CreateEvent", CreateEvent);
        }
    };
});
System.register("models/events/JoinRulesEvent", ["models/events/RoomEvent"], function (exports_65, context_65) {
    "use strict";
    var RoomEvent_11, JoinRulesEvent;
    var __moduleName = context_65 && context_65.id;
    return {
        setters: [
            function (RoomEvent_11_1) {
                RoomEvent_11 = RoomEvent_11_1;
            }
        ],
        execute: function () {
            /**
             * Represents an m.room.join_rules state event
             * @category Matrix events
             */
            JoinRulesEvent = class JoinRulesEvent extends RoomEvent_11.StateEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The join rule for the room.
                 */
                get rule() {
                    return this.content.join_rule;
                }
            };
            exports_65("JoinRulesEvent", JoinRulesEvent);
        }
    };
});
System.register("models/events/PowerLevelsEvent", ["models/events/RoomEvent"], function (exports_66, context_66) {
    "use strict";
    var RoomEvent_12, PowerLevelsEvent;
    var __moduleName = context_66 && context_66.id;
    function defaultNum(val, def) {
        if (!val && val !== 0)
            return def;
        return val;
    }
    return {
        setters: [
            function (RoomEvent_12_1) {
                RoomEvent_12 = RoomEvent_12_1;
            }
        ],
        execute: function () {
            /**
             * Represents an m.room.power_levels state event
             * @category Matrix events
             */
            PowerLevelsEvent = class PowerLevelsEvent extends RoomEvent_12.StateEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The power level required to ban users.
                 */
                get banLevel() {
                    return defaultNum(this.content.ban, 50);
                }
                /**
                 * The power level required to invite users.
                 */
                get inviteLevel() {
                    return defaultNum(this.content.invite, 50);
                }
                /**
                 * The power level required to kick users.
                 */
                get kickLevel() {
                    return defaultNum(this.content.kick, 50);
                }
                /**
                 * The power level required to redact messages sent by other users.
                 */
                get redactLevel() {
                    return defaultNum(this.content.redact, 50);
                }
                /**
                 * The power level required to send "@room" notifications.
                 */
                get notifyWholeRoomLevel() {
                    if (!this.content.notifications)
                        return 50;
                    return defaultNum(this.content.notifications.room, 50);
                }
                /**
                 * The default power level for users.
                 */
                get defaultUserLevel() {
                    return defaultNum(this.content.users_default, 0);
                }
                /**
                 * The default power level required to send state events.
                 */
                get defaultStateEventLevel() {
                    return defaultNum(this.content.state_default, 50);
                }
                /**
                 * The default power level required to send room events.
                 */
                get defaultEventLevel() {
                    return defaultNum(this.content.events_default, 50);
                }
            };
            exports_66("PowerLevelsEvent", PowerLevelsEvent);
        }
    };
});
System.register("models/events/RedactionEvent", ["models/events/RoomEvent"], function (exports_67, context_67) {
    "use strict";
    var RoomEvent_13, RedactionEvent;
    var __moduleName = context_67 && context_67.id;
    return {
        setters: [
            function (RoomEvent_13_1) {
                RoomEvent_13 = RoomEvent_13_1;
            }
        ],
        execute: function () {
            /**
             * Represents an m.room.redaction room event
             * @category Matrix events
             */
            RedactionEvent = class RedactionEvent extends RoomEvent_13.RoomEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The event ID this event redacts.
                 * @deprecated It is possible for multiple events to be redacted depending on the room version.
                 */
                get redactsEventId() {
                    return this.redactsEventIds[0];
                }
                /**
                 * The event IDs this event redacts.
                 */
                get redactsEventIds() {
                    if (Array.isArray(this.content.redacts)) {
                        return this.content.redacts;
                    }
                    else if (this.content.redacts) {
                        return [this.content.redacts];
                    }
                    else {
                        return [this.event['redacts']];
                    }
                }
            };
            exports_67("RedactionEvent", RedactionEvent);
        }
    };
});
System.register("models/events/PinnedEventsEvent", ["models/events/RoomEvent"], function (exports_68, context_68) {
    "use strict";
    var RoomEvent_14, PinnedEventsEvent;
    var __moduleName = context_68 && context_68.id;
    return {
        setters: [
            function (RoomEvent_14_1) {
                RoomEvent_14 = RoomEvent_14_1;
            }
        ],
        execute: function () {
            /**
             * Represents an m.room.pinned_events state event
             * @category Matrix events
             */
            PinnedEventsEvent = class PinnedEventsEvent extends RoomEvent_14.StateEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The event IDs that are pinned in the room.
                 */
                get pinnedEventIds() {
                    return this.content.pinned || [];
                }
            };
            exports_68("PinnedEventsEvent", PinnedEventsEvent);
        }
    };
});
System.register("models/events/RoomAvatarEvent", ["models/events/RoomEvent"], function (exports_69, context_69) {
    "use strict";
    var RoomEvent_15, RoomAvatarEvent;
    var __moduleName = context_69 && context_69.id;
    return {
        setters: [
            function (RoomEvent_15_1) {
                RoomEvent_15 = RoomEvent_15_1;
            }
        ],
        execute: function () {
            /**
             * Represents an m.room.avatar state event
             * @category Matrix events
             */
            RoomAvatarEvent = class RoomAvatarEvent extends RoomEvent_15.StateEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The URL for the avatar of the room.
                 */
                get avatarUrl() {
                    return this.content.url;
                }
            };
            exports_69("RoomAvatarEvent", RoomAvatarEvent);
        }
    };
});
System.register("models/events/RoomNameEvent", ["models/events/RoomEvent"], function (exports_70, context_70) {
    "use strict";
    var RoomEvent_16, RoomNameEvent;
    var __moduleName = context_70 && context_70.id;
    return {
        setters: [
            function (RoomEvent_16_1) {
                RoomEvent_16 = RoomEvent_16_1;
            }
        ],
        execute: function () {
            /**
             * Represents an m.room.name state event
             * @category Matrix events
             */
            RoomNameEvent = class RoomNameEvent extends RoomEvent_16.StateEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The name of the room.
                 */
                get name() {
                    return this.content.name;
                }
            };
            exports_70("RoomNameEvent", RoomNameEvent);
        }
    };
});
System.register("models/events/RoomTopicEvent", ["models/events/RoomEvent"], function (exports_71, context_71) {
    "use strict";
    var RoomEvent_17, RoomTopicEvent;
    var __moduleName = context_71 && context_71.id;
    return {
        setters: [
            function (RoomEvent_17_1) {
                RoomEvent_17 = RoomEvent_17_1;
            }
        ],
        execute: function () {
            /**
             * Represents an m.room.topic state event
             * @category Matrix events
             */
            RoomTopicEvent = class RoomTopicEvent extends RoomEvent_17.StateEvent {
                constructor(event) {
                    super(event);
                }
                /**
                 * The topic of the room.
                 */
                get topic() {
                    return this.content.topic;
                }
            };
            exports_71("RoomTopicEvent", RoomTopicEvent);
        }
    };
});
System.register("preprocessors/IPreprocessor", [], function (exports_72, context_72) {
    "use strict";
    var __moduleName = context_72 && context_72.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("preprocessors/RichRepliesPreprocessor", ["index"], function (exports_73, context_73) {
    "use strict";
    var __7, RichRepliesPreprocessor;
    var __moduleName = context_73 && context_73.id;
    return {
        setters: [
            function (__7_1) {
                __7 = __7_1;
            }
        ],
        execute: function () {
            /**
             * Processes rich replies found in events. This automatically strips
             * the fallback representation from events, providing the information
             * as a top level "mx_richreply" key. The "mx_richreply" property may
             * be casted to the type IRichReplyMetadata.
             * @category Preprocessors
             */
            RichRepliesPreprocessor = class RichRepliesPreprocessor {
                /**
                 * Creates a new rich replies preprocessor.
                 * @param fetchRealEventContents If enabled, this preprocessor will
                 * attempt to get the real event contents and append them to the event
                 * information.
                 */
                constructor(fetchRealEventContents = false) {
                    this.fetchRealEventContents = fetchRealEventContents;
                }
                getSupportedEventTypes() {
                    return ["m.room.message"];
                }
                processEvent(event, client, kind) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (kind && kind !== __7.EventKind.RoomEvent)
                            return;
                        if (!event["content"])
                            return;
                        if (!event["content"]["m.relates_to"])
                            return;
                        if (!event["content"]["m.relates_to"]["m.in_reply_to"])
                            return;
                        const parentEventId = event["content"]["m.relates_to"]["m.in_reply_to"]["event_id"];
                        if (!parentEventId)
                            return;
                        let fallbackHtml = "";
                        let fallbackText = "";
                        let fallbackSender = "";
                        let realHtml = event["content"]["formatted_body"];
                        let realText = event["content"]["body"];
                        let lenient = false;
                        if (event["content"]["format"] !== "org.matrix.custom.html" || !event["content"]["formatted_body"]) {
                            lenient = true; // Not safe to parse: probably not HTML
                        }
                        else {
                            const formattedBody = event["content"]["formatted_body"];
                            if (!formattedBody.startsWith("<mx-reply>") || formattedBody.indexOf("</mx-reply>") === -1) {
                                lenient = true; // Doesn't look like a reply
                            }
                            else {
                                const parts = formattedBody.split("</mx-reply>");
                                const fbHtml = parts[0];
                                realHtml = parts[1];
                                const results = fbHtml.match(/<br[ ]*[\/]{0,2}>(.*)<\/blockquote>\s*$/i);
                                if (!results) {
                                    lenient = true;
                                }
                                else {
                                    fallbackHtml = results[1];
                                }
                            }
                        }
                        let lastLine = "";
                        let processedFallback = false;
                        const body = event["content"]["body"] || "";
                        for (const line of body.split("\n")) {
                            if (line.startsWith("> ") && !processedFallback) {
                                fallbackText += line.substring(2) + "\n";
                                lastLine = line;
                            }
                            else if (!processedFallback) {
                                lastLine = line;
                                realText = "";
                                processedFallback = true;
                            }
                            else {
                                realText += line + "\n";
                            }
                        }
                        const firstFallbackLine = fallbackText.split("\n")[0];
                        const matches = firstFallbackLine.match(/<(@.*:.*)>/);
                        if (!matches) {
                            lenient = true;
                        }
                        else {
                            fallbackSender = matches[1];
                        }
                        const metadata = {
                            wasLenient: lenient,
                            fallbackHtmlBody: fallbackHtml ? fallbackHtml.trim() : "",
                            fallbackPlainBody: fallbackText ? fallbackText.trim() : "",
                            fallbackSender: fallbackSender ? fallbackSender.trim() : "",
                            parentEventId: parentEventId ? parentEventId.trim() : "",
                            realEvent: null,
                        };
                        if (this.fetchRealEventContents) {
                            try {
                                metadata.realEvent = yield client.getEvent(event["room_id"], parentEventId);
                            }
                            catch (e) {
                                __7.LogService.error("RichRepliesPreprocessor", "Failed to fetch real event:");
                                __7.LogService.error("RichRepliesPreprocessor", __7.extractRequestError(e));
                                metadata.wasLenient = true; // failed to fetch event
                            }
                        }
                        event["mx_richreply"] = metadata;
                        event["content"]["body"] = realText.trim();
                        event["content"]["formatted_body"] = realHtml.trim();
                        return event;
                    });
                }
            };
            exports_73("RichRepliesPreprocessor", RichRepliesPreprocessor);
        }
    };
});
System.register("storage/SimpleFsStorageProvider", ["lowdb", "lowdb/adapters/FileSync", "hash.js/lib/hash/sha/512", "mkdirp", "path"], function (exports_74, context_74) {
    "use strict";
    var lowdb, FileSync, sha512, mkdirp, path, SimpleFsStorageProvider, NamespacedFsProvider;
    var __moduleName = context_74 && context_74.id;
    return {
        setters: [
            function (lowdb_1) {
                lowdb = lowdb_1;
            },
            function (FileSync_1) {
                FileSync = FileSync_1;
            },
            function (sha512_1) {
                sha512 = sha512_1;
            },
            function (mkdirp_1) {
                mkdirp = mkdirp_1;
            },
            function (path_1) {
                path = path_1;
            }
        ],
        execute: function () {
            /**
             * A storage provider that uses the disk to store information.
             * @category Storage providers
             */
            SimpleFsStorageProvider = class SimpleFsStorageProvider {
                /**
                 * Creates a new simple file system storage provider.
                 * @param {string} filename The file name (typically 'storage.json') to store data within.
                 * @param {boolean} trackTransactionsInMemory True (default) to track all received appservice transactions rather than on disk.
                 * @param {int} maxInMemoryTransactions The maximum number of transactions to hold in memory before rotating the oldest out. Defaults to 20.
                 */
                constructor(filename, trackTransactionsInMemory = true, maxInMemoryTransactions = 20) {
                    this.trackTransactionsInMemory = trackTransactionsInMemory;
                    this.maxInMemoryTransactions = maxInMemoryTransactions;
                    this.completedTransactions = [];
                    mkdirp.sync(path.dirname(filename));
                    const adapter = new FileSync(filename);
                    this.db = lowdb(adapter);
                    this.db.defaults({
                        syncToken: null,
                        filter: null,
                        appserviceUsers: {},
                        appserviceTransactions: {},
                        kvStore: {}, // key => value (str)
                    }).write();
                }
                setSyncToken(token) {
                    this.db.set('syncToken', token).write();
                }
                getSyncToken() {
                    return this.db.get('syncToken').value();
                }
                setFilter(filter) {
                    this.db.set('filter', filter).write();
                }
                getFilter() {
                    return this.db.get('filter').value();
                }
                addRegisteredUser(userId) {
                    const key = sha512().update(userId).digest('hex');
                    this.db
                        .set(`appserviceUsers.${key}.userId`, userId)
                        .set(`appserviceUsers.${key}.registered`, true)
                        .write();
                }
                isUserRegistered(userId) {
                    const key = sha512().update(userId).digest('hex');
                    return this.db.get(`appserviceUsers.${key}.registered`).value();
                }
                isTransactionCompleted(transactionId) {
                    if (this.trackTransactionsInMemory) {
                        return this.completedTransactions.indexOf(transactionId) !== -1;
                    }
                    const key = sha512().update(transactionId).digest('hex');
                    return this.db.get(`appserviceTransactions.${key}.completed`).value();
                }
                setTransactionCompleted(transactionId) {
                    if (this.trackTransactionsInMemory) {
                        if (this.completedTransactions.indexOf(transactionId) === -1) {
                            this.completedTransactions.push(transactionId);
                        }
                        if (this.completedTransactions.length > this.maxInMemoryTransactions) {
                            this.completedTransactions = this.completedTransactions.reverse().slice(0, this.maxInMemoryTransactions).reverse();
                        }
                        return;
                    }
                    const key = sha512().update(transactionId).digest('hex');
                    this.db
                        .set(`appserviceTransactions.${key}.txnId`, transactionId)
                        .set(`appserviceTransactions.${key}.completed`, true)
                        .write();
                }
                readValue(key) {
                    return this.db.get("kvStore").value()[key];
                }
                storeValue(key, value) {
                    const kvStore = this.db.get("kvStore").value();
                    kvStore[key] = value;
                    this.db.set("kvStore", kvStore).write();
                }
                storageForUser(userId) {
                    return new NamespacedFsProvider(userId, this);
                }
            };
            exports_74("SimpleFsStorageProvider", SimpleFsStorageProvider);
            /**
             * A namespaced storage provider that uses the disk to store information.
             * @category Storage providers
             */
            NamespacedFsProvider = class NamespacedFsProvider {
                constructor(prefix, parent) {
                    this.prefix = prefix;
                    this.parent = parent;
                }
                setFilter(filter) {
                    return this.parent.storeValue(`${this.prefix}_int_filter`, JSON.stringify(filter));
                }
                getFilter() {
                    return Promise.resolve(this.parent.readValue(`${this.prefix}_int_filter`)).then(r => r ? JSON.parse(r) : r);
                }
                setSyncToken(token) {
                    return this.parent.storeValue(`${this.prefix}_int_syncToken`, token);
                }
                getSyncToken() {
                    return Promise.resolve(this.parent.readValue(`${this.prefix}_int_syncToken`)).then(r => r !== null && r !== void 0 ? r : null);
                }
                readValue(key) {
                    return this.parent.readValue(`${this.prefix}_kv_${key}`);
                }
                storeValue(key, value) {
                    return this.parent.storeValue(`${this.prefix}_kv_${key}`, value);
                }
            };
        }
    };
});
System.register("strategies/AppserviceJoinRoomStrategy", [], function (exports_75, context_75) {
    "use strict";
    var AppserviceJoinRoomStrategy;
    var __moduleName = context_75 && context_75.id;
    return {
        setters: [],
        execute: function () {
            /**
             * A join strategy for application services that proxies joins to an underlying join
             * strategy while also trying to use the appservice's bot user to invite the underlying
             * user if needed.
             * @category Join strategies
             */
            AppserviceJoinRoomStrategy = class AppserviceJoinRoomStrategy {
                constructor(underlyingStrategy, appservice) {
                    this.underlyingStrategy = underlyingStrategy;
                    this.appservice = appservice;
                }
                joinRoom(roomIdOrAlias, userId, apiCall) {
                    return __awaiter(this, void 0, void 0, function* () {
                        try {
                            // First just try joining via the apiCall
                            return yield apiCall(roomIdOrAlias);
                        }
                        catch (err) {
                            // If the user being joined is *not* the bridge bot, try and get the bridge bot to
                            // join them to the room.
                            if (userId !== this.appservice.botUserId) {
                                const client = this.appservice.botIntent.underlyingClient;
                                const roomId = yield client.resolveRoom(roomIdOrAlias);
                                try {
                                    // First start with having the bridge bot invite the user to the room
                                    yield client.inviteUser(userId, roomId);
                                }
                                catch (inviteErr) {
                                    // The invite failed - use the underlying join strategy to join the room, just in case.
                                    // If there's no join strategy, we want to fall through to an error.
                                    if (this.underlyingStrategy)
                                        return this.underlyingStrategy.joinRoom(roomId, userId, apiCall);
                                    throw inviteErr;
                                }
                                // The invite succeeded - use the underlying join strategy to join the room or just call use
                                // the apiCall if no strategy exists. We are expecting success.
                                if (this.underlyingStrategy)
                                    return this.underlyingStrategy.joinRoom(roomId, userId, apiCall);
                                else
                                    return apiCall(roomId);
                            }
                            else if (this.underlyingStrategy) {
                                // If the user being joined *is* the bridge bot, try and use the join strategy to join.
                                return this.underlyingStrategy.joinRoom(roomIdOrAlias, userId, apiCall);
                            }
                            // Finally, if all else fails, throw.
                            throw err;
                        }
                    });
                }
            };
            exports_75("AppserviceJoinRoomStrategy", AppserviceJoinRoomStrategy);
        }
    };
});
System.register("MatrixAuth", ["MatrixClient"], function (exports_76, context_76) {
    "use strict";
    var MatrixClient_1, MatrixAuth;
    var __moduleName = context_76 && context_76.id;
    return {
        setters: [
            function (MatrixClient_1_1) {
                MatrixClient_1 = MatrixClient_1_1;
            }
        ],
        execute: function () {
            /**
             * Functions for interacting with Matrix prior to having an access token. Intended
             * to be used for logging in/registering to get a MatrixClient instance.
             *
             * By design, this limits the options used to create the MatrixClient. To specify
             * custom elements to the client, get the access token from the returned client
             * and create a new MatrixClient instance. Due to the nature of Matrix, it is
             * also recommended to use the homeserverUrl from the generated MatrixClient as
             * it may be different from that given to the MatrixAuth class.
             */
            MatrixAuth = class MatrixAuth {
                /**
                 * Creates a new MatrixAuth class for creating a MatrixClient
                 * @param {string} homeserverUrl The homeserver URL to authenticate against.
                 */
                constructor(homeserverUrl) {
                    this.homeserverUrl = homeserverUrl;
                    // nothing to do
                }
                /**
                 * Generate a client with no access token so we can reuse the doRequest
                 * logic already written.
                 */
                createTemplateClient() {
                    return new MatrixClient_1.MatrixClient(this.homeserverUrl, "");
                }
                /**
                 * Performs simple registration using a password for the account. This will
                 * assume the server supports the m.login.password flow for registration, and
                 * will attempt to complete only that stage. The caller is expected to determine
                 * if the homeserver supports registration prior to invocation.
                 * @param {string} localpart The localpart (username) to register
                 * @param {string} password The password to register with
                 * @param {string} deviceName The name of the newly created device. Optional.
                 * @returns {Promise<MatrixClient>} Resolves to a logged-in MatrixClient
                 */
                passwordRegister(localpart, password, deviceName) {
                    return __awaiter(this, void 0, void 0, function* () {
                        // First try and complete the stage without UIA in hopes the server is kind to us:
                        const body = {
                            username: localpart,
                            password: password,
                            initial_device_display_name: deviceName,
                        };
                        let response;
                        try {
                            response = yield this.createTemplateClient().doRequest("POST", "/_matrix/client/r0/register", null, body);
                        }
                        catch (e) {
                            if (e.statusCode === 401) {
                                if (typeof (e.body) === "string")
                                    e.body = JSON.parse(e.body);
                                if (!e.body)
                                    throw new Error(JSON.stringify(Object.keys(e)));
                                // 401 means we need to do UIA, so try and complete a stage
                                const sessionId = e.body['session'];
                                const expectedFlow = ["m.login.dummy"];
                                let hasFlow = false;
                                for (const flow of e.body['flows']) {
                                    const stages = flow['stages'];
                                    if (stages.length !== expectedFlow.length)
                                        continue;
                                    let stagesMatch = true;
                                    for (let i = 0; i < stages.length; i++) {
                                        if (stages[i] !== expectedFlow[i]) {
                                            stagesMatch = false;
                                            break;
                                        }
                                    }
                                    if (stagesMatch) {
                                        hasFlow = true;
                                        break;
                                    }
                                }
                                if (!hasFlow)
                                    throw new Error("Failed to find appropriate login flow in User-Interactive Authentication");
                                body['auth'] = {
                                    type: expectedFlow[0],
                                    session: sessionId,
                                };
                                response = yield this.createTemplateClient().doRequest("POST", "/_matrix/client/r0/register", null, body);
                            }
                        }
                        if (!response)
                            throw new Error("Failed to register");
                        const accessToken = response['access_token'];
                        if (!accessToken)
                            throw new Error("No access token returned");
                        return new MatrixClient_1.MatrixClient(this.homeserverUrl, accessToken);
                    });
                }
                /**
                 * Performs simple password login with the homeserver. The caller is
                 * expected to confirm if the homeserver supports this login flow prior
                 * to invocation.
                 * @param {string} username The username (localpart or user ID) to log in with
                 * @param {string} password The password for the account
                 * @param {string} deviceName The name of the newly created device. Optional.
                 * @returns {Promise<MatrixClient>} Resolves to a logged-in MatrixClient
                 */
                passwordLogin(username, password, deviceName) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const body = {
                            type: "m.login.password",
                            identifier: {
                                type: "m.id.user",
                                user: username,
                            },
                            password: password,
                            initial_device_display_name: deviceName,
                        };
                        const response = yield this.createTemplateClient().doRequest("POST", "/_matrix/client/r0/login", null, body);
                        const accessToken = response["access_token"];
                        if (!accessToken)
                            throw new Error("Expected access token in response - got nothing");
                        let homeserverUrl = this.homeserverUrl;
                        if (response['well_known'] && response['well_known']['m.homeserver'] && response['well_known']['m.homeserver']['base_url']) {
                            homeserverUrl = response['well_known']['m.homeserver']['base_url'];
                        }
                        return new MatrixClient_1.MatrixClient(homeserverUrl, accessToken);
                    });
                }
            };
            exports_76("MatrixAuth", MatrixAuth);
        }
    };
});
System.register("models/unstable/MediaInfo", [], function (exports_77, context_77) {
    "use strict";
    var __moduleName = context_77 && context_77.id;
    return {
        setters: [],
        execute: function () {
        }
    };
});
System.register("UnstableApis", [], function (exports_78, context_78) {
    "use strict";
    var UnstableApis;
    var __moduleName = context_78 && context_78.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Unstable APIs that shouldn't be used in most circumstances.
             * @category Unstable APIs
             */
            UnstableApis = class UnstableApis {
                constructor(client) {
                    this.client = client;
                }
                /**
                 * Gets the local room aliases that are published for a given room.
                 * @param {string} roomId The room ID to get local aliases for.
                 * @returns {Promise<string[]>} Resolves to the aliases on the room, or an empty array.
                 * @deprecated Relies on MSC2432 endpoint.
                 */
                getRoomAliases(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const r = yield this.client.doRequest("GET", "/_matrix/client/unstable/org.matrix.msc2432/rooms/" + encodeURIComponent(roomId) + "/aliases");
                        return r['aliases'] || [];
                    });
                }
                /**
                 * Creates a group.
                 * @param {string} localpart The localpart for the group
                 * @return {Promise<string>} Resolves to the created group ID.
                 */
                createGroup(localpart) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.client.doRequest("POST", "/_matrix/client/unstable/create_group", null, { "localpart": localpart });
                        return response["group_id"];
                    });
                }
                /**
                 * Invites a user to the group.
                 * @param {string} groupId The group ID to invite the user to.
                 * @param {string} userId The user ID to invite to the group.
                 * @return {Promise<"join" | "invite" | "reject">} Resolves to the invite state for
                 *  the user. This is normally "invite", but may be "join" or "reject" if the user's
                 *  homeserver accepted/rejected the invite right away.
                 */
                inviteUserToGroup(groupId, userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.client.doRequest("PUT", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/admin/users/invite/${encodeURIComponent(userId)}`, null, {});
                        return response["state"];
                    });
                }
                /**
                 * Kicks a user from a group.
                 * @param {string} groupId The group ID to kick the user from.
                 * @param {string} userId The user ID to kick from the group.
                 * @return {Promise<any>} Resolves when completed.
                 */
                kickUserFromGroup(groupId, userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("PUT", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/admin/users/remove/${encodeURIComponent(userId)}`, null, {});
                    });
                }
                /**
                 * Updates a group's profile
                 * @param {string} groupId The group ID to update.
                 * @param {GroupProfile} profile The profile to update the group with.
                 * @return {Promise<any>} Resolves when completed.
                 */
                setGroupProfile(groupId, profile) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("POST", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/profile`, null, profile);
                    });
                }
                /**
                 * Sets a group's join policy to either be publicly joinable (open) or
                 * require an invite (invite).
                 * @param {string} groupId The group ID to set the policy for.
                 * @param {"open" | "invite"} policy The policy to set.
                 * @return {Promise<any>} Resolves when completed.
                 */
                setGroupJoinPolicy(groupId, policy) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("PUT", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/settings/m.join_policy`, null, {
                            "m.join_policy": {
                                "type": policy,
                            },
                        });
                    });
                }
                /**
                 * Adds a room to a group.
                 * @param {string} groupId The group ID to add the room to.
                 * @param {string} roomId The room ID to add to the group.
                 * @param {boolean} isPublic Whether this group-room association is visible to non-members. Optional. Defaults to true.
                 * @return {Promise<any>} Resolves when completed.
                 */
                addRoomToGroup(groupId, roomId, isPublic = true) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("PUT", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/admin/rooms/${encodeURIComponent(roomId)}`, null, {
                            "m.visibility": { type: isPublic ? "public" : "private" },
                        });
                    });
                }
                /**
                 * Updates the visibility of a room in a group.
                 * @param {string} groupId The group ID of the room to update.
                 * @param {string} roomId The room ID of the room to update.
                 * @param {boolean} isPublic Whether this group-room association is visible to non-members.
                 * @return {Promise<any>} Resolves when completed.
                 */
                updateGroupRoomVisibility(groupId, roomId, isPublic) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("PUT", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/admin/rooms/${encodeURIComponent(roomId)}/config/m.visibility`, null, {
                            type: isPublic ? "public" : "private",
                        });
                    });
                }
                /**
                 * Removes a room from a group.
                 * @param {string} groupId The group ID to remove the room from.
                 * @param {string} roomId The room ID to remove from the group.
                 * @return {Promise<any>} Resolves when completed.
                 */
                removeRoomFromGroup(groupId, roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("DELETE", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/admin/rooms/${encodeURIComponent(roomId)}`);
                    });
                }
                /**
                 * Gets a group's profile.
                 * @param {string} groupId The group ID to fetch the profile of.
                 * @return {Promise<GroupProfile>} Resolves to the profile of the group.
                 */
                getGroupProfile(groupId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("GET", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/profile`);
                    });
                }
                /**
                 * Gets the users in a group.
                 * @param {string} groupId The group ID of which to get the users.
                 * @return {Promise<any[]>} Resolves to an array of all the users in the group.
                 */
                getGroupUsers(groupId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.client.doRequest("GET", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/users`);
                        return response["chunk"];
                    });
                }
                /**
                 * Gets the invited users of a group.
                 * @param {string} groupId The group ID of which to get the invited users.
                 * @return {Promise<any[]>} Resolves to an array of all the users invited to the group.
                 */
                getGroupInvitedUsers(groupId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.client.doRequest("GET", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/invited_users`);
                        return response["chunk"];
                    });
                }
                /**
                 * Gets the rooms of a group.
                 * @param {string} groupId The group ID of which to get all the rooms.
                 * @return {Promise<any[]>} Resolves to an array of all the rooms of the group.
                 */
                getGroupRooms(groupId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.client.doRequest("GET", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/rooms`);
                        return response["chunk"];
                    });
                }
                /**
                 * Accepts an invite to a group.
                 * @param {string} groupId The group ID of which to accept the invite of.
                 * @return {Promise<any>} Resolves when completed.
                 */
                acceptGroupInvite(groupId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("PUT", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/self/accept_invite`, null, {});
                    });
                }
                /**
                 * Joins a group.
                 * @param {string} groupId The group ID to join.
                 * @return {Promise<any>} Resolves when completed.
                 */
                joinGroup(groupId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("PUT", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/self/join`, null, {});
                    });
                }
                /**
                 * Leaves a group.
                 * @param {string} groupId The group ID of the group to leave.
                 * @return {Promise<any>} Resolves when completed.
                 */
                leaveGroup(groupId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("PUT", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/self/leave`, null, {});
                    });
                }
                /**
                 * Sets the publicity of a group.
                 * @param {string} groupId The group ID to set the publicity of.
                 * @param {boolean} publicise If the group should be publicised.
                 * @return {Promise<any>} Resolves when completed.
                 */
                setGroupPublicity(groupId, publicise) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("PUT", `/_matrix/client/unstable/groups/${encodeURIComponent(groupId)}/self/update_publicity`, null, {
                            publicise,
                        });
                    });
                }
                /**
                 * Gets all group IDs joined.
                 * @return {Promise<string[]>} Resolves to the group IDs of the joined groups.
                 */
                getJoinedGroups() {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.client.doRequest("GET", "/_matrix/client/unstable/joined_groups");
                        return response["groups"];
                    });
                }
                /**
                 * Gets the group IDs that the specified user has publicised.
                 * @param {string} userId The user ID to fetch the publicised groups of.
                 * @return {Promise<string[]>} Resolves to the publicised group IDs of that user.
                 */
                getPublicisedGroups(userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.client.doRequest("GET", `/_matrix/client/unstable/publicised_groups/${encodeURIComponent(userId)}`);
                        return response["groups"];
                    });
                }
                /**
                 * Adds a reaction to an event. The contract for this function may change in the future.
                 * @param {string} roomId The room ID to react in
                 * @param {string} eventId The event ID to react against, in the given room
                 * @param {string} emoji The emoji to react with
                 * @returns {Promise<string>} Resolves to the event ID of the reaction
                 */
                addReactionToEvent(roomId, eventId, emoji) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.sendEvent(roomId, "m.reaction", {
                            "m.relates_to": {
                                event_id: eventId,
                                key: emoji,
                                rel_type: "m.annotation",
                            },
                        });
                    });
                }
                /**
                 * Get relations for a given event.
                 * @param {string} roomId The room ID to for the given event.
                 * @param {string} eventId The event ID to list reacations for.
                 * @param {string?} relationType The type of reaction (e.g. `m.room.member`) to filter for. Optional.
                 * @param {string?} eventType The type of event to look for (e.g. `m.room.member`). Optional.
                 * @returns {Promise<{original_event: any, chunk: any[]}>} Resolves a object containing the original event, and a chunk of relations
                 */
                getRelationsForEvent(roomId, eventId, relationType, eventType) {
                    return __awaiter(this, void 0, void 0, function* () {
                        let url = `/_matrix/client/unstable/rooms/${roomId}/relations/${eventId}`;
                        if (relationType) {
                            url += `/${relationType}`;
                        }
                        if (eventType) {
                            url += `/${eventType}`;
                        }
                        return this.client.doRequest("GET", url);
                    });
                }
                /**
                 * Get information about a media item. Implements MSC2380
                 * @param {string} mxc The MXC to get information about.
                 * @returns {Promise<MSC2380MediaInfo>} Resolves a object containing the media information.
                 */
                getMediaInfo(mxcUrl) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (!mxcUrl.toLowerCase().startsWith("mxc://")) {
                            throw Error("'mxcUrl' does not begin with mxc://");
                        }
                        const [domain, mediaId] = mxcUrl.substr("mxc://".length).split("/");
                        if (!domain || !mediaId) {
                            throw Error('Missing domain');
                        }
                        if (!mediaId) {
                            throw Error('Missing mediaId');
                        }
                        return this.client.doRequest("GET", `/_matrix/media/unstable/info/${encodeURIComponent(domain)}/${encodeURIComponent(mediaId)}`);
                    });
                }
            };
            exports_78("UnstableApis", UnstableApis);
        }
    };
});
System.register("PantalaimonClient", ["MatrixClient", "MatrixAuth"], function (exports_79, context_79) {
    "use strict";
    var MatrixClient_2, MatrixAuth_1, ACCESS_TOKEN_STORAGE_KEY, PantalaimonClient;
    var __moduleName = context_79 && context_79.id;
    return {
        setters: [
            function (MatrixClient_2_1) {
                MatrixClient_2 = MatrixClient_2_1;
            },
            function (MatrixAuth_1_1) {
                MatrixAuth_1 = MatrixAuth_1_1;
            }
        ],
        execute: function () {
            ACCESS_TOKEN_STORAGE_KEY = "pantalaimon_access_token";
            // TODO: Write a test for this (it's hard because of the many interactions with different parts)
            /**
             * Supporting functions for interacting with a Pantalaimon instance.
             * @category Encryption
             */
            PantalaimonClient = class PantalaimonClient {
                /**
                 * Creates a new PantalaimonClient class for interacting with Pantalaimon. The storage
                 * provider given will also be used in the client.
                 * @param {string} homeserverUrl The homeserver (Pantalaimon) URL to interact with.
                 * @param {IStorageProvider} storageProvider The storage provider to back the client with.
                 */
                constructor(homeserverUrl, storageProvider) {
                    this.homeserverUrl = homeserverUrl;
                    this.storageProvider = storageProvider;
                    // nothing to do
                }
                /**
                 * Authenticates and creates the Pantalaimon-capable client. The username and password given
                 * are only used if the storage provider does not reveal an access token.
                 * @param {string} username The username to log in with, if needed.
                 * @param {string} password The password to log in with, if needed.
                 * @returns {Promise<MatrixClient>} Resolves to a MatrixClient ready for interacting with Pantalaimon.
                 */
                createClientWithCredentials(username, password) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const accessToken = yield Promise.resolve(this.storageProvider.readValue(ACCESS_TOKEN_STORAGE_KEY));
                        if (accessToken) {
                            return new MatrixClient_2.MatrixClient(this.homeserverUrl, accessToken, this.storageProvider);
                        }
                        const auth = new MatrixAuth_1.MatrixAuth(this.homeserverUrl);
                        const authedClient = yield auth.passwordLogin(username, password);
                        yield Promise.resolve(this.storageProvider.storeValue(ACCESS_TOKEN_STORAGE_KEY, authedClient.accessToken));
                        // We recreate the client to ensure we set it up with the right storage provider.
                        return new MatrixClient_2.MatrixClient(this.homeserverUrl, authedClient.accessToken, this.storageProvider);
                    });
                }
            };
            exports_79("PantalaimonClient", PantalaimonClient);
        }
    };
});
System.register("SynchronousMatrixClient", ["MatrixClient"], function (exports_80, context_80) {
    "use strict";
    var MatrixClient_3, SynchronousMatrixClient;
    var __moduleName = context_80 && context_80.id;
    return {
        setters: [
            function (MatrixClient_3_1) {
                MatrixClient_3 = MatrixClient_3_1;
            }
        ],
        execute: function () {
            /**
             * A MatrixClient class that handles events in sync for the /sync loop, instead
             * of trying to push its way through the /sync loop as fast as possible. It is
             * intended that the consumer extend this class and override the onWhatever()
             * functions it needs. All of the onWhatever() functions have a default behaviour
             * of doing nothing.
             */
            SynchronousMatrixClient = class SynchronousMatrixClient extends MatrixClient_3.MatrixClient {
                /**
                 * Creates a new SynchronousMatrixClient. Note that this accepts a MatrixClient, though
                 * much of the class's properties are not brought over. Always convert your MatrixClient
                 * instance to a SynchronousMatrixClient as soon as possible to avoid diversion in which
                 * properties are proxied over.
                 * @param {MatrixClient} baseClient The client to wrap.
                 */
                constructor(baseClient) {
                    super(baseClient.homeserverUrl, baseClient.accessToken, baseClient.storageProvider);
                }
                handleEvent(emitType, arg1, arg2) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (emitType === 'account_data')
                            yield this.onAccountData(arg1);
                        if (emitType === 'room.account_data')
                            yield this.onRoomAccountData(arg1, arg2);
                        if (emitType === 'room.leave')
                            yield this.onRoomLeave(arg1, arg2);
                        if (emitType === 'room.invite')
                            yield this.onRoomInvite(arg1, arg2);
                        if (emitType === 'room.join')
                            yield this.onRoomJoin(arg1, arg2);
                        if (emitType === 'room.archived')
                            yield this.onRoomArchived(arg1, arg2);
                        if (emitType === 'room.upgraded')
                            yield this.onRoomUpgraded(arg1, arg2);
                        if (emitType === 'room.message')
                            yield this.onRoomMessage(arg1, arg2);
                        if (emitType === 'room.event')
                            yield this.onRoomEvent(arg1, arg2);
                        // Still emit though for easier support of plugins.
                        this.emit(emitType, arg1, arg2);
                    });
                }
                startSyncInternal() {
                    return this.startSync(this.handleEvent.bind(this));
                }
                /**
                 * Handles the `account_data` event raised by the client.
                 * @param {any} event The account data event.
                 * @returns {Promise<any>} Resolves when complete.
                 */
                onAccountData(event) {
                    return;
                }
                /**
                 * Handles the `room.account_data` event raised by the client.
                 * @param {string} roomId The Room ID the account data applies to.
                 * @param {any} event The room account data event.
                 * @returns {Promise<any>} Resolves when complete.
                 */
                onRoomAccountData(roomId, event) {
                    return;
                }
                /**
                 * Handles the `room.leave` event raised by the client.
                 * @param {string} roomId The Room ID the event happened in.
                 * @param {any} event The event.
                 * @returns {Promise<any>} Resolves when complete.
                 */
                onRoomLeave(roomId, event) {
                    return;
                }
                /**
                 * Handles the `room.invite` event raised by the client.
                 * @param {string} roomId The Room ID the event happened in.
                 * @param {any} event The event.
                 * @returns {Promise<any>} Resolves when complete.
                 */
                onRoomInvite(roomId, event) {
                    return;
                }
                /**
                 * Handles the `room.join` event raised by the client.
                 * @param {string} roomId The Room ID the event happened in.
                 * @param {any} event The event.
                 * @returns {Promise<any>} Resolves when complete.
                 */
                onRoomJoin(roomId, event) {
                    return;
                }
                /**
                 * Handles the `room.message` event raised by the client.
                 * @param {string} roomId The Room ID the event happened in.
                 * @param {any} event The event.
                 * @returns {Promise<any>} Resolves when complete.
                 */
                onRoomMessage(roomId, event) {
                    return;
                }
                /**
                 * Handles the `room.archived` event raised by the client.
                 * @param {string} roomId The Room ID the event happened in.
                 * @param {any} event The event.
                 * @returns {Promise<any>} Resolves when complete.
                 */
                onRoomArchived(roomId, event) {
                    return;
                }
                /**
                 * Handles the `room.upgraded` event raised by the client.
                 * @param {string} roomId The Room ID the event happened in.
                 * @param {any} event The event.
                 * @returns {Promise<any>} Resolves when complete.
                 */
                onRoomUpgraded(roomId, event) {
                    return;
                }
                /**
                 * Handles the `room.event` event raised by the client.
                 * @param {string} roomId The Room ID the event happened in.
                 * @param {any} event The event.
                 * @returns {Promise<any>} Resolves when complete.
                 */
                onRoomEvent(roomId, event) {
                    return;
                }
            };
            exports_80("SynchronousMatrixClient", SynchronousMatrixClient);
        }
    };
});
System.register("SynapseAdminApis", [], function (exports_81, context_81) {
    "use strict";
    var SynapseRoomProperty, SynapseAdminApis;
    var __moduleName = context_81 && context_81.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Available properties on a Synapse room listing to order by.
             * @category Admin APIs
             */
            (function (SynapseRoomProperty) {
                SynapseRoomProperty["Name"] = "name";
                SynapseRoomProperty["CanonicalAlias"] = "canonical_alias";
                SynapseRoomProperty["JoinedMembers"] = "joined_members";
                SynapseRoomProperty["JoinedLocalMembers"] = "joined_local_members";
                SynapseRoomProperty["Version"] = "version";
                SynapseRoomProperty["Creator"] = "creator";
                SynapseRoomProperty["Encryption"] = "encryption";
                SynapseRoomProperty["CanFederate"] = "federatable";
                SynapseRoomProperty["IsPublic"] = "public";
                SynapseRoomProperty["JoinRules"] = "join_rules";
                SynapseRoomProperty["GuestAccess"] = "guest_access";
                SynapseRoomProperty["HistoryVisibility"] = "history_visibility";
                SynapseRoomProperty["NumStateEvents"] = "state_events";
            })(SynapseRoomProperty || (SynapseRoomProperty = {}));
            exports_81("SynapseRoomProperty", SynapseRoomProperty);
            /**
             * Access to various administrative APIs specifically available in Synapse.
             * @category Admin APIs
             */
            SynapseAdminApis = class SynapseAdminApis {
                constructor(client) {
                    this.client = client;
                }
                /**
                 * Get information about a user. The client making the request must be an admin user.
                 * @param {string} userId The user ID to check.
                 * @returns {Promise<SynapseUser>} The resulting Synapse user record
                 */
                getUser(userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("GET", "/_synapse/admin/v2/users/" + encodeURIComponent(userId));
                    });
                }
                /**
                 * Create or update a given user on a Synapse server. The
                 * client making the request must be an admin user.
                 * @param {string} userId The user ID to check.
                 * @param {SynapseUserProperties} opts Options to set when creating or updating the user.
                 * @returns {Promise<SynapseUser>} The resulting Synapse user record
                 */
                upsertUser(userId, opts = {}) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("PUT", "/_synapse/admin/v2/users/" + encodeURIComponent(userId), undefined, opts);
                    });
                }
                /**
                 * Get a list of users registered with Synapse, optionally filtered by some criteria. The
                 * client making the request must be an admin user.
                 * @param {string} from The token to continue listing users from.
                 * @param {number} limit The maximum number of users to request.
                 * @param {string} name Optional localpart or display name filter for results.
                 * @param {boolean} guests Whether or not to include guest accounts. Default true.
                 * @param {boolean} deactivated Whether or not to include deactivated accounts. Default false.
                 * @returns {Promise<SynapseUserList>} A batch of user results.
                 */
                listUsers(from, limit, name, guests = true, deactivated = false) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const qs = { guests, deactivated };
                        if (from)
                            qs['from'] = from;
                        if (limit)
                            qs['limit'] = limit;
                        if (name)
                            qs['name'] = name;
                        return this.client.doRequest("GET", "/_synapse/admin/v2/users", qs);
                    });
                }
                /**
                 * Determines if the given user is a Synapse server administrator for this homeserver. The
                 * client making the request must be an admin user themselves (check with `isSelfAdmin`)
                 * @param {string} userId The user ID to check.
                 * @returns {Promise<boolean>} Resolves to true if the user is an admin, false otherwise.
                 * Throws if there's an error.
                 */
                isAdmin(userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const response = yield this.client.doRequest("GET", `/_synapse/admin/v1/users/${encodeURIComponent(userId)}/admin`);
                        return response['admin'] || false;
                    });
                }
                /**
                 * Determines if the current user is an admin for the Synapse homeserver.
                 * @returns {Promise<boolean>} Resolve to true if the user is an admin, false otherwise.
                 * Throws if there's an error.
                 */
                isSelfAdmin() {
                    var _a;
                    return __awaiter(this, void 0, void 0, function* () {
                        try {
                            return yield this.isAdmin(yield this.client.getUserId());
                        }
                        catch (e) {
                            if (((_a = e === null || e === void 0 ? void 0 : e.body) === null || _a === void 0 ? void 0 : _a.errcode) === 'M_FORBIDDEN') {
                                return false;
                            }
                            throw e;
                        }
                    });
                }
                /**
                 * Lists the rooms on the server.
                 * @param {string} searchTerm A term to search for in the room names
                 * @param {string} from A previous batch token to search from
                 * @param {number} limit The maximum number of rooms to return
                 * @param {SynapseRoomProperty} orderBy A property of rooms to order by
                 * @param {boolean} reverseOrder True to reverse the orderBy direction.
                 * @returns {Promise<SynapseRoomList>} Resolves to the server's rooms, ordered and filtered.
                 */
                listRooms(searchTerm, from, limit, orderBy, reverseOrder = false) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const params = {};
                        if (from)
                            params['from'] = from;
                        if (limit)
                            params['limit'] = limit;
                        if (searchTerm)
                            params['search_term'] = searchTerm;
                        if (orderBy)
                            params['order_by'] = orderBy;
                        if (reverseOrder) {
                            params['dir'] = 'b';
                        }
                        else {
                            params['dir'] = 'f';
                        }
                        return this.client.doRequest("GET", "/_synapse/admin/v1/rooms", params);
                    });
                }
                /**
                 * Gets a list of state events in a room.
                 * @param {string} roomId The room ID to get state for.
                 * @returns {Promise<any[]>} Resolves to the room's state events.
                 */
                getRoomState(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const r = yield this.client.doRequest("GET", `/_synapse/admin/v1/rooms/${encodeURIComponent(roomId)}/state`);
                        return (r === null || r === void 0 ? void 0 : r['state']) || [];
                    });
                }
                /**
                 * Deletes a room from the server, purging all record of it.
                 * @param {string} roomId The room to delete.
                 * @returns {Promise} Resolves when complete.
                 */
                deleteRoom(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.client.doRequest("POST", `/_synapse/admin/v1/rooms/${encodeURIComponent(roomId)}/delete`, {}, { purge: true });
                    });
                }
            };
            exports_81("SynapseAdminApis", SynapseAdminApis);
        }
    };
});
System.register("index", ["appservice/Appservice", "appservice/Intent", "appservice/MatrixBridge", "appservice/http_responses", "appservice/UnstableAppserviceApis", "e2ee/RoomTracker", "e2ee/CryptoClient", "e2ee/decorators", "helpers/RichReply", "helpers/MentionPill", "helpers/Permalinks", "helpers/MatrixGlob", "helpers/ProfileCache", "helpers/MatrixEntity", "helpers/UnpaddedBase64", "logging/ConsoleLogger", "logging/RichConsoleLogger", "logging/ILogger", "logging/LogService", "metrics/contexts", "metrics/names", "metrics/decorators", "metrics/IMetricListener", "metrics/Metrics", "mixins/AutojoinRoomsMixin", "mixins/AutojoinUpgradedRoomsMixin", "models/Presence", "models/MatrixProfile", "models/EventContext", "models/PowerLevelBounds", "models/OpenIDConnect", "models/Policies", "models/Threepid", "models/Spaces", "models/IdentityServerModels", "models/Crypto", "models/MSC2176", "models/Account", "models/events/EventKind", "models/events/converter", "models/events/InvalidEventError", "models/events/Event", "models/events/RoomEvent", "models/events/PresenceEvent", "models/events/MembershipEvent", "models/events/MessageEvent", "models/events/AliasesEvent", "models/events/CanonicalAliasEvent", "models/events/CreateEvent", "models/events/JoinRulesEvent", "models/events/PowerLevelsEvent", "models/events/RedactionEvent", "models/events/PinnedEventsEvent", "models/events/RoomAvatarEvent", "models/events/RoomNameEvent", "models/events/RoomTopicEvent", "models/events/SpaceChildEvent", "models/events/EncryptionEvent", "models/events/EncryptedRoomEvent", "preprocessors/IPreprocessor", "preprocessors/RichRepliesPreprocessor", "storage/IAppserviceStorageProvider", "storage/IStorageProvider", "storage/MemoryStorageProvider", "storage/SimpleFsStorageProvider", "storage/ICryptoStorageProvider", "strategies/AppserviceJoinRoomStrategy", "strategies/JoinRoomStrategy", "identity/IdentityClient", "IFilter", "MatrixClient", "MatrixAuth", "UnstableApis", "AdminApis", "request", "PantalaimonClient", "SynchronousMatrixClient", "SynapseAdminApis", "simple-validation", "b64"], function (exports_82, context_82) {
    "use strict";
    var __moduleName = context_82 && context_82.id;
    function exportStar_1(m) {
        var exports = {};
        for (var n in m) {
            if (n !== "default") exports[n] = m[n];
        }
        exports_82(exports);
    }
    return {
        setters: [
            function (Appservice_1_1) {
                exportStar_1(Appservice_1_1);
            },
            function (Intent_2_1) {
                exportStar_1(Intent_2_1);
            },
            function (MatrixBridge_2_1) {
                exportStar_1(MatrixBridge_2_1);
            },
            function (http_responses_1_1) {
                exportStar_1(http_responses_1_1);
            },
            function (UnstableAppserviceApis_2_1) {
                exportStar_1(UnstableAppserviceApis_2_1);
            },
            function (RoomTracker_2_1) {
                exportStar_1(RoomTracker_2_1);
            },
            function (CryptoClient_1_1) {
                exportStar_1(CryptoClient_1_1);
            },
            function (decorators_4_1) {
                exportStar_1(decorators_4_1);
            },
            function (RichReply_1_1) {
                exportStar_1(RichReply_1_1);
            },
            function (MentionPill_1_1) {
                exportStar_1(MentionPill_1_1);
            },
            function (Permalinks_2_1) {
                exportStar_1(Permalinks_2_1);
            },
            function (MatrixGlob_1_1) {
                exportStar_1(MatrixGlob_1_1);
            },
            function (ProfileCache_1_1) {
                exportStar_1(ProfileCache_1_1);
            },
            function (MatrixEntity_2_1) {
                exportStar_1(MatrixEntity_2_1);
            },
            function (UnpaddedBase64_2_1) {
                exportStar_1(UnpaddedBase64_2_1);
            },
            function (ConsoleLogger_2_1) {
                exportStar_1(ConsoleLogger_2_1);
            },
            function (RichConsoleLogger_1_1) {
                exportStar_1(RichConsoleLogger_1_1);
            },
            function (ILogger_1_1) {
                exportStar_1(ILogger_1_1);
            },
            function (LogService_4_1) {
                exportStar_1(LogService_4_1);
            },
            function (contexts_1_1) {
                exportStar_1(contexts_1_1);
            },
            function (names_2_1) {
                exportStar_1(names_2_1);
            },
            function (decorators_5_1) {
                exportStar_1(decorators_5_1);
            },
            function (IMetricListener_1_1) {
                exportStar_1(IMetricListener_1_1);
            },
            function (Metrics_2_1) {
                exportStar_1(Metrics_2_1);
            },
            function (AutojoinRoomsMixin_1_1) {
                exportStar_1(AutojoinRoomsMixin_1_1);
            },
            function (AutojoinUpgradedRoomsMixin_1_1) {
                exportStar_1(AutojoinUpgradedRoomsMixin_1_1);
            },
            function (Presence_1_1) {
                exportStar_1(Presence_1_1);
            },
            function (MatrixProfile_2_1) {
                exportStar_1(MatrixProfile_2_1);
            },
            function (EventContext_1_1) {
                exportStar_1(EventContext_1_1);
            },
            function (PowerLevelBounds_1_1) {
                exportStar_1(PowerLevelBounds_1_1);
            },
            function (OpenIDConnect_1_1) {
                exportStar_1(OpenIDConnect_1_1);
            },
            function (Policies_1_1) {
                exportStar_1(Policies_1_1);
            },
            function (Threepid_1_1) {
                exportStar_1(Threepid_1_1);
            },
            function (Spaces_1_1) {
                exportStar_1(Spaces_1_1);
            },
            function (IdentityServerModels_1_1) {
                exportStar_1(IdentityServerModels_1_1);
            },
            function (Crypto_3_1) {
                exportStar_1(Crypto_3_1);
            },
            function (MSC2176_1_1) {
                exportStar_1(MSC2176_1_1);
            },
            function (Account_1_1) {
                exportStar_1(Account_1_1);
            },
            function (EventKind_1_1) {
                exportStar_1(EventKind_1_1);
            },
            function (converter_1_1) {
                exportStar_1(converter_1_1);
            },
            function (InvalidEventError_3_1) {
                exportStar_1(InvalidEventError_3_1);
            },
            function (Event_3_1) {
                exportStar_1(Event_3_1);
            },
            function (RoomEvent_18_1) {
                exportStar_1(RoomEvent_18_1);
            },
            function (PresenceEvent_1_1) {
                exportStar_1(PresenceEvent_1_1);
            },
            function (MembershipEvent_3_1) {
                exportStar_1(MembershipEvent_3_1);
            },
            function (MessageEvent_2_1) {
                exportStar_1(MessageEvent_2_1);
            },
            function (AliasesEvent_1_1) {
                exportStar_1(AliasesEvent_1_1);
            },
            function (CanonicalAliasEvent_1_1) {
                exportStar_1(CanonicalAliasEvent_1_1);
            },
            function (CreateEvent_1_1) {
                exportStar_1(CreateEvent_1_1);
            },
            function (JoinRulesEvent_1_1) {
                exportStar_1(JoinRulesEvent_1_1);
            },
            function (PowerLevelsEvent_1_1) {
                exportStar_1(PowerLevelsEvent_1_1);
            },
            function (RedactionEvent_1_1) {
                exportStar_1(RedactionEvent_1_1);
            },
            function (PinnedEventsEvent_1_1) {
                exportStar_1(PinnedEventsEvent_1_1);
            },
            function (RoomAvatarEvent_1_1) {
                exportStar_1(RoomAvatarEvent_1_1);
            },
            function (RoomNameEvent_1_1) {
                exportStar_1(RoomNameEvent_1_1);
            },
            function (RoomTopicEvent_1_1) {
                exportStar_1(RoomTopicEvent_1_1);
            },
            function (SpaceChildEvent_2_1) {
                exportStar_1(SpaceChildEvent_2_1);
            },
            function (EncryptionEvent_2_1) {
                exportStar_1(EncryptionEvent_2_1);
            },
            function (EncryptedRoomEvent_2_1) {
                exportStar_1(EncryptedRoomEvent_2_1);
            },
            function (IPreprocessor_1_1) {
                exportStar_1(IPreprocessor_1_1);
            },
            function (RichRepliesPreprocessor_1_1) {
                exportStar_1(RichRepliesPreprocessor_1_1);
            },
            function (IAppserviceStorageProvider_1_1) {
                exportStar_1(IAppserviceStorageProvider_1_1);
            },
            function (IStorageProvider_1_1) {
                exportStar_1(IStorageProvider_1_1);
            },
            function (MemoryStorageProvider_1_1) {
                exportStar_1(MemoryStorageProvider_1_1);
            },
            function (SimpleFsStorageProvider_1_1) {
                exportStar_1(SimpleFsStorageProvider_1_1);
            },
            function (ICryptoStorageProvider_1_1) {
                exportStar_1(ICryptoStorageProvider_1_1);
            },
            function (AppserviceJoinRoomStrategy_1_1) {
                exportStar_1(AppserviceJoinRoomStrategy_1_1);
            },
            function (JoinRoomStrategy_1_1) {
                exportStar_1(JoinRoomStrategy_1_1);
            },
            function (IdentityClient_1_1) {
                exportStar_1(IdentityClient_1_1);
            },
            function (IFilter_1_1) {
                exportStar_1(IFilter_1_1);
            },
            function (MatrixClient_4_1) {
                exportStar_1(MatrixClient_4_1);
            },
            function (MatrixAuth_2_1) {
                exportStar_1(MatrixAuth_2_1);
            },
            function (UnstableApis_1_1) {
                exportStar_1(UnstableApis_1_1);
            },
            function (AdminApis_1_1) {
                exportStar_1(AdminApis_1_1);
            },
            function (request_2_1) {
                exportStar_1(request_2_1);
            },
            function (PantalaimonClient_1_1) {
                exportStar_1(PantalaimonClient_1_1);
            },
            function (SynchronousMatrixClient_1_1) {
                exportStar_1(SynchronousMatrixClient_1_1);
            },
            function (SynapseAdminApis_1_1) {
                exportStar_1(SynapseAdminApis_1_1);
            },
            function (simple_validation_2_1) {
                exportStar_1(simple_validation_2_1);
            },
            function (b64_2_1) {
                exportStar_1(b64_2_1);
            }
        ],
        execute: function () {
        }
    };
});
System.register("strategies/JoinRoomStrategy", ["index"], function (exports_83, context_83) {
    "use strict";
    var __8, SimpleRetryJoinStrategy;
    var __moduleName = context_83 && context_83.id;
    function waitPromise(interval) {
        return new Promise((resolve, reject) => {
            setTimeout(resolve, interval);
        });
    }
    return {
        setters: [
            function (__8_1) {
                __8 = __8_1;
            }
        ],
        execute: function () {
            /**
             * A join strategy that keeps trying to join the room on a set interval.
             * @category Join strategies
             */
            SimpleRetryJoinStrategy = class SimpleRetryJoinStrategy {
                constructor() {
                    // Note: The schedule must not have duplicate values to avoid problems in positioning.
                    this.schedule = [
                        0,
                        1000,
                        30 * 1000,
                        5 * 60 * 1000,
                        15 * 60 * 1000, // 15 minutes
                    ];
                }
                joinRoom(roomIdOrAlias, userId, apiCall) {
                    let currentSchedule = this.schedule[0];
                    const doJoin = () => waitPromise(currentSchedule).then(() => apiCall(roomIdOrAlias));
                    const errorHandler = err => {
                        __8.LogService.error("SimpleRetryJoinStrategy", __8.extractRequestError(err));
                        const idx = this.schedule.indexOf(currentSchedule);
                        if (idx === this.schedule.length - 1) {
                            __8.LogService.warn("SimpleRetryJoinStrategy", "Failed to join room " + roomIdOrAlias);
                            return Promise.reject(err);
                        }
                        else {
                            currentSchedule = this.schedule[idx + 1];
                            return doJoin().catch(errorHandler);
                        }
                    };
                    return doJoin().catch(errorHandler);
                }
            };
            exports_83("SimpleRetryJoinStrategy", SimpleRetryJoinStrategy);
        }
    };
});
System.register("models/PowerLevelAction", [], function (exports_84, context_84) {
    "use strict";
    var PowerLevelAction;
    var __moduleName = context_84 && context_84.id;
    return {
        setters: [],
        execute: function () {
            /**
             * Actions that can be guarded by power levels.
             */
            (function (PowerLevelAction) {
                /**
                 * Power level required to ban other users.
                 */
                PowerLevelAction["Ban"] = "ban";
                /**
                 * Power level required to kick other users.
                 */
                PowerLevelAction["Kick"] = "kick";
                /**
                 * Power level required to redact events sent by other users. Users can redact
                 * their own messages regardless of this power level requirement, unless forbidden
                 * by the `events` section of the power levels content.
                 */
                PowerLevelAction["RedactEvents"] = "redact";
                /**
                 * Power level required to invite other users.
                 */
                PowerLevelAction["Invite"] = "invite";
                /**
                 * Power level required to notify the whole room with "@room".
                 */
                PowerLevelAction["NotifyRoom"] = "notifications.room";
            })(PowerLevelAction || (PowerLevelAction = {}));
            exports_84("PowerLevelAction", PowerLevelAction);
        }
    };
});
System.register("MatrixClient", ["events", "storage/MemoryStorageProvider", "UnstableApis", "request", "logging/LogService", "htmlencode", "helpers/RichReply", "metrics/Metrics", "metrics/decorators", "AdminApis", "models/Presence", "models/events/MembershipEvent", "models/events/RoomEvent", "models/events/EventKind", "identity/IdentityClient", "http", "html-to-text", "models/Spaces", "models/PowerLevelAction", "e2ee/CryptoClient", "models/Crypto", "e2ee/decorators", "models/events/EncryptedRoomEvent"], function (exports_85, context_85) {
    "use strict";
    var _a, _b, events_2, MemoryStorageProvider_2, UnstableApis_2, request_3, LogService_5, htmlencode_1, RichReply_2, Metrics_3, decorators_6, AdminApis_2, Presence_2, MembershipEvent_4, RoomEvent_19, EventKind_2, IdentityClient_2, http_2, html_to_text_1, Spaces_2, PowerLevelAction_1, CryptoClient_2, Crypto_4, decorators_7, EncryptedRoomEvent_3, SYNC_BACKOFF_MIN_MS, SYNC_BACKOFF_MAX_MS, MatrixClient;
    var __moduleName = context_85 && context_85.id;
    return {
        setters: [
            function (events_2_1) {
                events_2 = events_2_1;
            },
            function (MemoryStorageProvider_2_1) {
                MemoryStorageProvider_2 = MemoryStorageProvider_2_1;
            },
            function (UnstableApis_2_1) {
                UnstableApis_2 = UnstableApis_2_1;
            },
            function (request_3_1) {
                request_3 = request_3_1;
            },
            function (LogService_5_1) {
                LogService_5 = LogService_5_1;
            },
            function (htmlencode_1_1) {
                htmlencode_1 = htmlencode_1_1;
            },
            function (RichReply_2_1) {
                RichReply_2 = RichReply_2_1;
            },
            function (Metrics_3_1) {
                Metrics_3 = Metrics_3_1;
            },
            function (decorators_6_1) {
                decorators_6 = decorators_6_1;
            },
            function (AdminApis_2_1) {
                AdminApis_2 = AdminApis_2_1;
            },
            function (Presence_2_1) {
                Presence_2 = Presence_2_1;
            },
            function (MembershipEvent_4_1) {
                MembershipEvent_4 = MembershipEvent_4_1;
            },
            function (RoomEvent_19_1) {
                RoomEvent_19 = RoomEvent_19_1;
            },
            function (EventKind_2_1) {
                EventKind_2 = EventKind_2_1;
            },
            function (IdentityClient_2_1) {
                IdentityClient_2 = IdentityClient_2_1;
            },
            function (http_2_1) {
                http_2 = http_2_1;
            },
            function (html_to_text_1_1) {
                html_to_text_1 = html_to_text_1_1;
            },
            function (Spaces_2_1) {
                Spaces_2 = Spaces_2_1;
            },
            function (PowerLevelAction_1_1) {
                PowerLevelAction_1 = PowerLevelAction_1_1;
            },
            function (CryptoClient_2_1) {
                CryptoClient_2 = CryptoClient_2_1;
            },
            function (Crypto_4_1) {
                Crypto_4 = Crypto_4_1;
            },
            function (decorators_7_1) {
                decorators_7 = decorators_7_1;
            },
            function (EncryptedRoomEvent_3_1) {
                EncryptedRoomEvent_3 = EncryptedRoomEvent_3_1;
            }
        ],
        execute: function () {
            SYNC_BACKOFF_MIN_MS = 5000;
            SYNC_BACKOFF_MAX_MS = 15000;
            /**
             * A client that is capable of interacting with a matrix homeserver.
             */
            MatrixClient = class MatrixClient extends events_2.EventEmitter {
                /**
                 * Creates a new matrix client
                 * @param {string} homeserverUrl The homeserver's client-server API URL
                 * @param {string} accessToken The access token for the homeserver
                 * @param {IStorageProvider} storage The storage provider to use. Defaults to MemoryStorageProvider.
                 * @param {ICryptoStorageProvider} cryptoStore Optional crypto storage provider to use. If not supplied,
                 * end-to-end encryption will not be functional in this client.
                 */
                constructor(homeserverUrl, accessToken, storage = null, cryptoStore = null) {
                    super();
                    this.homeserverUrl = homeserverUrl;
                    this.accessToken = accessToken;
                    this.storage = storage;
                    this.cryptoStore = cryptoStore;
                    /**
                     * The presence status to use while syncing. The valid values are "online" to set the account as online,
                     * "offline" to set the user as offline, "unavailable" for marking the user away, and null for not setting
                     * an explicit presence (the default).
                     *
                     * Has no effect if the client is not syncing. Does not apply until the next sync request.
                     */
                    this.syncingPresence = null;
                    /**
                     * The number of milliseconds to wait for new events for on the next sync.
                     *
                     * Has no effect if the client is not syncing. Does not apply until the next sync request.
                     */
                    this.syncingTimeout = 30000;
                    this.requestId = 0;
                    this.lastJoinedRoomIds = [];
                    this.joinStrategy = null;
                    this.eventProcessors = {};
                    this.filterId = 0;
                    this.stopSyncing = false;
                    this.metricsInstance = new Metrics_3.Metrics();
                    this.unstableApisInstance = new UnstableApis_2.UnstableApis(this);
                    /**
                     * Set this to true to have the client only persist the sync token after the sync
                     * has been processed successfully. Note that if this is true then when the sync
                     * loop throws an error the client will not persist a token.
                     */
                    this.persistTokenAfterSync = false;
                    if (this.homeserverUrl.endsWith("/")) {
                        this.homeserverUrl = this.homeserverUrl.substring(0, this.homeserverUrl.length - 1);
                    }
                    if (this.cryptoStore) {
                        if (!this.storage || this.storage instanceof MemoryStorageProvider_2.MemoryStorageProvider) {
                            LogService_5.LogService.warn("MatrixClientLite", "Starting an encryption-capable client with a memory store is not considered a good idea.");
                        }
                        this.crypto = new CryptoClient_2.CryptoClient(this);
                        LogService_5.LogService.debug("MatrixClientLite", "End-to-end encryption client created");
                    }
                    else {
                        // LogService.trace("MatrixClientLite", "Not setting up encryption");
                    }
                    if (!this.storage)
                        this.storage = new MemoryStorageProvider_2.MemoryStorageProvider();
                }
                /**
                 * The storage provider for this client. Direct access is usually not required.
                 */
                get storageProvider() {
                    return this.storage;
                }
                /**
                 * The metrics instance for this client
                 */
                get metrics() {
                    return this.metricsInstance;
                }
                /**
                 * Assigns a new metrics instance, overwriting the old one.
                 * @param {Metrics} metrics The new metrics instance.
                 */
                set metrics(metrics) {
                    if (!metrics)
                        throw new Error("Metrics cannot be null/undefined");
                    this.metricsInstance = metrics;
                }
                /**
                 * Gets the unstable API access class. This is generally not recommended to be
                 * used by clients.
                 * @return {UnstableApis} The unstable API access class.
                 */
                get unstableApis() {
                    return this.unstableApisInstance;
                }
                /**
                 * Gets the admin API access class.
                 * @return {AdminApis} The admin API access class.
                 */
                get adminApis() {
                    return new AdminApis_2.AdminApis(this);
                }
                /**
                 * Sets a user ID to impersonate as. This will assume that the access token for this client
                 * is for an application service, and that the userId given is within the reach of the
                 * application service. Setting this to null will stop future impersonation. The user ID is
                 * assumed to already be valid
                 * @param {string} userId The user ID to masquerade as, or `null` to clear masquerading.
                 * @param {string} deviceId Optional device ID to impersonate under the given user, if supported
                 * by the server. Check the whoami response after setting.
                 */
                impersonateUserId(userId, deviceId) {
                    this.impersonatedUserId = userId;
                    this.userId = userId;
                    if (userId) {
                        this.impersonatedDeviceId = deviceId;
                    }
                    else if (deviceId) {
                        throw new Error("Cannot impersonate just a device: need a user ID");
                    }
                    else {
                        this.impersonatedDeviceId = null;
                    }
                }
                /**
                 * Acquires an identity server client for communicating with an identity server. Note that
                 * this will automatically do the login portion to establish a usable token with the identity
                 * server provided, but it will not automatically accept any terms of service.
                 *
                 * The identity server name provided will in future be resolved to a server address - for now
                 * that resolution is assumed to be prefixing the name with `https://`.
                 * @param {string} identityServerName The domain of the identity server to connect to.
                 * @returns {Promise<IdentityClient>} Resolves to a prepared identity client.
                 */
                getIdentityServerClient(identityServerName) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const oidcToken = yield this.getOpenIDConnectToken();
                        return IdentityClient_2.IdentityClient.acquire(oidcToken, `https://${identityServerName}`, this);
                    });
                }
                /**
                 * Sets the strategy to use for when joinRoom is called on this client
                 * @param {IJoinRoomStrategy} strategy The strategy to use, or null to use none
                 */
                setJoinStrategy(strategy) {
                    this.joinStrategy = strategy;
                }
                /**
                 * Adds a preprocessor to the event pipeline. When this client encounters an event, it
                 * will try to run it through the preprocessors it can in the order they were added.
                 * @param {IPreprocessor} preprocessor the preprocessor to add
                 */
                addPreprocessor(preprocessor) {
                    if (!preprocessor)
                        throw new Error("Preprocessor cannot be null");
                    const eventTypes = preprocessor.getSupportedEventTypes();
                    if (!eventTypes)
                        return; // Nothing to do
                    for (const eventType of eventTypes) {
                        if (!this.eventProcessors[eventType])
                            this.eventProcessors[eventType] = [];
                        this.eventProcessors[eventType].push(preprocessor);
                    }
                }
                processEvent(event) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (!event)
                            return event;
                        if (!this.eventProcessors[event["type"]])
                            return event;
                        for (const processor of this.eventProcessors[event["type"]]) {
                            yield processor.processEvent(event, this, EventKind_2.EventKind.RoomEvent);
                        }
                        return event;
                    });
                }
                /**
                 * Retrieves an OpenID Connect token from the homeserver for the current user.
                 * @returns {Promise<OpenIDConnectToken>} Resolves to the token.
                 */
                getOpenIDConnectToken() {
                    return __awaiter(this, void 0, void 0, function* () {
                        const userId = encodeURIComponent(yield this.getUserId());
                        return this.doRequest("POST", "/_matrix/client/r0/user/" + userId + "/openid/request_token", null, {});
                    });
                }
                /**
                 * Retrieves content from account data.
                 * @param {string} eventType The type of account data to retrieve.
                 * @returns {Promise<any>} Resolves to the content of that account data.
                 */
                getAccountData(eventType) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const userId = encodeURIComponent(yield this.getUserId());
                        eventType = encodeURIComponent(eventType);
                        return this.doRequest("GET", "/_matrix/client/r0/user/" + userId + "/account_data/" + eventType);
                    });
                }
                /**
                 * Retrieves content from room account data.
                 * @param {string} eventType The type of room account data to retrieve.
                 * @param {string} roomId The room to read the account data from.
                 * @returns {Promise<any>} Resolves to the content of that account data.
                 */
                getRoomAccountData(eventType, roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const userId = encodeURIComponent(yield this.getUserId());
                        eventType = encodeURIComponent(eventType);
                        roomId = encodeURIComponent(roomId);
                        return this.doRequest("GET", "/_matrix/client/r0/user/" + userId + "/rooms/" + roomId + "/account_data/" + eventType);
                    });
                }
                /**
                 * Retrieves content from account data. If the account data request throws an error,
                 * this simply returns the default provided.
                 * @param {string} eventType The type of account data to retrieve.
                 * @param {any} defaultContent The default value. Defaults to null.
                 * @returns {Promise<any>} Resolves to the content of that account data, or the default.
                 */
                getSafeAccountData(eventType, defaultContent = null) {
                    return __awaiter(this, void 0, void 0, function* () {
                        try {
                            return yield this.getAccountData(eventType);
                        }
                        catch (e) {
                            LogService_5.LogService.warn("MatrixClient", `Error getting ${eventType} account data:`, LogService_5.extractRequestError(e));
                            return defaultContent;
                        }
                    });
                }
                /**
                 * Retrieves content from room account data. If the account data request throws an error,
                 * this simply returns the default provided.
                 * @param {string} eventType The type of room account data to retrieve.
                 * @param {string} roomId The room to read the account data from.
                 * @param {any} defaultContent The default value. Defaults to null.
                 * @returns {Promise<any>} Resolves to the content of that room account data, or the default.
                 */
                getSafeRoomAccountData(eventType, roomId, defaultContent = null) {
                    return __awaiter(this, void 0, void 0, function* () {
                        try {
                            return yield this.getRoomAccountData(eventType, roomId);
                        }
                        catch (e) {
                            LogService_5.LogService.warn("MatrixClient", `Error getting ${eventType} room account data in ${roomId}:`, LogService_5.extractRequestError(e));
                            return defaultContent;
                        }
                    });
                }
                /**
                 * Sets account data.
                 * @param {string} eventType The type of account data to set
                 * @param {any} content The content to set
                 * @returns {Promise<any>} Resolves when updated
                 */
                setAccountData(eventType, content) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const userId = encodeURIComponent(yield this.getUserId());
                        eventType = encodeURIComponent(eventType);
                        return this.doRequest("PUT", "/_matrix/client/r0/user/" + userId + "/account_data/" + eventType, null, content);
                    });
                }
                /**
                 * Sets room account data.
                 * @param {string} eventType The type of room account data to set
                 * @param {string} roomId The room to set account data in
                 * @param {any} content The content to set
                 * @returns {Promise<any>} Resolves when updated
                 */
                setRoomAccountData(eventType, roomId, content) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const userId = encodeURIComponent(yield this.getUserId());
                        eventType = encodeURIComponent(eventType);
                        roomId = encodeURIComponent(roomId);
                        return this.doRequest("PUT", "/_matrix/client/r0/user/" + userId + "/rooms/" + roomId + "/account_data/" + eventType, null, content);
                    });
                }
                /**
                 * Gets the presence information for the current user.
                 * @returns {Promise<Presence>} Resolves to the presence status of the user.
                 */
                getPresenceStatus() {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.getPresenceStatusFor(yield this.getUserId());
                    });
                }
                /**
                 * Gets the presence information for a given user.
                 * @param {string} userId The user ID to look up the presence of.
                 * @returns {Promise<Presence>} Resolves to the presence status of the user.
                 */
                getPresenceStatusFor(userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.doRequest("GET", "/_matrix/client/r0/presence/" + encodeURIComponent(userId) + "/status").then(r => new Presence_2.Presence(r));
                    });
                }
                /**
                 * Sets the presence status for the current user.
                 * @param {"online"|"offline"|"unavailable"} presence The new presence state for the user.
                 * @param {string} statusMessage Optional status message to include with the presence.
                 * @returns {Promise<any>} Resolves when complete.
                 */
                setPresenceStatus(presence, statusMessage = null) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.doRequest("PUT", "/_matrix/client/r0/presence/" + encodeURIComponent(yield this.getUserId()) + "/status", null, {
                            presence: presence,
                            status_msg: statusMessage,
                        });
                    });
                }
                /**
                 * Gets a published alias for the given room. These are supplied by the room admins
                 * and should point to the room, but may not. This is primarily intended to be used
                 * in the context of rendering a mention (pill) for a room.
                 * @param {string} roomIdOrAlias The room ID or alias to get an alias for.
                 * @returns {Promise<string>} Resolves to a published room alias, or falsey if none found.
                 */
                getPublishedAlias(roomIdOrAlias) {
                    return __awaiter(this, void 0, void 0, function* () {
                        try {
                            const roomId = yield this.resolveRoom(roomIdOrAlias);
                            const event = yield this.getRoomStateEvent(roomId, "m.room.canonical_alias", "");
                            if (!event)
                                return null;
                            const canonical = event['alias'];
                            const alt = event['alt_aliases'] || [];
                            return canonical || alt[0];
                        }
                        catch (e) {
                            // Assume none
                            return null;
                        }
                    });
                }
                /**
                 * Adds a new room alias to the room directory
                 * @param {string} alias The alias to add (eg: "#my-room:matrix.org")
                 * @param {string} roomId The room ID to add the alias to
                 * @returns {Promise} resolves when the alias has been added
                 */
                createRoomAlias(alias, roomId) {
                    alias = encodeURIComponent(alias);
                    return this.doRequest("PUT", "/_matrix/client/r0/directory/room/" + alias, null, {
                        "room_id": roomId,
                    });
                }
                /**
                 * Removes a room alias from the room directory
                 * @param {string} alias The alias to remove
                 * @returns {Promise} resolves when the alias has been deleted
                 */
                deleteRoomAlias(alias) {
                    alias = encodeURIComponent(alias);
                    return this.doRequest("DELETE", "/_matrix/client/r0/directory/room/" + alias);
                }
                /**
                 * Sets the visibility of a room in the directory.
                 * @param {string} roomId The room ID to manipulate the visibility of
                 * @param {"public" | "private"} visibility The visibility to set for the room
                 * @return {Promise} resolves when the visibility has been updated
                 */
                setDirectoryVisibility(roomId, visibility) {
                    roomId = encodeURIComponent(roomId);
                    return this.doRequest("PUT", "/_matrix/client/r0/directory/list/room/" + roomId, null, {
                        "visibility": visibility,
                    });
                }
                /**
                 * Gets the visibility of a room in the directory.
                 * @param {string} roomId The room ID to query the visibility of
                 * @return {Promise<"public"|"private">} The visibility of the room
                 */
                getDirectoryVisibility(roomId) {
                    roomId = encodeURIComponent(roomId);
                    return this.doRequest("GET", "/_matrix/client/r0/directory/list/room/" + roomId).then(response => {
                        return response["visibility"];
                    });
                }
                /**
                 * Resolves a room ID or alias to a room ID. If the given ID or alias looks like a room ID
                 * already, it will be returned as-is. If the room ID or alias looks like a room alias, it
                 * will be resolved to a room ID if possible. If the room ID or alias is neither, an error
                 * will be raised.
                 * @param {string} roomIdOrAlias the room ID or alias to resolve to a room ID
                 * @returns {Promise<string>} resolves to the room ID
                 */
                resolveRoom(roomIdOrAlias) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (roomIdOrAlias.startsWith("!"))
                            return roomIdOrAlias; // probably
                        if (roomIdOrAlias.startsWith("#"))
                            return this.lookupRoomAlias(roomIdOrAlias).then(r => r.roomId);
                        throw new Error("Invalid room ID or alias");
                    });
                }
                /**
                 * Does a room directory lookup for a given room alias
                 * @param {string} roomAlias the room alias to look up in the room directory
                 * @returns {Promise<RoomDirectoryLookupResponse>} resolves to the room's information
                 */
                lookupRoomAlias(roomAlias) {
                    return this.doRequest("GET", "/_matrix/client/r0/directory/room/" + encodeURIComponent(roomAlias)).then(response => {
                        return {
                            roomId: response["room_id"],
                            residentServers: response["servers"],
                        };
                    });
                }
                /**
                 * Invites a user to a room.
                 * @param {string} userId the user ID to invite
                 * @param {string} roomId the room ID to invite the user to
                 * @returns {Promise<any>} resolves when completed
                 */
                inviteUser(userId, roomId) {
                    return this.doRequest("POST", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/invite", null, {
                        user_id: userId,
                    });
                }
                /**
                 * Kicks a user from a room.
                 * @param {string} userId the user ID to kick
                 * @param {string} roomId the room ID to kick the user in
                 * @param {string?} reason optional reason for the kick
                 * @returns {Promise<any>} resolves when completed
                 */
                kickUser(userId, roomId, reason = null) {
                    return this.doRequest("POST", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/kick", null, {
                        user_id: userId,
                        reason: reason,
                    });
                }
                /**
                 * Bans a user from a room.
                 * @param {string} userId the user ID to ban
                 * @param {string} roomId the room ID to set the ban in
                 * @param {string?} reason optional reason for the ban
                 * @returns {Promise<any>} resolves when completed
                 */
                banUser(userId, roomId, reason = null) {
                    return this.doRequest("POST", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/ban", null, {
                        user_id: userId,
                        reason: reason,
                    });
                }
                /**
                 * Unbans a user in a room.
                 * @param {string} userId the user ID to unban
                 * @param {string} roomId the room ID to lift the ban in
                 * @returns {Promise<any>} resolves when completed
                 */
                unbanUser(userId, roomId) {
                    return this.doRequest("POST", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/unban", null, {
                        user_id: userId,
                    });
                }
                /**
                 * Gets the current user ID for this client
                 * @returns {Promise<string>} The user ID of this client
                 */
                getUserId() {
                    if (this.userId)
                        return Promise.resolve(this.userId);
                    return this.getWhoAmI().then(response => {
                        this.userId = response["user_id"];
                        return this.userId;
                    });
                }
                /**
                 * Gets the user's information from the server directly.
                 * @returns {Promise<IWhoAmI>} The "who am I" response.
                 */
                getWhoAmI() {
                    return this.doRequest("GET", "/_matrix/client/r0/account/whoami");
                }
                /**
                 * Stops the client from syncing.
                 */
                stop() {
                    this.stopSyncing = true;
                }
                /**
                 * Starts syncing the client with an optional filter
                 * @param {any} filter The filter to use, or null for none
                 * @returns {Promise<any>} Resolves when the client has started syncing
                 */
                start(filter = null) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.stopSyncing = false;
                        if (!filter || typeof (filter) !== "object") {
                            LogService_5.LogService.trace("MatrixClientLite", "No filter given or invalid object - using defaults.");
                            filter = null;
                        }
                        LogService_5.LogService.trace("MatrixClientLite", "Populating joined rooms to avoid excessive join emits");
                        this.lastJoinedRoomIds = yield this.getJoinedRooms();
                        const userId = yield this.getUserId();
                        if (this.crypto) {
                            LogService_5.LogService.debug("MatrixClientLite", "Preparing end-to-end encryption");
                            yield this.crypto.prepare(this.lastJoinedRoomIds);
                            LogService_5.LogService.info("MatrixClientLite", "End-to-end encryption enabled");
                        }
                        let createFilter = false;
                        // noinspection ES6RedundantAwait
                        let existingFilter = yield Promise.resolve(this.storage.getFilter());
                        if (existingFilter) {
                            LogService_5.LogService.trace("MatrixClientLite", "Found existing filter. Checking consistency with given filter");
                            if (JSON.stringify(existingFilter.filter) === JSON.stringify(filter)) {
                                LogService_5.LogService.trace("MatrixClientLite", "Filters match");
                                this.filterId = existingFilter.id;
                            }
                            else {
                                createFilter = true;
                            }
                        }
                        else {
                            createFilter = true;
                        }
                        if (createFilter && filter) {
                            LogService_5.LogService.trace("MatrixClientLite", "Creating new filter");
                            return this.doRequest("POST", "/_matrix/client/r0/user/" + encodeURIComponent(userId) + "/filter", null, filter).then((response) => __awaiter(this, void 0, void 0, function* () {
                                this.filterId = response["filter_id"];
                                // noinspection ES6RedundantAwait
                                yield Promise.resolve(this.storage.setSyncToken(null));
                                // noinspection ES6RedundantAwait
                                yield Promise.resolve(this.storage.setFilter({
                                    id: this.filterId,
                                    filter: filter,
                                }));
                            }));
                        }
                        LogService_5.LogService.trace("MatrixClientLite", "Starting sync with filter ID " + this.filterId);
                        return this.startSyncInternal();
                    });
                }
                startSyncInternal() {
                    return this.startSync();
                }
                startSync(emitFn = null) {
                    return __awaiter(this, void 0, void 0, function* () {
                        // noinspection ES6RedundantAwait
                        let token = yield Promise.resolve(this.storage.getSyncToken());
                        const promiseWhile = () => __awaiter(this, void 0, void 0, function* () {
                            if (this.stopSyncing) {
                                LogService_5.LogService.info("MatrixClientLite", "Client stop requested - stopping sync");
                                return;
                            }
                            try {
                                const response = yield this.doSync(token);
                                token = response["next_batch"];
                                if (!this.persistTokenAfterSync) {
                                    yield Promise.resolve(this.storage.setSyncToken(token));
                                }
                                LogService_5.LogService.debug("MatrixClientLite", "Received sync. Next token: " + token);
                                yield this.processSync(response, emitFn);
                                if (this.persistTokenAfterSync) {
                                    yield Promise.resolve(this.storage.setSyncToken(token));
                                }
                            }
                            catch (e) {
                                LogService_5.LogService.error("MatrixClientLite", "Error handling sync " + LogService_5.extractRequestError(e));
                                const backoffTime = SYNC_BACKOFF_MIN_MS + Math.random() * (SYNC_BACKOFF_MAX_MS - SYNC_BACKOFF_MIN_MS);
                                LogService_5.LogService.info("MatrixClientLite", `Backing off for ${backoffTime}ms`);
                                yield new Promise((r) => setTimeout(r, backoffTime));
                            }
                            return promiseWhile();
                        });
                        promiseWhile(); // start the loop
                    });
                }
                doSync(token) {
                    LogService_5.LogService.debug("MatrixClientLite", "Performing sync with token " + token);
                    const conf = {
                        full_state: false,
                        timeout: Math.max(0, this.syncingTimeout),
                    };
                    // synapse complains if the variables are null, so we have to have it unset instead
                    if (token)
                        conf["since"] = token;
                    if (this.filterId)
                        conf['filter'] = this.filterId;
                    if (this.syncingPresence)
                        conf['presence'] = this.syncingPresence;
                    // timeout is 40s if we have a token, otherwise 10min
                    return this.doRequest("GET", "/_matrix/client/r0/sync", conf, null, (token ? 40000 : 600000));
                }
                processSync(raw, emitFn = null) {
                    var _a, _b, _c, _d, _e, _f, _g;
                    return __awaiter(this, void 0, void 0, function* () {
                        if (!emitFn)
                            emitFn = (e, ...p) => Promise.resolve(this.emit(e, ...p));
                        if (!raw)
                            return; // nothing to process
                        if (raw['device_one_time_keys_count']) {
                            (_a = this.crypto) === null || _a === void 0 ? void 0 : _a.updateCounts(raw['device_one_time_keys_count']);
                        }
                        let unusedFallbacks = null;
                        if (raw['org.matrix.msc2732.device_unused_fallback_key_types']) {
                            unusedFallbacks = raw['org.matrix.msc2732.device_unused_fallback_key_types'];
                        }
                        else if (raw['device_unused_fallback_key_types']) {
                            unusedFallbacks = raw['device_unused_fallback_key_types'];
                        }
                        // XXX: We should be able to detect the presence of the array, but Synapse doesn't tell us about
                        // feature support if we didn't upload one, so assume we're on a latest version of Synapse at least.
                        if (!(unusedFallbacks === null || unusedFallbacks === void 0 ? void 0 : unusedFallbacks.includes(Crypto_4.OTKAlgorithm.Signed))) {
                            yield ((_b = this.crypto) === null || _b === void 0 ? void 0 : _b.updateFallbackKey());
                        }
                        if (raw['device_lists']) {
                            const changed = raw['device_lists']['changed'];
                            const removed = raw['device_lists']['left'];
                            if (changed) {
                                (_c = this.crypto) === null || _c === void 0 ? void 0 : _c.flagUsersDeviceListsOutdated(changed, true);
                            }
                            if (removed) {
                                // Don't resync removed device lists: they are uninteresting according to the server so we
                                // don't need them. When we request the user's device list again, we'll pull it all back in.
                                (_d = this.crypto) === null || _d === void 0 ? void 0 : _d.flagUsersDeviceListsOutdated(removed, false);
                            }
                        }
                        // Always process device messages first to ensure there are decryption keys
                        if ((_e = raw['to_device']) === null || _e === void 0 ? void 0 : _e['events']) {
                            const inbox = raw['to_device']['events'];
                            for (const message of inbox) {
                                if (message['type'] === 'm.room.encrypted') {
                                    yield ((_f = this.crypto) === null || _f === void 0 ? void 0 : _f.processInboundDeviceMessage(message));
                                }
                                else {
                                    // TODO: Emit or do something with unknown messages?
                                }
                            }
                        }
                        if (raw['groups']) {
                            const leave = raw['groups']['leave'] || {};
                            for (const groupId of Object.keys(leave)) {
                                yield emitFn("unstable.group.leave", groupId, leave[groupId]);
                            }
                            const join = raw['groups']['join'] || {};
                            for (const groupId of Object.keys(join)) {
                                yield emitFn("unstable.group.join", groupId, join[groupId]);
                            }
                            const invite = raw['groups']['invite'] || {};
                            for (const groupId of Object.keys(invite)) {
                                yield emitFn("unstable.group.invite", groupId, invite[groupId]);
                            }
                        }
                        if (raw['account_data'] && raw['account_data']['events']) {
                            for (const event of raw['account_data']['events']) {
                                yield emitFn("account_data", event);
                            }
                        }
                        if (!raw['rooms'])
                            return; // nothing more to process
                        let leftRooms = raw['rooms']['leave'] || {};
                        let inviteRooms = raw['rooms']['invite'] || {};
                        let joinedRooms = raw['rooms']['join'] || {};
                        // Process rooms we've left first
                        for (let roomId in leftRooms) {
                            const room = leftRooms[roomId];
                            if (room['account_data'] && room['account_data']['events']) {
                                for (const event of room['account_data']['events']) {
                                    yield emitFn("room.account_data", roomId, event);
                                }
                            }
                            if (!room['timeline'] || !room['timeline']['events'])
                                continue;
                            let leaveEvent = null;
                            for (let event of room['timeline']['events']) {
                                if (event['type'] !== 'm.room.member')
                                    continue;
                                if (event['state_key'] !== (yield this.getUserId()))
                                    continue;
                                const oldAge = leaveEvent && leaveEvent['unsigned'] && leaveEvent['unsigned']['age'] ? leaveEvent['unsigned']['age'] : 0;
                                const newAge = event['unsigned'] && event['unsigned']['age'] ? event['unsigned']['age'] : 0;
                                if (leaveEvent && oldAge < newAge)
                                    continue;
                                leaveEvent = event;
                            }
                            if (!leaveEvent) {
                                LogService_5.LogService.warn("MatrixClientLite", "Left room " + roomId + " without receiving an event");
                                continue;
                            }
                            leaveEvent = yield this.processEvent(leaveEvent);
                            yield emitFn("room.leave", roomId, leaveEvent);
                            this.lastJoinedRoomIds = this.lastJoinedRoomIds.filter(r => r !== roomId);
                        }
                        // Process rooms we've been invited to
                        for (let roomId in inviteRooms) {
                            const room = inviteRooms[roomId];
                            if (!room['invite_state'] || !room['invite_state']['events'])
                                continue;
                            let inviteEvent = null;
                            for (let event of room['invite_state']['events']) {
                                if (event['type'] !== 'm.room.member')
                                    continue;
                                if (event['state_key'] !== (yield this.getUserId()))
                                    continue;
                                if (!event['content'])
                                    continue;
                                if (event['content']['membership'] !== "invite")
                                    continue;
                                const oldAge = inviteEvent && inviteEvent['unsigned'] && inviteEvent['unsigned']['age'] ? inviteEvent['unsigned']['age'] : 0;
                                const newAge = event['unsigned'] && event['unsigned']['age'] ? event['unsigned']['age'] : 0;
                                if (inviteEvent && oldAge < newAge)
                                    continue;
                                inviteEvent = event;
                            }
                            if (!inviteEvent) {
                                LogService_5.LogService.warn("MatrixClientLite", "Invited to room " + roomId + " without receiving an event");
                                continue;
                            }
                            inviteEvent = yield this.processEvent(inviteEvent);
                            yield emitFn("room.invite", roomId, inviteEvent);
                        }
                        // Process rooms we've joined and their events
                        for (let roomId in joinedRooms) {
                            if (this.lastJoinedRoomIds.indexOf(roomId) === -1) {
                                yield emitFn("room.join", roomId);
                                this.lastJoinedRoomIds.push(roomId);
                            }
                            const room = joinedRooms[roomId];
                            if (room['account_data'] && room['account_data']['events']) {
                                for (const event of room['account_data']['events']) {
                                    yield emitFn("room.account_data", roomId, event);
                                }
                            }
                            if (!room['timeline'] || !room['timeline']['events'])
                                continue;
                            for (let event of room['timeline']['events']) {
                                event = yield this.processEvent(event);
                                if (event['type'] === 'm.room.encrypted' && (yield ((_g = this.crypto) === null || _g === void 0 ? void 0 : _g.isRoomEncrypted(roomId)))) {
                                    yield emitFn("room.encrypted_event", roomId, event);
                                    try {
                                        event = (yield this.crypto.decryptRoomEvent(new EncryptedRoomEvent_3.EncryptedRoomEvent(event), roomId)).raw;
                                        event = yield this.processEvent(event);
                                        yield emitFn("room.decrypted_event", roomId, event);
                                    }
                                    catch (e) {
                                        LogService_5.LogService.error("MatrixClientLite", `Decryption error on ${roomId} ${event['event_id']}`, e);
                                        yield emitFn("room.failed_decryption", roomId, event, e);
                                    }
                                }
                                if (event['type'] === 'm.room.message') {
                                    yield emitFn("room.message", roomId, event);
                                }
                                if (event['type'] === 'm.room.tombstone' && event['state_key'] === '') {
                                    yield emitFn("room.archived", roomId, event);
                                }
                                if (event['type'] === 'm.room.create' && event['state_key'] === '' && event['content']
                                    && event['content']['predecessor'] && event['content']['predecessor']['room_id']) {
                                    yield emitFn("room.upgraded", roomId, event);
                                }
                                yield emitFn("room.event", roomId, event);
                            }
                        }
                    });
                }
                /**
                 * Gets an event for a room. If the event is encrypted, and the client supports encryption,
                 * and the room is encrypted, then this will return a decrypted event.
                 * @param {string} roomId the room ID to get the event in
                 * @param {string} eventId the event ID to look up
                 * @returns {Promise<any>} resolves to the found event
                 */
                getEvent(roomId, eventId) {
                    var _a;
                    return __awaiter(this, void 0, void 0, function* () {
                        const event = yield this.getRawEvent(roomId, eventId);
                        if (event['type'] === 'm.room.encrypted' && (yield ((_a = this.crypto) === null || _a === void 0 ? void 0 : _a.isRoomEncrypted(roomId)))) {
                            return this.processEvent((yield this.crypto.decryptRoomEvent(new EncryptedRoomEvent_3.EncryptedRoomEvent(event), roomId)).raw);
                        }
                        return event;
                    });
                }
                /**
                 * Gets an event for a room. Returned as a raw event.
                 * @param {string} roomId the room ID to get the event in
                 * @param {string} eventId the event ID to look up
                 * @returns {Promise<any>} resolves to the found event
                 */
                getRawEvent(roomId, eventId) {
                    return this.doRequest("GET", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/event/" + encodeURIComponent(eventId))
                        .then(ev => this.processEvent(ev));
                }
                /**
                 * Gets the room state for the given room. Returned as raw events.
                 * @param {string} roomId the room ID to get state for
                 * @returns {Promise<any[]>} resolves to the room's state
                 */
                getRoomState(roomId) {
                    return this.doRequest("GET", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/state")
                        .then(state => Promise.all(state.map(ev => this.processEvent(ev))));
                }
                /**
                 * Gets the state events for a given room of a given type under the given state key.
                 * @param {string} roomId the room ID
                 * @param {string} type the event type
                 * @param {String} stateKey the state key, falsey if not needed
                 * @returns {Promise<any|any[]>} resolves to the state event(s)
                 * @deprecated It is not possible to get an array of events - use getRoomStateEvent instead
                 */
                getRoomStateEvents(roomId, type, stateKey) {
                    return this.getRoomStateEvent(roomId, type, stateKey);
                }
                /**
                 * Gets a state event for a given room of a given type under the given state key.
                 * @param {string} roomId the room ID
                 * @param {string} type the event type
                 * @param {String} stateKey the state key
                 * @returns {Promise<any>} resolves to the state event
                 */
                getRoomStateEvent(roomId, type, stateKey) {
                    return this.doRequest("GET", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/state/" + encodeURIComponent(type) + "/" + encodeURIComponent(stateKey ? stateKey : ''))
                        .then(ev => this.processEvent(ev));
                }
                /**
                 * Gets the context surrounding an event.
                 * @param {string} roomId The room ID to get the context in.
                 * @param {string} eventId The event ID to get the context of.
                 * @param {number} limit The maximum number of events to return on either side of the event.
                 * @returns {Promise<EventContext>} The context of the event
                 */
                getEventContext(roomId, eventId, limit = 10) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const res = yield this.doRequest("GET", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/context/" + encodeURIComponent(eventId), { limit });
                        return {
                            event: new RoomEvent_19.RoomEvent(res['event']),
                            before: res['events_before'].map(e => new RoomEvent_19.RoomEvent(e)),
                            after: res['events_after'].map(e => new RoomEvent_19.RoomEvent(e)),
                            state: res['state'].map(e => new RoomEvent_19.StateEvent(e)),
                        };
                    });
                }
                /**
                 * Gets the profile for a given user
                 * @param {string} userId the user ID to lookup
                 * @returns {Promise<any>} the profile of the user
                 */
                getUserProfile(userId) {
                    return this.doRequest("GET", "/_matrix/client/r0/profile/" + encodeURIComponent(userId));
                }
                /**
                 * Sets a new display name for the user.
                 * @param {string} displayName the new display name for the user, or null to clear
                 * @returns {Promise<any>} resolves when complete
                 */
                setDisplayName(displayName) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const userId = encodeURIComponent(yield this.getUserId());
                        return this.doRequest("PUT", "/_matrix/client/r0/profile/" + userId + "/displayname", null, {
                            displayname: displayName,
                        });
                    });
                }
                /**
                 * Sets a new avatar url for the user.
                 * @param {string} avatarUrl the new avatar URL for the user, in the form of a Matrix Content URI
                 * @returns {Promise<any>} resolves when complete
                 */
                setAvatarUrl(avatarUrl) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const userId = encodeURIComponent(yield this.getUserId());
                        return this.doRequest("PUT", "/_matrix/client/r0/profile/" + userId + "/avatar_url", null, {
                            avatar_url: avatarUrl,
                        });
                    });
                }
                /**
                 * Joins the given room
                 * @param {string} roomIdOrAlias the room ID or alias to join
                 * @param {string[]} viaServers the server names to try and join through
                 * @returns {Promise<string>} resolves to the joined room ID
                 */
                joinRoom(roomIdOrAlias, viaServers = []) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const apiCall = (targetIdOrAlias) => {
                            targetIdOrAlias = encodeURIComponent(targetIdOrAlias);
                            const qs = {};
                            if (viaServers.length > 0)
                                qs['server_name'] = viaServers;
                            return this.doRequest("POST", "/_matrix/client/r0/join/" + targetIdOrAlias, qs).then(response => {
                                return response['room_id'];
                            });
                        };
                        const userId = yield this.getUserId();
                        if (this.joinStrategy)
                            return this.joinStrategy.joinRoom(roomIdOrAlias, userId, apiCall);
                        else
                            return apiCall(roomIdOrAlias);
                    });
                }
                /**
                 * Gets a list of joined room IDs
                 * @returns {Promise<string[]>} resolves to a list of room IDs the client participates in
                 */
                getJoinedRooms() {
                    return this.doRequest("GET", "/_matrix/client/r0/joined_rooms").then(response => response['joined_rooms']);
                }
                /**
                 * Gets the joined members in a room. The client must be in the room to make this request.
                 * @param {string} roomId The room ID to get the joined members of.
                 * @returns {Promise<string>} The joined user IDs in the room
                 */
                getJoinedRoomMembers(roomId) {
                    return this.doRequest("GET", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/joined_members").then(response => {
                        return Object.keys(response['joined']);
                    });
                }
                /**
                 * Gets the joined members in a room, as an object mapping userIds to profiles. The client must be in the room to make this request.
                 * @param {string} roomId The room ID to get the joined members of.
                 * @returns {Object} The joined user IDs in the room as an object mapped to a set of profiles.
                 */
                getJoinedRoomMembersWithProfiles(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return (yield this.doRequest("GET", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/joined_members")).joined;
                    });
                }
                /**
                 * Gets the membership events of users in the room. Defaults to all membership
                 * types, though this can be controlled with the membership and notMembership
                 * arguments. To change the point in time, use the batchToken.
                 * @param {string} roomId The room ID to get members in.
                 * @param {string} batchToken The point in time to get members at (or null for 'now')
                 * @param {string[]} membership The membership kinds to search for.
                 * @param {string[]} notMembership The membership kinds to not search for.
                 * @returns {Promise<any[]>} Resolves to the membership events of the users in the room.
                 */
                getRoomMembers(roomId, batchToken = null, membership = null, notMembership = null) {
                    const qs = {};
                    if (batchToken)
                        qs["at"] = batchToken;
                    if (membership)
                        qs["membership"] = membership;
                    if (notMembership)
                        qs["not_membership"] = notMembership;
                    return this.doRequest("GET", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/members", qs).then(r => {
                        return r['chunk'].map(e => new MembershipEvent_4.MembershipEvent(e));
                    });
                }
                /**
                 * Leaves the given room
                 * @param {string} roomId the room ID to leave
                 * @returns {Promise<any>} resolves when left
                 */
                leaveRoom(roomId) {
                    return this.doRequest("POST", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/leave");
                }
                /**
                 * Sends a read receipt for an event in a room
                 * @param {string} roomId the room ID to send the receipt to
                 * @param {string} eventId the event ID to set the receipt at
                 * @returns {Promise<any>} resolves when the receipt has been sent
                 */
                sendReadReceipt(roomId, eventId) {
                    return this.doRequest("POST", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/receipt/m.read/" + encodeURIComponent(eventId), null, {});
                }
                /**
                 * Sets the typing status of the current user in a room
                 * @param {string} roomId the room ID the user is typing in
                 * @param {boolean} typing is the user currently typing
                 * @param {number} timeout how long should the server preserve the typing state, in milliseconds
                 * @returns {Promise<any>} resolves when the typing state has been set
                 */
                setTyping(roomId, typing, timeout = 30000) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const userId = yield this.getUserId();
                        return this.doRequest("PUT", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/typing/" + encodeURIComponent(userId), null, {
                            typing,
                            timeout,
                        });
                    });
                }
                /**
                 * Replies to a given event with the given text. The event is sent with a msgtype of m.text.
                 * The message will be encrypted if the client supports encryption and the room is encrypted.
                 * @param {string} roomId the room ID to reply in
                 * @param {any} event the event to reply to
                 * @param {string} text the text to reply with
                 * @param {string} html the HTML to reply with, or falsey to use the `text`
                 * @returns {Promise<string>} resolves to the event ID which was sent
                 */
                replyText(roomId, event, text, html = null) {
                    if (!html)
                        html = htmlencode_1.htmlEncode(text);
                    const reply = RichReply_2.RichReply.createFor(roomId, event, text, html);
                    return this.sendMessage(roomId, reply);
                }
                /**
                 * Replies to a given event with the given HTML. The event is sent with a msgtype of m.text.
                 * The message will be encrypted if the client supports encryption and the room is encrypted.
                 * @param {string} roomId the room ID to reply in
                 * @param {any} event the event to reply to
                 * @param {string} html the HTML to reply with.
                 * @returns {Promise<string>} resolves to the event ID which was sent
                 */
                replyHtmlText(roomId, event, html) {
                    const text = html_to_text_1.htmlToText(html, { wordwrap: false });
                    const reply = RichReply_2.RichReply.createFor(roomId, event, text, html);
                    return this.sendMessage(roomId, reply);
                }
                /**
                 * Replies to a given event with the given text. The event is sent with a msgtype of m.notice.
                 * The message will be encrypted if the client supports encryption and the room is encrypted.
                 * @param {string} roomId the room ID to reply in
                 * @param {any} event the event to reply to
                 * @param {string} text the text to reply with
                 * @param {string} html the HTML to reply with, or falsey to use the `text`
                 * @returns {Promise<string>} resolves to the event ID which was sent
                 */
                replyNotice(roomId, event, text, html = null) {
                    if (!html)
                        html = htmlencode_1.htmlEncode(text);
                    const reply = RichReply_2.RichReply.createFor(roomId, event, text, html);
                    reply['msgtype'] = 'm.notice';
                    return this.sendMessage(roomId, reply);
                }
                /**
                 * Replies to a given event with the given HTML. The event is sent with a msgtype of m.notice.
                 * The message will be encrypted if the client supports encryption and the room is encrypted.
                 * @param {string} roomId the room ID to reply in
                 * @param {any} event the event to reply to
                 * @param {string} html the HTML to reply with.
                 * @returns {Promise<string>} resolves to the event ID which was sent
                 */
                replyHtmlNotice(roomId, event, html) {
                    const text = html_to_text_1.htmlToText(html, { wordwrap: false });
                    const reply = RichReply_2.RichReply.createFor(roomId, event, text, html);
                    reply['msgtype'] = 'm.notice';
                    return this.sendMessage(roomId, reply);
                }
                /**
                 * Sends a notice to the given room. The message will be encrypted if the client supports
                 * encryption and the room is encrypted.
                 * @param {string} roomId the room ID to send the notice to
                 * @param {string} text the text to send
                 * @returns {Promise<string>} resolves to the event ID that represents the message
                 */
                sendNotice(roomId, text) {
                    return this.sendMessage(roomId, {
                        body: text,
                        msgtype: "m.notice",
                    });
                }
                /**
                 * Sends a notice to the given room with HTML content. The message will be encrypted if the client supports
                 * encryption and the room is encrypted.
                 * @param {string} roomId the room ID to send the notice to
                 * @param {string} html the HTML to send
                 * @returns {Promise<string>} resolves to the event ID that represents the message
                 */
                sendHtmlNotice(roomId, html) {
                    return this.sendMessage(roomId, {
                        body: html_to_text_1.htmlToText(html, { wordwrap: false }),
                        msgtype: "m.notice",
                        format: "org.matrix.custom.html",
                        formatted_body: html,
                    });
                }
                /**
                 * Sends a text message to the given room. The message will be encrypted if the client supports
                 * encryption and the room is encrypted.
                 * @param {string} roomId the room ID to send the text to
                 * @param {string} text the text to send
                 * @returns {Promise<string>} resolves to the event ID that represents the message
                 */
                sendText(roomId, text) {
                    return this.sendMessage(roomId, {
                        body: text,
                        msgtype: "m.text",
                    });
                }
                /**
                 * Sends a text message to the given room with HTML content. The message will be encrypted if the client supports
                 * encryption and the room is encrypted.
                 * @param {string} roomId the room ID to send the text to
                 * @param {string} html the HTML to send
                 * @returns {Promise<string>} resolves to the event ID that represents the message
                 */
                sendHtmlText(roomId, html) {
                    return this.sendMessage(roomId, {
                        body: html_to_text_1.htmlToText(html, { wordwrap: false }),
                        msgtype: "m.text",
                        format: "org.matrix.custom.html",
                        formatted_body: html,
                    });
                }
                /**
                 * Sends a message to the given room. The message will be encrypted if the client supports
                 * encryption and the room is encrypted.
                 * @param {string} roomId the room ID to send the message to
                 * @param {object} content the event content to send
                 * @returns {Promise<string>} resolves to the event ID that represents the message
                 */
                sendMessage(roomId, content) {
                    return this.sendEvent(roomId, "m.room.message", content);
                }
                /**
                 * Sends an event to the given room. This will encrypt the event before sending if the room is
                 * encrypted and the client supports encryption. Use sendRawEvent() to avoid this behaviour.
                 * @param {string} roomId the room ID to send the event to
                 * @param {string} eventType the type of event to send
                 * @param {string} content the event body to send
                 * @returns {Promise<string>} resolves to the event ID that represents the event
                 */
                sendEvent(roomId, eventType, content) {
                    var _a;
                    return __awaiter(this, void 0, void 0, function* () {
                        if (yield ((_a = this.crypto) === null || _a === void 0 ? void 0 : _a.isRoomEncrypted(roomId))) {
                            content = yield this.crypto.encryptRoomEvent(roomId, eventType, content);
                            eventType = "m.room.encrypted";
                        }
                        return this.sendRawEvent(roomId, eventType, content);
                    });
                }
                /**
                 * Sends an event to the given room.
                 * @param {string} roomId the room ID to send the event to
                 * @param {string} eventType the type of event to send
                 * @param {string} content the event body to send
                 * @returns {Promise<string>} resolves to the event ID that represents the event
                 */
                sendRawEvent(roomId, eventType, content) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const txnId = (new Date().getTime()) + "__inc" + (++this.requestId);
                        return this.doRequest("PUT", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/send/" + encodeURIComponent(eventType) + "/" + encodeURIComponent(txnId), null, content).then(response => {
                            return response['event_id'];
                        });
                    });
                }
                /**
                 * Sends a state event to the given room
                 * @param {string} roomId the room ID to send the event to
                 * @param {string} type the event type to send
                 * @param {string} stateKey the state key to send, should not be null
                 * @param {string} content the event body to send
                 * @returns {Promise<string>} resolves to the event ID that represents the message
                 */
                sendStateEvent(roomId, type, stateKey, content) {
                    return this.doRequest("PUT", "/_matrix/client/r0/rooms/" + encodeURIComponent(roomId) + "/state/" + encodeURIComponent(type) + "/" + encodeURIComponent(stateKey), null, content).then(response => {
                        return response['event_id'];
                    });
                }
                /**
                 * Redact an event in a given room
                 * @param {string} roomId the room ID to send the redaction to
                 * @param {string} eventId the event ID to redact
                 * @param {String} reason an optional reason for redacting the event
                 * @returns {Promise<string>} resolves to the event ID that represents the redaction
                 */
                redactEvent(roomId, eventId, reason = null) {
                    const txnId = (new Date().getTime()) + "__inc" + (++this.requestId);
                    const content = reason !== null ? { reason } : {};
                    return this.doRequest("PUT", `/_matrix/client/r0/rooms/${encodeURIComponent(roomId)}/redact/${encodeURIComponent(eventId)}/${txnId}`, null, content).then(response => {
                        return response['event_id'];
                    });
                }
                /**
                 * Creates a room. This does not break out the various options for creating a room
                 * due to the large number of possibilities. See the /createRoom endpoint in the
                 * spec for more information on what to provide for `properties`. Note that creating
                 * a room may cause the bot/appservice to raise a join event.
                 * @param {any} properties the properties of the room. See the spec for more information
                 * @returns {Promise<string>} resolves to the room ID that represents the room
                 */
                createRoom(properties = {}) {
                    return this.doRequest("POST", "/_matrix/client/r0/createRoom", null, properties).then(response => {
                        return response['room_id'];
                    });
                }
                /**
                 * Checks if a given user has a required power level required to send the given event.
                 * @param {string} userId the user ID to check the power level of
                 * @param {string} roomId the room ID to check the power level in
                 * @param {string} eventType the event type to look for in the `events` property of the power levels
                 * @param {boolean} isState true to indicate the event is intended to be a state event
                 * @returns {Promise<boolean>} resolves to true if the user has the required power level, resolves to false otherwise
                 */
                userHasPowerLevelFor(userId, roomId, eventType, isState) {
                    var _a, _b;
                    return __awaiter(this, void 0, void 0, function* () {
                        const powerLevelsEvent = yield this.getRoomStateEvent(roomId, "m.room.power_levels", "");
                        if (!powerLevelsEvent) {
                            // This is technically supposed to be non-fatal, but it's pretty unreasonable for a room to be missing
                            // power levels.
                            throw new Error("No power level event found");
                        }
                        let requiredPower = isState ? 50 : 0;
                        if (isState && Number.isFinite(powerLevelsEvent["state_default"]))
                            requiredPower = powerLevelsEvent["state_default"];
                        if (!isState && Number.isFinite(powerLevelsEvent["events_default"]))
                            requiredPower = powerLevelsEvent["events_default"];
                        if (Number.isFinite((_a = powerLevelsEvent["events"]) === null || _a === void 0 ? void 0 : _a[eventType]))
                            requiredPower = powerLevelsEvent["events"][eventType];
                        let userPower = 0;
                        if (Number.isFinite(powerLevelsEvent["users_default"]))
                            userPower = powerLevelsEvent["users_default"];
                        if (Number.isFinite((_b = powerLevelsEvent["users"]) === null || _b === void 0 ? void 0 : _b[userId]))
                            userPower = powerLevelsEvent["users"][userId];
                        return userPower >= requiredPower;
                    });
                }
                /**
                 * Checks if a given user has a required power level to perform the given action
                 * @param {string} userId the user ID to check the power level of
                 * @param {string} roomId the room ID to check the power level in
                 * @param {PowerLevelAction} action the action to check power level for
                 * @returns {Promise<boolean>} resolves to true if the user has the required power level, resolves to false otherwise
                 */
                userHasPowerLevelForAction(userId, roomId, action) {
                    var _a;
                    return __awaiter(this, void 0, void 0, function* () {
                        const powerLevelsEvent = yield this.getRoomStateEvent(roomId, "m.room.power_levels", "");
                        if (!powerLevelsEvent) {
                            // This is technically supposed to be non-fatal, but it's pretty unreasonable for a room to be missing
                            // power levels.
                            throw new Error("No power level event found");
                        }
                        const defaultForActions = {
                            [PowerLevelAction_1.PowerLevelAction.Ban]: 50,
                            [PowerLevelAction_1.PowerLevelAction.Invite]: 50,
                            [PowerLevelAction_1.PowerLevelAction.Kick]: 50,
                            [PowerLevelAction_1.PowerLevelAction.RedactEvents]: 50,
                            [PowerLevelAction_1.PowerLevelAction.NotifyRoom]: 50,
                        };
                        let requiredPower = defaultForActions[action];
                        let investigate = powerLevelsEvent;
                        action.split('.').forEach(k => (investigate = investigate === null || investigate === void 0 ? void 0 : investigate[k]));
                        if (Number.isFinite(investigate))
                            requiredPower = investigate;
                        let userPower = 0;
                        if (Number.isFinite(powerLevelsEvent["users_default"]))
                            userPower = powerLevelsEvent["users_default"];
                        if (Number.isFinite((_a = powerLevelsEvent["users"]) === null || _a === void 0 ? void 0 : _a[userId]))
                            userPower = powerLevelsEvent["users"][userId];
                        return userPower >= requiredPower;
                    });
                }
                /**
                 * Determines the boundary conditions for this client's ability to change another user's power level
                 * in a given room. This will identify the maximum possible level this client can change the user to,
                 * and if that change could even be possible. If the returned object indicates that the client can
                 * change the power level of the user, the client is able to set the power level to any value equal
                 * to or less than the maximum value.
                 * @param {string} targetUserId The user ID to compare against.
                 * @param {string} roomId The room ID to compare within.
                 * @returns {Promise<PowerLevelBounds>} The bounds of the client's ability to change the user's power level.
                 */
                calculatePowerLevelChangeBoundsOn(targetUserId, roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const myUserId = yield this.getUserId();
                        const canChangePower = yield this.userHasPowerLevelFor(myUserId, roomId, "m.room.power_levels", true);
                        if (!canChangePower)
                            return { canModify: false, maximumPossibleLevel: 0 };
                        const powerLevelsEvent = yield this.getRoomStateEvent(roomId, "m.room.power_levels", "");
                        if (!powerLevelsEvent) {
                            throw new Error("No power level event found");
                        }
                        let targetUserPower = 0;
                        let myUserPower = 0;
                        if (powerLevelsEvent["users"] && powerLevelsEvent["users"][targetUserId])
                            targetUserPower = powerLevelsEvent["users"][targetUserId];
                        if (powerLevelsEvent["users"] && powerLevelsEvent["users"][myUserId])
                            myUserPower = powerLevelsEvent["users"][myUserId];
                        if (myUserId === targetUserId) {
                            return { canModify: true, maximumPossibleLevel: myUserPower };
                        }
                        if (targetUserPower >= myUserPower) {
                            return { canModify: false, maximumPossibleLevel: myUserPower };
                        }
                        return { canModify: true, maximumPossibleLevel: myUserPower };
                    });
                }
                /**
                 * Sets the power level for a given user ID in the given room. Note that this is not safe to
                 * call multiple times concurrently as changes are not atomic. This will throw an error if
                 * the user lacks enough permission to change the power level, or if a power level event is
                 * missing from the room.
                 * @param {string} userId The user ID to change
                 * @param {string} roomId The room ID to change the power level in
                 * @param {number} newLevel The integer power level to set the user to.
                 * @returns {Promise<any>} Resolves when complete.
                 */
                setUserPowerLevel(userId, roomId, newLevel) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const currentLevels = yield this.getRoomStateEvent(roomId, "m.room.power_levels", "");
                        if (!currentLevels['users'])
                            currentLevels['users'] = {};
                        currentLevels['users'][userId] = newLevel;
                        yield this.sendStateEvent(roomId, "m.room.power_levels", "", currentLevels);
                    });
                }
                /**
                 * Converts a MXC URI to an HTTP URL.
                 * @param {string} mxc The MXC URI to convert
                 * @returns {string} The HTTP URL for the content.
                 */
                mxcToHttp(mxc) {
                    if (!mxc.startsWith("mxc://"))
                        throw new Error("Not a MXC URI");
                    const parts = mxc.substring("mxc://".length).split('/');
                    const originHomeserver = parts[0];
                    const mediaId = parts.slice(1, parts.length).join('/');
                    return `${this.homeserverUrl}/_matrix/media/r0/download/${encodeURIComponent(originHomeserver)}/${encodeURIComponent(mediaId)}`;
                }
                /**
                 * Converts a MXC URI to an HTTP URL for downsizing the content.
                 * @param {string} mxc The MXC URI to convert and downsize.
                 * @param {number} width The width, as an integer, for the thumbnail.
                 * @param {number} height The height, as an intenger, for the thumbnail.
                 * @param {"crop"|"scale"} method Whether to crop or scale (preserve aspect ratio) the content.
                 * @returns {string} The HTTP URL for the downsized content.
                 */
                mxcToHttpThumbnail(mxc, width, height, method) {
                    const downloadUri = this.mxcToHttp(mxc);
                    return downloadUri.replace("/_matrix/media/r0/download", "/_matrix/media/r0/thumbnail")
                        + `?width=${width}&height=${height}&method=${encodeURIComponent(method)}`;
                }
                /**
                 * Uploads data to the homeserver's media repository. Note that this will <b>not</b> automatically encrypt
                 * media as it cannot determine if the media should be encrypted.
                 * @param {Buffer} data the content to upload.
                 * @param {string} contentType the content type of the file. Defaults to application/octet-stream
                 * @param {string} filename the name of the file. Optional.
                 * @returns {Promise<string>} resolves to the MXC URI of the content
                 */
                uploadContent(data, contentType = "application/octet-stream", filename = null) {
                    // TODO: Make doRequest take an object for options
                    return this.doRequest("POST", "/_matrix/media/r0/upload", { filename: filename }, data, 60000, false, contentType)
                        .then(response => response["content_uri"]);
                }
                /**
                 * Download content from the homeserver's media repository. Note that this will <b>not</b> automatically decrypt
                 * media as it cannot determine if the media is encrypted.
                 * @param {string} mxcUrl The MXC URI for the content.
                 * @param {string} allowRemote Indicates to the server that it should not attempt to fetch the
                 * media if it is deemed remote. This is to prevent routing loops where the server contacts itself.
                 * Defaults to true if not provided.
                 * @returns {Promise<{data: Buffer, contentType: string}>} Resolves to the downloaded content.
                 */
                downloadContent(mxcUrl, allowRemote = true) {
                    return __awaiter(this, void 0, void 0, function* () {
                        if (!mxcUrl.toLowerCase().startsWith("mxc://")) {
                            throw Error("'mxcUrl' does not begin with mxc://");
                        }
                        const urlParts = mxcUrl.substr("mxc://".length).split("/");
                        const domain = encodeURIComponent(urlParts[0]);
                        const mediaId = encodeURIComponent(urlParts[1].split("/")[0]);
                        const path = `/_matrix/media/r0/download/${domain}/${mediaId}`;
                        const res = yield this.doRequest("GET", path, { allow_remote: allowRemote }, null, null, true, null, true);
                        return {
                            data: res.body,
                            contentType: res.headers["content-type"],
                        };
                    });
                }
                /**
                 * Uploads data to the homeserver's media repository after downloading it from the
                 * provided URL.
                 * @param {string} url The URL to download content from.
                 * @returns {Promise<string>} Resolves to the MXC URI of the content
                 */
                uploadContentFromUrl(url) {
                    return new Promise((resolve, reject) => {
                        const requestId = ++this.requestId;
                        const params = {
                            uri: url,
                            method: "GET",
                            encoding: null,
                        };
                        request_3.getRequestFn()(params, (err, response, resBody) => {
                            if (err) {
                                LogService_5.LogService.error("MatrixLiteClient (REQ-" + requestId + ")", LogService_5.extractRequestError(err));
                                reject(err);
                            }
                            else {
                                const contentType = response.headers['content-type'] || "application/octet-stream";
                                LogService_5.LogService.trace("MatrixLiteClient (REQ-" + requestId + " RESP-H" + response.statusCode + ")", "<data>");
                                if (response.statusCode < 200 || response.statusCode >= 300) {
                                    LogService_5.LogService.error("MatrixLiteClient (REQ-" + requestId + ")", "<data>");
                                    reject(response);
                                }
                                else
                                    resolve({ body: resBody, contentType: contentType });
                            }
                        });
                    }).then(obj => {
                        return this.uploadContent(obj.body, obj.contentType);
                    });
                }
                /**
                 * Determines the upgrade history for a given room as a doubly-linked list styled structure. Given
                 * a room ID in the history of upgrades, the resulting `previous` array will hold any rooms which
                 * are older than the given room. The resulting `newer` array will hold any rooms which are newer
                 * versions of the room. Both arrays will be defined, but may be empty individually. Element zero
                 * of each will always be the nearest to the given room ID and the last element will be the furthest
                 * from the room. The given room will never be in either array.
                 * @param {string} roomId the room ID to get the history of
                 * @returns {Promise<{previous: RoomReference[], newer: RoomReference[]}>} Resolves to the room's
                 * upgrade history
                 */
                getRoomUpgradeHistory(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = { previous: [], newer: [], current: null };
                        const chaseCreates = (findRoomId) => __awaiter(this, void 0, void 0, function* () {
                            try {
                                const createEvent = yield this.getRoomStateEvent(findRoomId, "m.room.create", "");
                                if (!createEvent)
                                    return;
                                if (findRoomId === roomId && !result.current) {
                                    const version = createEvent['room_version'] || '1';
                                    result.current = {
                                        roomId: roomId,
                                        version: version,
                                        refEventId: null,
                                    };
                                }
                                if (createEvent['predecessor'] && createEvent['predecessor']['room_id']) {
                                    const prevRoomId = createEvent['predecessor']['room_id'];
                                    if (prevRoomId === findRoomId)
                                        return; // Recursion is bad
                                    if (result.previous.find(r => r.roomId === prevRoomId))
                                        return; // Already found
                                    let tombstoneEventId = null;
                                    let prevVersion = "1";
                                    try {
                                        const roomState = yield this.getRoomState(prevRoomId);
                                        const tombstone = roomState.find(e => e['type'] === 'm.room.tombstone' && e['state_key'] === '');
                                        const create = roomState.find(e => e['type'] === 'm.room.create' && e['state_key'] === '');
                                        if (tombstone) {
                                            if (!tombstone['content'])
                                                tombstone['content'] = {};
                                            const tombstoneRefRoomId = tombstone['content']['replacement_room'];
                                            if (tombstoneRefRoomId === findRoomId)
                                                tombstoneEventId = tombstone['event_id'];
                                        }
                                        if (create) {
                                            if (!create['content'])
                                                create['content'] = {};
                                            prevVersion = create['content']['room_version'] || "1";
                                        }
                                    }
                                    catch (e) {
                                        // state not available
                                    }
                                    result.previous.push({
                                        roomId: prevRoomId,
                                        version: prevVersion,
                                        refEventId: tombstoneEventId,
                                    });
                                    return chaseCreates(prevRoomId);
                                }
                            }
                            catch (e) {
                                // no create event - that's fine
                            }
                        });
                        const chaseTombstones = (findRoomId) => __awaiter(this, void 0, void 0, function* () {
                            try {
                                const tombstoneEvent = yield this.getRoomStateEvent(findRoomId, "m.room.tombstone", "");
                                if (!tombstoneEvent)
                                    return;
                                if (!tombstoneEvent['replacement_room'])
                                    return;
                                const newRoomId = tombstoneEvent['replacement_room'];
                                if (newRoomId === findRoomId)
                                    return; // Recursion is bad
                                if (result.newer.find(r => r.roomId === newRoomId))
                                    return; // Already found
                                let newRoomVersion = "1";
                                let createEventId = null;
                                try {
                                    const roomState = yield this.getRoomState(newRoomId);
                                    const create = roomState.find(e => e['type'] === 'm.room.create' && e['state_key'] === '');
                                    if (create) {
                                        if (!create['content'])
                                            create['content'] = {};
                                        const predecessor = create['content']['predecessor'] || {};
                                        const refPrevRoomId = predecessor['room_id'];
                                        if (refPrevRoomId === findRoomId) {
                                            createEventId = create['event_id'];
                                        }
                                        newRoomVersion = create['content']['room_version'] || "1";
                                    }
                                }
                                catch (e) {
                                    // state not available
                                }
                                result.newer.push({
                                    roomId: newRoomId,
                                    version: newRoomVersion,
                                    refEventId: createEventId,
                                });
                                return yield chaseTombstones(newRoomId);
                            }
                            catch (e) {
                                // no tombstone - that's fine
                            }
                        });
                        yield chaseCreates(roomId);
                        yield chaseTombstones(roomId);
                        return result;
                    });
                }
                /**
                 * Creates a Space room.
                 * @param {SpaceCreateOptions} opts The creation options.
                 * @returns {Promise<Space>} Resolves to the created space.
                 */
                createSpace(opts) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const roomCreateOpts = {
                            name: opts.name,
                            topic: opts.topic || "",
                            preset: opts.isPublic ? 'public_chat' : 'private_chat',
                            room_alias_name: opts.localpart,
                            initial_state: [
                                {
                                    type: "m.room.history_visibility",
                                    state_key: "",
                                    content: {
                                        history_visibility: opts.isPublic ? 'world_readable' : 'shared',
                                    },
                                },
                            ],
                            creation_content: {
                                type: "m.space",
                            },
                            invite: opts.invites || [],
                            power_level_content_override: {
                                ban: 100,
                                events_default: 50,
                                invite: 50,
                                kick: 100,
                                notifications: {
                                    room: 100,
                                },
                                redact: 100,
                                state_default: 100,
                                users: {
                                    [yield this.getUserId()]: 100,
                                },
                                users_default: 0,
                            },
                        };
                        if (opts.avatarUrl) {
                            roomCreateOpts.initial_state.push({
                                type: 'm.room.avatar',
                                state_key: "",
                                content: {
                                    url: opts.avatarUrl,
                                },
                            });
                        }
                        const roomId = yield this.createRoom(roomCreateOpts);
                        return new Spaces_2.Space(roomId, this);
                    });
                }
                /**
                 * Gets a Space.
                 * This API does not work with unstable spaces (e.g. org.matrix.msc.1772.space)
                 *
                 * @throws If the room is not a space or there was an error
                 * @returns {Promise<Space>} Resolves to the space.
                 */
                getSpace(roomIdOrAlias) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const roomId = yield this.resolveRoom(roomIdOrAlias);
                        const createEvent = yield this.getRoomStateEvent(roomId, "m.room.create", "");
                        if (createEvent["type"] !== "m.space") {
                            throw new Error("Room is not a space");
                        }
                        return new Spaces_2.Space(roomId, this);
                    });
                }
                /**
                 * Uploads new identity keys for the current device.
                 * @param {EncryptionAlgorithm[]} algorithms The supported algorithms.
                 * @param {Record<DeviceKeyLabel<DeviceKeyAlgorithm, string>, string>} keys The keys for the device.
                 * @returns {Promise<OTKCounts>} Resolves to the current One Time Key counts when complete.
                 */
                uploadDeviceKeys(algorithms, keys) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const obj = {
                            user_id: yield this.getUserId(),
                            device_id: this.crypto.clientDeviceId,
                            algorithms: algorithms,
                            keys: keys,
                        };
                        obj['signatures'] = yield this.crypto.sign(obj);
                        return this.doRequest("POST", "/_matrix/client/r0/keys/upload", null, {
                            device_keys: obj,
                        }).then(r => r['one_time_key_counts']);
                    });
                }
                /**
                 * Uploads One Time Keys for the current device.
                 * @param {OTKs} keys The keys to upload.
                 * @returns {Promise<OTKCounts>} Resolves to the current One Time Key counts when complete.
                 */
                uploadDeviceOneTimeKeys(keys) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.doRequest("POST", "/_matrix/client/r0/keys/upload", null, {
                            one_time_keys: keys,
                        }).then(r => r['one_time_key_counts']);
                    });
                }
                /**
                 * Gets the current One Time Key counts.
                 * @returns {Promise<OTKCounts>} Resolves to the One Time Key counts.
                 */
                checkOneTimeKeyCounts() {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.doRequest("POST", "/_matrix/client/r0/keys/upload", null, {})
                            .then(r => r['one_time_key_counts']);
                    });
                }
                /**
                 * Uploads a fallback One Time Key to the server for usage. This will replace the existing fallback
                 * key.
                 * @param {FallbackKey} fallbackKey The fallback key.
                 * @returns {Promise<OTKCounts>} Resolves to the One Time Key counts.
                 */
                uploadFallbackKey(fallbackKey) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const keyObj = {
                            [`${Crypto_4.OTKAlgorithm.Signed}:${fallbackKey.keyId}`]: fallbackKey.key,
                        };
                        return this.doRequest("POST", "/_matrix/client/r0/keys/upload", null, {
                            "org.matrix.msc2732.fallback_keys": keyObj,
                            "fallback_keys": keyObj,
                        }).then(r => r['one_time_key_counts']);
                    });
                }
                /**
                 * Gets <b>unverified</b> device lists for the given users. The caller is expected to validate
                 * and verify the device lists, including that the returned devices belong to the claimed users.
                 *
                 * Failures with federation are reported in the returned object. Users which did not fail a federation
                 * lookup but have no devices will not appear in either the failures or in the returned devices.
                 *
                 * See https://matrix.org/docs/spec/client_server/r0.6.1#post-matrix-client-r0-keys-query for more
                 * information.
                 * @param {string[]} userIds The user IDs to query.
                 * @param {number} federationTimeoutMs The default timeout for requesting devices over federation. Defaults to
                 * 10 seconds.
                 * @returns {Promise<MultiUserDeviceListResponse>} Resolves to the device list/errors for the requested user IDs.
                 */
                getUserDevices(userIds, federationTimeoutMs = 10000) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const req = {};
                        for (const userId of userIds) {
                            req[userId] = [];
                        }
                        return this.doRequest("POST", "/_matrix/client/r0/keys/query", {}, {
                            timeout: federationTimeoutMs,
                            device_keys: req,
                        });
                    });
                }
                /**
                 * Gets a device list for the client's own account, with metadata. The devices are not verified
                 * in this response, but should be active on the account.
                 * @returns {Promise<OwnUserDevice[]>} Resolves to the active devices on the account.
                 */
                getOwnDevices() {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.doRequest("GET", "/_matrix/client/r0/devices").then(r => {
                            return r['devices'];
                        });
                    });
                }
                /**
                 * Claims One Time Keys for a set of user devices, returning those keys. The caller is expected to verify
                 * and validate the returned keys.
                 *
                 * Failures with federation are reported in the returned object.
                 * @param {Record<string, Record<string, OTKAlgorithm>>} userDeviceMap The map of user IDs to device IDs to
                 * OTKAlgorithm to request a claim for.
                 * @param {number} federationTimeoutMs The default timeout for claiming keys over federation. Defaults to
                 * 10 seconds.
                 */
                claimOneTimeKeys(userDeviceMap, federationTimeoutMs = 10000) {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.doRequest("POST", "/_matrix/client/r0/keys/claim", {}, {
                            timeout: federationTimeoutMs,
                            one_time_keys: userDeviceMap,
                        });
                    });
                }
                /**
                 * Sends to-device messages to the respective users/devices.
                 * @param {string} type The message type being sent.
                 * @param {Record<string, Record<string, any>>} messages The messages to send, mapped as user ID to
                 * device ID (or "*" to denote all of the user's devices) to message payload (content).
                 * @returns {Promise<void>} Resolves when complete.
                 */
                sendToDevices(type, messages) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const txnId = (new Date().getTime()) + "_TDEV__inc" + (++this.requestId);
                        return this.doRequest("PUT", `/_matrix/client/r0/sendToDevice/${encodeURIComponent(type)}/${encodeURIComponent(txnId)}`, null, {
                            messages: messages,
                        });
                    });
                }
                /**
                 * Performs a web request to the homeserver, applying appropriate authorization headers for
                 * this client.
                 * @param {"GET"|"POST"|"PUT"|"DELETE"} method The HTTP method to use in the request
                 * @param {string} endpoint The endpoint to call. For example: "/_matrix/client/r0/account/whoami"
                 * @param {any} qs The query string to send. Optional.
                 * @param {any} body The request body to send. Optional. Will be converted to JSON unless the type is a Buffer.
                 * @param {number} timeout The number of milliseconds to wait before timing out.
                 * @param {boolean} raw If true, the raw response will be returned instead of the response body.
                 * @param {string} contentType The content type to send. Only used if the `body` is a Buffer.
                 * @param {string} noEncoding Set to true to disable encoding, and return a Buffer. Defaults to false
                 * @returns {Promise<any>} Resolves to the response (body), rejected if a non-2xx status code was returned.
                 */
                doRequest(method, endpoint, qs = null, body = null, timeout = 60000, raw = false, contentType = "application/json", noEncoding = false) {
                    if (this.impersonatedUserId) {
                        if (!qs)
                            qs = { "user_id": this.impersonatedUserId };
                        else
                            qs["user_id"] = this.impersonatedUserId;
                    }
                    if (this.impersonatedDeviceId) {
                        if (!qs)
                            qs = { "org.matrix.msc3202.device_id": this.impersonatedDeviceId };
                        else
                            qs["org.matrix.msc3202.device_id"] = this.impersonatedDeviceId;
                    }
                    const headers = {};
                    if (this.accessToken) {
                        headers["Authorization"] = `Bearer ${this.accessToken}`;
                    }
                    return http_2.doHttpRequest(this.homeserverUrl, method, endpoint, qs, body, headers, timeout, raw, contentType, noEncoding);
                }
            };
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getOpenIDConnectToken", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getAccountData", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getRoomAccountData", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, typeof (_a = typeof T !== "undefined" && T) === "function" ? _a : Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getSafeAccountData", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String, typeof (_b = typeof T !== "undefined" && T) === "function" ? _b : Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getSafeRoomAccountData", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "setAccountData", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "setRoomAccountData", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getPresenceStatus", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getPresenceStatusFor", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "setPresenceStatus", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getPublishedAlias", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "createRoomAlias", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "deleteRoomAlias", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "setDirectoryVisibility", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getDirectoryVisibility", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "resolveRoom", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "lookupRoomAlias", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object]),
                __metadata("design:returntype", void 0)
            ], MatrixClient.prototype, "inviteUser", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object, Object]),
                __metadata("design:returntype", void 0)
            ], MatrixClient.prototype, "kickUser", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object, Object]),
                __metadata("design:returntype", void 0)
            ], MatrixClient.prototype, "banUser", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object]),
                __metadata("design:returntype", void 0)
            ], MatrixClient.prototype, "unbanUser", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getUserId", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "doSync", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Function]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "processSync", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getEvent", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getRawEvent", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getRoomState", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getRoomStateEvents", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getRoomStateEvent", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getEventContext", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getUserProfile", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "setDisplayName", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "setAvatarUrl", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, Array]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "joinRoom", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getJoinedRooms", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getJoinedRoomMembers", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getJoinedRoomMembersWithProfiles", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "leaveRoom", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "sendReadReceipt", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, Boolean, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "setTyping", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, Object, String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "replyText", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, Object, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "replyHtmlText", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, Object, String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "replyNotice", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, Object, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "replyHtmlNotice", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "sendNotice", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "sendHtmlNotice", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "sendText", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "sendHtmlText", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "sendMessage", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "sendEvent", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "sendRawEvent", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String, String, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "sendStateEvent", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "redactEvent", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "createRoom", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String, String, Boolean]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "userHasPowerLevelFor", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "userHasPowerLevelForAction", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "calculatePowerLevelChangeBoundsOn", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, String, Number]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "setUserPowerLevel", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", String)
            ], MatrixClient.prototype, "mxcToHttp", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, Number, Number, String]),
                __metadata("design:returntype", String)
            ], MatrixClient.prototype, "mxcToHttpThumbnail", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Buffer, Object, String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "uploadContent", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "uploadContentFromUrl", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getRoomUpgradeHistory", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "createSpace", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getSpace", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                decorators_7.requiresCrypto(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Array, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "uploadDeviceKeys", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                decorators_7.requiresCrypto(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "uploadDeviceOneTimeKeys", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                decorators_7.requiresCrypto(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "checkOneTimeKeyCounts", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                decorators_7.requiresCrypto(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "uploadFallbackKey", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Array, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getUserDevices", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", []),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "getOwnDevices", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                decorators_7.requiresCrypto(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "claimOneTimeKeys", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [String, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "sendToDevices", null);
            __decorate([
                decorators_6.timedMatrixClientFunctionCall(),
                __metadata("design:type", Function),
                __metadata("design:paramtypes", [Object, Object, Object, Object, Object, Object, Object, Object]),
                __metadata("design:returntype", Promise)
            ], MatrixClient.prototype, "doRequest", null);
            exports_85("MatrixClient", MatrixClient);
        }
    };
});
System.register("AdminApis", ["SynapseAdminApis"], function (exports_86, context_86) {
    "use strict";
    var SynapseAdminApis_2, AdminApis;
    var __moduleName = context_86 && context_86.id;
    return {
        setters: [
            function (SynapseAdminApis_2_1) {
                SynapseAdminApis_2 = SynapseAdminApis_2_1;
            }
        ],
        execute: function () {
            /**
             * Access to various administrative APIs.
             * @category Admin APIs
             */
            AdminApis = class AdminApis {
                constructor(client) {
                    this.client = client;
                }
                /**
                 * Gets access to the Synapse administrative APIs object.
                 */
                get synapse() {
                    return new SynapseAdminApis_2.SynapseAdminApis(this.client);
                }
                /**
                 * Gets information about a particular user.
                 * @param {string} userId the user ID to lookup
                 * @returns {Promise<WhoisInfo>} resolves to the whois information
                 */
                whoisUser(userId) {
                    return this.client.doRequest("GET", "/_matrix/client/r0/admin/whois/" + encodeURIComponent(userId));
                }
            };
            exports_86("AdminApis", AdminApis);
        }
    };
});
System.register("storage/CryptexCryptoSecureStorageProvider", ["cryptex"], function (exports_87, context_87) {
    "use strict";
    var cryptex_1, CryptexCryptoSecureStorageProvider;
    var __moduleName = context_87 && context_87.id;
    return {
        setters: [
            function (cryptex_1_1) {
                cryptex_1 = cryptex_1_1;
            }
        ],
        execute: function () {
            /**
             * A storage provider for secure information relating to crypto, stored using Cryptex.
             * Requires `cryptex` package to be installed.
             *
             * The pickle key is stored as the "pickle_key" secret.
             * @category Storage providers
             * @see https://github.com/TomFrost/Cryptex
             */
            CryptexCryptoSecureStorageProvider = class CryptexCryptoSecureStorageProvider {
                constructor(opts) {
                    this.cryptex = new cryptex_1.Cryptex(opts);
                }
                getPickleKey() {
                    return __awaiter(this, void 0, void 0, function* () {
                        return this.cryptex.getSecret("pickle_key");
                    });
                }
                setPickleKey(pickleKey) {
                    return __awaiter(this, void 0, void 0, function* () {
                        throw new Error("Cannot set keys with Cryptex - ensure that the secret is set up prior to running");
                    });
                }
            };
            exports_87("CryptexCryptoSecureStorageProvider", CryptexCryptoSecureStorageProvider);
        }
    };
});
System.register("storage/NamespacingPostgresCryptoStorageProvider", ["pg-promise"], function (exports_88, context_88) {
    "use strict";
    var pgPromise, DEFAULT_NAMESPACE, psql, NamespacingPostgresCryptoStorageProvider;
    var __moduleName = context_88 && context_88.id;
    return {
        setters: [
            function (pgPromise_1) {
                pgPromise = pgPromise_1;
            }
        ],
        execute: function () {
            DEFAULT_NAMESPACE = "default";
            // Init library
            psql = pgPromise();
            /**
             * PostgreSQL crypto storage provider for appservices and clients. Requires `pg-promise` package to be installed.
             * @category Storage providers
             */
            NamespacingPostgresCryptoStorageProvider = class NamespacingPostgresCryptoStorageProvider {
                /**
                 * Combined constructor implementation.
                 */
                constructor(cnOrNamespace, parentOrSecureStorage) {
                    this.namespace = DEFAULT_NAMESPACE;
                    this.kvUpsert = "INSERT INTO kv (ns, name, value) VALUES ($[ns], $[name], $[value]) ON CONFLICT (ns, name) DO UPDATE SET value = $[value]";
                    this.kvSelect = "SELECT ns, name, value FROM kv WHERE name = $[name] AND ns = $[ns]";
                    this.roomUpsert = "INSERT INTO rooms (room_id, config) VALUES ($[roomId], $[config]) ON CONFLICT (room_id) DO UPDATE SET config = $[config]";
                    this.roomSelect = "SELECT room_id, config FROM rooms WHERE room_id = $[roomId]";
                    this.userUpsert = "INSERT INTO users (user_id, outdated) VALUES ($[userId], $[outdated]) ON CONFLICT (user_id) DO UPDATE SET outdated = $[outdated]";
                    this.userSelect = "SELECT user_id, outdated FROM users WHERE user_id = $[userId]";
                    this.userDeviceUpsert = "INSERT INTO user_devices (user_id, device_id, device, active) VALUES ($[userId], $[deviceId], $[device], $[active]) ON CONFLICT (user_id, device_id) DO UPDATE SET device = $[device], active = $[active]";
                    this.userDevicesDelete = "UPDATE user_devices SET active = false WHERE user_id = $[userId]";
                    this.userDevicesSelect = "SELECT user_id, device_id, device, active FROM user_devices WHERE user_id = $[userId]";
                    this.userActiveDevicesSelect = "SELECT user_id, device_id, device, active FROM user_devices WHERE user_id = $[userId] AND active = true";
                    this.userActiveDeviceSelect = "SELECT user_id, device_id, device, active FROM user_devices WHERE user_id = $[userId] AND device_id = $[deviceId] AND active = true";
                    this.obGroupSessionUpsert = "INSERT INTO outbound_group_sessions (ns, session_id, room_id, current, pickled, uses_left, expires_ts) VALUES ($[ns], $[sessionId], $[roomId], $[current], $[pickled], $[usesLeft], $[expiresTs]) ON CONFLICT (ns, session_id, room_id) DO UPDATE SET pickled = $[pickled], current = $[current], uses_left = $[usesLeft], expires_ts = $[expiresTs]";
                    this.obGroupSessionSelect = "SELECT ns, session_id, room_id, current, pickled, uses_left, expires_ts FROM outbound_group_sessions WHERE session_id = $[sessionId] AND room_id = $[roomId] AND ns = $[ns]";
                    this.obGroupCurrentSessionSelect = "SELECT ns, session_id, room_id, current, pickled, uses_left, expires_ts FROM outbound_group_sessions WHERE room_id = $[roomId] AND current = true AND ns = $[ns]";
                    this.obGroupSessionMarkAllInactive = "UPDATE outbound_group_sessions SET current = false WHERE room_id = $[roomId] AND ns = $[ns]";
                    this.obSentGroupSessionUpsert = "INSERT INTO sent_outbound_group_sessions (ns, session_id, room_id, session_index, user_id, device_id) VALUES ($[ns], $[sessionId], $[roomId], $[sessionIndex], $[userId], $[deviceId]) ON CONFLICT (ns, session_id, room_id, user_id, device_id, session_index) DO NOTHING";
                    this.obSentSelectLastSent = "SELECT ns, session_id, room_id, session_index, user_id, device_id FROM sent_outbound_group_sessions WHERE user_id = $[userId] AND device_id = $[deviceId] AND room_id = $[roomId] AND ns = $[ns]";
                    this.olmSessionUpsert = "INSERT INTO olm_sessions (ns, user_id, device_id, session_id, last_decryption_ts, pickled) VALUES ($[ns], $[userId], $[deviceId], $[sessionId], $[lastDecryptionTs], $[pickled]) ON CONFLICT (ns, user_id, device_id, session_id) DO UPDATE SET last_decryption_ts = $[lastDecryptionTs], pickled = $[pickled]";
                    this.olmSessionCurrentSelect = "SELECT ns, user_id, device_id, session_id, last_decryption_ts, pickled FROM olm_sessions WHERE user_id = $[userId] AND device_id = $[deviceId] AND ns = $[ns] ORDER BY last_decryption_ts DESC LIMIT 1";
                    this.olmSessionSelect = "SELECT ns, user_id, device_id, session_id, last_decryption_ts, pickled FROM olm_sessions WHERE user_id = $[userId] AND device_id = $[deviceId] AND ns = $[ns]";
                    this.ibGroupSessionUpsert = "INSERT INTO inbound_group_sessions (ns, session_id, room_id, user_id, device_id, pickled) VALUES ($[ns], $[sessionId], $[roomId], $[userId], $[deviceId], $[pickled]) ON CONFLICT (ns, session_id, room_id, user_id, device_id) DO UPDATE SET pickled = $[pickled]";
                    this.ibGroupSessionSelect = "SELECT ns, session_id, room_id, user_id, device_id, pickled FROM inbound_group_sessions WHERE session_id = $[sessionId] AND room_id = $[roomId] AND user_id = $[userId] AND device_id = $[deviceId] AND ns = $[ns]";
                    this.deMetadataUpsert = "INSERT INTO decrypted_event_metadata (ns, room_id, event_id, session_id, message_index) VALUES ($[ns], $[roomId], $[eventId], $[sessionId], $[messageIndex]) ON CONFLICT (ns, room_id, event_id) DO UPDATE SET message_index = $[messageIndex], session_id = $[sessionId]";
                    this.deMetadataSelect = "SELECT ns, room_id, event_id, session_id, message_index FROM decrypted_event_metadata WHERE room_id = $[roomId] AND session_id = $[sessionId] AND message_index = $[messageIndex] AND ns = $[ns] LIMIT 1";
                    if (parentOrSecureStorage instanceof NamespacingPostgresCryptoStorageProvider) {
                        this.namespace = cnOrNamespace;
                        this.setup = parentOrSecureStorage.setup;
                        this.db = parentOrSecureStorage.db;
                        this.secureStorage = parentOrSecureStorage.secureStorage;
                        return;
                    }
                    this.secureStorage = parentOrSecureStorage;
                    this.db = psql(cnOrNamespace);
                    this.setup = new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
                        try {
                            yield this.db.none("CREATE TABLE IF NOT EXISTS kv (ns TEXT NOT NULL, name TEXT NOT NULL, value TEXT NOT NULL, PRIMARY KEY (ns, name))");
                            yield this.db.none("CREATE TABLE IF NOT EXISTS rooms (room_id TEXT PRIMARY KEY NOT NULL, config TEXT NOT NULL)");
                            yield this.db.none("CREATE TABLE IF NOT EXISTS users (user_id TEXT PRIMARY KEY NOT NULL, outdated BOOL NOT NULL)");
                            yield this.db.none("CREATE TABLE IF NOT EXISTS user_devices (user_id TEXT NOT NULL, device_id TEXT NOT NULL, device TEXT NOT NULL, active BOOL NOT NULL, PRIMARY KEY (user_id, device_id))");
                            yield this.db.none("CREATE TABLE IF NOT EXISTS outbound_group_sessions (ns TEXT NOT NULL, session_id TEXT NOT NULL, room_id TEXT NOT NULL, current BOOL NOT NULL, pickled TEXT NOT NULL, uses_left INT NOT NULL, expires_ts BIGINT NOT NULL, PRIMARY KEY (ns, session_id, room_id))");
                            yield this.db.none("CREATE TABLE IF NOT EXISTS sent_outbound_group_sessions (ns TEXT NOT NULL, session_id TEXT NOT NULL, room_id TEXT NOT NULL, session_index INT NOT NULL, user_id TEXT NOT NULL, device_id TEXT NOT NULL, PRIMARY KEY (ns, session_id, room_id, user_id, device_id, session_index))");
                            yield this.db.none("CREATE TABLE IF NOT EXISTS olm_sessions (ns TEXT NOT NULL, user_id TEXT NOT NULL, device_id TEXT NOT NULL, session_id TEXT NOT NULL, last_decryption_ts BIGINT NOT NULL, pickled TEXT NOT NULL, PRIMARY KEY (ns, user_id, device_id, session_id))");
                            yield this.db.none("CREATE TABLE IF NOT EXISTS inbound_group_sessions (ns TEXT NOT NULL, session_id TEXT NOT NULL, room_id TEXT NOT NULL, user_id TEXT NOT NULL, device_id TEXT NOT NULL, pickled TEXT NOT NULL, PRIMARY KEY (ns, session_id, room_id, user_id, device_id))");
                            yield this.db.none("CREATE TABLE IF NOT EXISTS decrypted_event_metadata (ns TEXT NOT NULL, room_id TEXT NOT NULL, event_id TEXT NOT NULL, session_id TEXT NOT NULL, message_index INT NOT NULL, PRIMARY KEY (ns, room_id, event_id))");
                            yield this.db.none("CREATE INDEX IF NOT EXISTS idx_decrypted_event_metadata_by_message_index ON decrypted_event_metadata (ns, room_id, session_id, message_index)");
                            resolve();
                        }
                        catch (e) {
                            reject(e);
                        }
                    }));
                }
                setDeviceId(deviceId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        return this.db.none(this.kvUpsert, {
                            ns: this.namespace,
                            name: 'deviceId',
                            value: deviceId,
                        });
                    });
                }
                getDeviceId() {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        const row = yield this.db.oneOrNone(this.kvSelect, {
                            ns: this.namespace,
                            name: 'deviceId',
                        });
                        return row === null || row === void 0 ? void 0 : row.value;
                    });
                }
                setPickleKey(pickleKey) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        return this.secureStorage.setPickleKey(pickleKey);
                    });
                }
                getPickleKey() {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        return this.secureStorage.getPickleKey();
                    });
                }
                setPickledAccount(pickled) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        // TODO: Use secure storage
                        return this.db.none(this.kvUpsert, {
                            ns: this.namespace,
                            name: 'pickled',
                            value: pickled,
                        });
                    });
                }
                getPickledAccount() {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        const row = yield this.db.oneOrNone(this.kvSelect, {
                            ns: this.namespace,
                            name: 'pickled',
                        });
                        return row === null || row === void 0 ? void 0 : row.value;
                    });
                }
                storeRoom(roomId, config) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        return this.db.none(this.roomUpsert, {
                            roomId: roomId,
                            config: JSON.stringify(config),
                        });
                    });
                }
                getRoom(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        const row = yield this.db.oneOrNone(this.roomSelect, {
                            roomId: roomId,
                        });
                        const val = row === null || row === void 0 ? void 0 : row.config;
                        return val ? JSON.parse(val) : null;
                    });
                }
                setActiveUserDevices(userId, devices) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        return this.db.tx((t) => __awaiter(this, void 0, void 0, function* () {
                            yield t.none(this.userUpsert, {
                                userId: userId,
                                outdated: false,
                            });
                            yield t.none(this.userDevicesDelete, {
                                userId: userId,
                            });
                            for (const device of devices) {
                                yield t.none(this.userDeviceUpsert, {
                                    userId: userId,
                                    deviceId: device.device_id,
                                    device: JSON.stringify(device),
                                    active: true,
                                });
                            }
                        }));
                    });
                }
                getActiveUserDevices(userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        const results = yield this.db.manyOrNone(this.userActiveDevicesSelect, {
                            userId: userId,
                        });
                        if (!results)
                            return [];
                        return results.map(d => JSON.parse(d.device));
                    });
                }
                getActiveUserDevice(userId, deviceId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        const result = yield this.db.oneOrNone(this.userActiveDeviceSelect, {
                            userId: userId,
                            deviceId: deviceId,
                        });
                        return result ? JSON.parse(result.device) : null;
                    });
                }
                getAllUserDevices(userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        const results = yield this.db.manyOrNone(this.userDevicesSelect, {
                            userId: userId,
                        });
                        if (!results)
                            return [];
                        return results.map(d => Object.assign({}, JSON.parse(d.device), { unsigned: { bsdkIsActive: d.active } }));
                    });
                }
                flagUsersOutdated(userIds) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        return this.db.tx((t) => __awaiter(this, void 0, void 0, function* () {
                            for (const userId of userIds) {
                                yield t.none(this.userUpsert, {
                                    userId: userId,
                                    outdated: true,
                                });
                            }
                        }));
                    });
                }
                isUserOutdated(userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        const user = yield this.db.oneOrNone(this.userSelect, {
                            userId: userId,
                        });
                        return user ? user.outdated : true;
                    });
                }
                storeOutboundGroupSession(session) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        return this.db.tx((t) => __awaiter(this, void 0, void 0, function* () {
                            if (session.isCurrent) {
                                yield t.none(this.obGroupSessionMarkAllInactive, {
                                    ns: this.namespace,
                                    roomId: session.roomId,
                                });
                            }
                            yield t.none(this.obGroupSessionUpsert, {
                                ns: this.namespace,
                                sessionId: session.sessionId,
                                roomId: session.roomId,
                                pickled: session.pickled,
                                current: session.isCurrent,
                                usesLeft: session.usesLeft,
                                expiresTs: session.expiresTs,
                            });
                        }));
                    });
                }
                getOutboundGroupSession(sessionId, roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        const result = yield this.db.oneOrNone(this.obGroupSessionSelect, {
                            ns: this.namespace,
                            sessionId: sessionId,
                            roomId: roomId,
                        });
                        if (result) {
                            return {
                                sessionId: result.session_id,
                                roomId: result.room_id,
                                pickled: result.pickled,
                                isCurrent: result.current,
                                usesLeft: result.uses_left,
                                expiresTs: result.expires_ts,
                            };
                        }
                        return null;
                    });
                }
                getCurrentOutboundGroupSession(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        const result = yield this.db.oneOrNone(this.obGroupCurrentSessionSelect, {
                            ns: this.namespace,
                            roomId: roomId,
                        });
                        if (result) {
                            return {
                                sessionId: result.session_id,
                                roomId: result.room_id,
                                pickled: result.pickled,
                                isCurrent: result.current,
                                usesLeft: result.uses_left,
                                expiresTs: result.expires_ts,
                            };
                        }
                        return null;
                    });
                }
                storeSentOutboundGroupSession(session, index, device) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        return this.db.none(this.obSentGroupSessionUpsert, {
                            ns: this.namespace,
                            sessionId: session.sessionId,
                            roomId: session.roomId,
                            sessionIndex: index,
                            userId: device.user_id,
                            deviceId: device.device_id,
                        });
                    });
                }
                getLastSentOutboundGroupSession(userId, deviceId, roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        const result = yield this.db.oneOrNone(this.obSentSelectLastSent, {
                            ns: this.namespace,
                            userId: userId,
                            deviceId: deviceId,
                            roomId: roomId,
                        });
                        if (result) {
                            return { sessionId: result.session_id, index: result.session_index };
                        }
                        return null;
                    });
                }
                storeOlmSession(userId, deviceId, session) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        return this.db.none(this.olmSessionUpsert, {
                            ns: this.namespace,
                            userId: userId,
                            deviceId: deviceId,
                            sessionId: session.sessionId,
                            lastDecryptionTs: session.lastDecryptionTs,
                            pickled: session.pickled,
                        });
                    });
                }
                getCurrentOlmSession(userId, deviceId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        const result = yield this.db.oneOrNone(this.olmSessionCurrentSelect, {
                            ns: this.namespace,
                            userId: userId,
                            deviceId: deviceId,
                        });
                        if (!result)
                            return null;
                        return {
                            sessionId: result.session_id,
                            pickled: result.pickled,
                            lastDecryptionTs: result.last_decryption_ts,
                        };
                    });
                }
                getOlmSessions(userId, deviceId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        const result = yield this.db.manyOrNone(this.olmSessionSelect, {
                            ns: this.namespace,
                            userId: userId,
                            deviceId: deviceId,
                        });
                        return (result || []).map(r => ({
                            sessionId: r.session_id,
                            pickled: r.pickled,
                            lastDecryptionTs: r.last_decryption_ts,
                        }));
                    });
                }
                storeInboundGroupSession(session) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        return this.db.none(this.ibGroupSessionUpsert, {
                            ns: this.namespace,
                            sessionId: session.sessionId,
                            roomId: session.roomId,
                            userId: session.senderUserId,
                            deviceId: session.senderDeviceId,
                            pickled: session.pickled,
                        });
                    });
                }
                getInboundGroupSession(senderUserId, senderDeviceId, roomId, sessionId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        const result = yield this.db.oneOrNone(this.ibGroupSessionSelect, {
                            ns: this.namespace,
                            sessionId: sessionId,
                            roomId: roomId,
                            userId: senderUserId,
                            deviceId: senderDeviceId,
                        });
                        if (result) {
                            return {
                                sessionId: result.session_id,
                                roomId: result.room_id,
                                senderUserId: result.user_id,
                                senderDeviceId: result.device_id,
                                pickled: result.pickled,
                            };
                        }
                        return null;
                    });
                }
                setMessageIndexForEvent(roomId, eventId, sessionId, messageIndex) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        return this.db.none(this.deMetadataUpsert, {
                            ns: this.namespace,
                            roomId: roomId,
                            eventId: eventId,
                            sessionId: sessionId,
                            messageIndex: messageIndex,
                        });
                    });
                }
                getEventForMessageIndex(roomId, sessionId, messageIndex) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield this.setup;
                        const result = yield this.db.oneOrNone(this.deMetadataSelect, {
                            ns: this.namespace,
                            roomId: roomId,
                            sessionId: sessionId,
                            messageIndex: messageIndex,
                        });
                        return result === null || result === void 0 ? void 0 : result.event_id;
                    });
                }
                storageForUser(userId) {
                    return new NamespacingPostgresCryptoStorageProvider(userId, this);
                }
            };
            exports_88("NamespacingPostgresCryptoStorageProvider", NamespacingPostgresCryptoStorageProvider);
        }
    };
});
System.register("storage/NamespacingSqliteCryptoStorageProvider", ["better-sqlite3"], function (exports_89, context_89) {
    "use strict";
    var Database, DEFAULT_NAMESPACE, NamespacingSqliteCryptoStorageProvider;
    var __moduleName = context_89 && context_89.id;
    return {
        setters: [
            function (Database_1) {
                Database = Database_1;
            }
        ],
        execute: function () {
            DEFAULT_NAMESPACE = "default";
            // noinspection DuplicatedCode
            /**
             * Sqlite crypto storage provider for appservices and clients. Requires `better-sqlite3` package to be installed.
             * @category Storage providers
             */
            NamespacingSqliteCryptoStorageProvider = class NamespacingSqliteCryptoStorageProvider {
                /**
                 * Combined constructor implementation.
                 */
                constructor(pathOrNamespace, parent) {
                    this.namespace = DEFAULT_NAMESPACE;
                    if (parent) {
                        this.namespace = pathOrNamespace;
                        this.db = parent.db;
                        this.kvUpsert = parent.kvUpsert;
                        this.kvSelect = parent.kvSelect;
                        this.roomUpsert = parent.roomUpsert;
                        this.roomSelect = parent.roomSelect;
                        this.userUpsert = parent.userUpsert;
                        this.userSelect = parent.userSelect;
                        this.userDeviceUpsert = parent.userDeviceUpsert;
                        this.userDevicesDelete = parent.userDevicesDelete;
                        this.userDevicesSelect = parent.userDevicesSelect;
                        this.userActiveDevicesSelect = parent.userActiveDevicesSelect;
                        this.userActiveDeviceSelect = parent.userActiveDeviceSelect;
                        this.obGroupSessionUpsert = parent.obGroupSessionUpsert;
                        this.obGroupSessionSelect = parent.obGroupSessionSelect;
                        this.obGroupCurrentSessionSelect = parent.obGroupCurrentSessionSelect;
                        this.obGroupSessionMarkAllInactive = parent.obGroupSessionMarkAllInactive;
                        this.obSentGroupSessionUpsert = parent.obSentGroupSessionUpsert;
                        this.obSentSelectLastSent = parent.obSentSelectLastSent;
                        this.olmSessionUpsert = parent.olmSessionUpsert;
                        this.olmSessionCurrentSelect = parent.olmSessionCurrentSelect;
                        this.olmSessionSelect = parent.olmSessionSelect;
                        this.ibGroupSessionUpsert = parent.ibGroupSessionUpsert;
                        this.ibGroupSessionSelect = parent.ibGroupSessionSelect;
                        this.deMetadataUpsert = parent.deMetadataUpsert;
                        this.deMetadataSelect = parent.deMetadataSelect;
                        return;
                    }
                    this.db = new Database(pathOrNamespace);
                    this.db.exec("CREATE TABLE IF NOT EXISTS kv (ns TEXT NOT NULL, name TEXT NOT NULL, value TEXT NOT NULL, PRIMARY KEY (ns, name))");
                    this.db.exec("CREATE TABLE IF NOT EXISTS rooms (room_id TEXT PRIMARY KEY NOT NULL, config TEXT NOT NULL)");
                    this.db.exec("CREATE TABLE IF NOT EXISTS users (user_id TEXT PRIMARY KEY NOT NULL, outdated TINYINT NOT NULL)");
                    this.db.exec("CREATE TABLE IF NOT EXISTS user_devices (user_id TEXT NOT NULL, device_id TEXT NOT NULL, device TEXT NOT NULL, active TINYINT NOT NULL, PRIMARY KEY (user_id, device_id))");
                    this.db.exec("CREATE TABLE IF NOT EXISTS outbound_group_sessions (ns TEXT NOT NULL, session_id TEXT NOT NULL, room_id TEXT NOT NULL, current TINYINT NOT NULL, pickled TEXT NOT NULL, uses_left NUMBER NOT NULL, expires_ts NUMBER NOT NULL, PRIMARY KEY (ns, session_id, room_id))");
                    this.db.exec("CREATE TABLE IF NOT EXISTS sent_outbound_group_sessions (ns TEXT NOT NULL, session_id TEXT NOT NULL, room_id TEXT NOT NULL, session_index INT NOT NULL, user_id TEXT NOT NULL, device_id TEXT NOT NULL, PRIMARY KEY (ns, session_id, room_id, user_id, device_id, session_index))");
                    this.db.exec("CREATE TABLE IF NOT EXISTS olm_sessions (ns TEXT NOT NULL, user_id TEXT NOT NULL, device_id TEXT NOT NULL, session_id TEXT NOT NULL, last_decryption_ts NUMBER NOT NULL, pickled TEXT NOT NULL, PRIMARY KEY (ns, user_id, device_id, session_id))");
                    this.db.exec("CREATE TABLE IF NOT EXISTS inbound_group_sessions (ns TEXT NOT NULL, session_id TEXT NOT NULL, room_id TEXT NOT NULL, user_id TEXT NOT NULL, device_id TEXT NOT NULL, pickled TEXT NOT NULL, PRIMARY KEY (ns, session_id, room_id, user_id, device_id))");
                    this.db.exec("CREATE TABLE IF NOT EXISTS decrypted_event_metadata (ns TEXT NOT NULL, room_id TEXT NOT NULL, event_id TEXT NOT NULL, session_id TEXT NOT NULL, message_index INT NOT NULL, PRIMARY KEY (ns, room_id, event_id))");
                    this.db.exec("CREATE INDEX IF NOT EXISTS idx_decrypted_event_metadata_by_message_index ON decrypted_event_metadata (ns, room_id, session_id, message_index)");
                    this.kvUpsert = this.db.prepare("INSERT INTO kv (ns, name, value) VALUES (@ns, @name, @value) ON CONFLICT (ns, name) DO UPDATE SET value = @value");
                    this.kvSelect = this.db.prepare("SELECT ns, name, value FROM kv WHERE name = @name AND ns = @ns");
                    this.roomUpsert = this.db.prepare("INSERT INTO rooms (room_id, config) VALUES (@roomId, @config) ON CONFLICT (room_id) DO UPDATE SET config = @config");
                    this.roomSelect = this.db.prepare("SELECT room_id, config FROM rooms WHERE room_id = @roomId");
                    this.userUpsert = this.db.prepare("INSERT INTO users (user_id, outdated) VALUES (@userId, @outdated) ON CONFLICT (user_id) DO UPDATE SET outdated = @outdated");
                    this.userSelect = this.db.prepare("SELECT user_id, outdated FROM users WHERE user_id = @userId");
                    this.userDeviceUpsert = this.db.prepare("INSERT INTO user_devices (user_id, device_id, device, active) VALUES (@userId, @deviceId, @device, @active) ON CONFLICT (user_id, device_id) DO UPDATE SET device = @device, active = @active");
                    this.userDevicesDelete = this.db.prepare("UPDATE user_devices SET active = 0 WHERE user_id = @userId");
                    this.userDevicesSelect = this.db.prepare("SELECT user_id, device_id, device, active FROM user_devices WHERE user_id = @userId");
                    this.userActiveDevicesSelect = this.db.prepare("SELECT user_id, device_id, device, active FROM user_devices WHERE user_id = @userId AND active = 1");
                    this.userActiveDeviceSelect = this.db.prepare("SELECT user_id, device_id, device, active FROM user_devices WHERE user_id = @userId AND device_id = @deviceId AND active = 1");
                    this.obGroupSessionUpsert = this.db.prepare("INSERT INTO outbound_group_sessions (ns, session_id, room_id, current, pickled, uses_left, expires_ts) VALUES (@ns, @sessionId, @roomId, @current, @pickled, @usesLeft, @expiresTs) ON CONFLICT (ns, session_id, room_id) DO UPDATE SET pickled = @pickled, current = @current, uses_left = @usesLeft, expires_ts = @expiresTs");
                    this.obGroupSessionSelect = this.db.prepare("SELECT ns, session_id, room_id, current, pickled, uses_left, expires_ts FROM outbound_group_sessions WHERE session_id = @sessionId AND room_id = @roomId AND ns = @ns");
                    this.obGroupCurrentSessionSelect = this.db.prepare("SELECT ns, session_id, room_id, current, pickled, uses_left, expires_ts FROM outbound_group_sessions WHERE room_id = @roomId AND current = 1 AND ns = @ns");
                    this.obGroupSessionMarkAllInactive = this.db.prepare("UPDATE outbound_group_sessions SET current = 0 WHERE room_id = @roomId AND ns = @ns");
                    this.obSentGroupSessionUpsert = this.db.prepare("INSERT INTO sent_outbound_group_sessions (ns, session_id, room_id, session_index, user_id, device_id) VALUES (@ns, @sessionId, @roomId, @sessionIndex, @userId, @deviceId) ON CONFLICT (ns, session_id, room_id, user_id, device_id, session_index) DO NOTHING");
                    this.obSentSelectLastSent = this.db.prepare("SELECT ns, session_id, room_id, session_index, user_id, device_id FROM sent_outbound_group_sessions WHERE user_id = @userId AND device_id = @deviceId AND room_id = @roomId AND ns = @ns");
                    this.olmSessionUpsert = this.db.prepare("INSERT INTO olm_sessions (ns, user_id, device_id, session_id, last_decryption_ts, pickled) VALUES (@ns, @userId, @deviceId, @sessionId, @lastDecryptionTs, @pickled) ON CONFLICT (ns, user_id, device_id, session_id) DO UPDATE SET last_decryption_ts = @lastDecryptionTs, pickled = @pickled");
                    this.olmSessionCurrentSelect = this.db.prepare("SELECT ns, user_id, device_id, session_id, last_decryption_ts, pickled FROM olm_sessions WHERE user_id = @userId AND device_id = @deviceId AND ns = @ns ORDER BY last_decryption_ts DESC LIMIT 1");
                    this.olmSessionSelect = this.db.prepare("SELECT ns, user_id, device_id, session_id, last_decryption_ts, pickled FROM olm_sessions WHERE user_id = @userId AND device_id = @deviceId AND ns = @ns");
                    this.ibGroupSessionUpsert = this.db.prepare("INSERT INTO inbound_group_sessions (ns, session_id, room_id, user_id, device_id, pickled) VALUES (@ns, @sessionId, @roomId, @userId, @deviceId, @pickled) ON CONFLICT (ns, session_id, room_id, user_id, device_id) DO UPDATE SET pickled = @pickled");
                    this.ibGroupSessionSelect = this.db.prepare("SELECT ns, session_id, room_id, user_id, device_id, pickled FROM inbound_group_sessions WHERE session_id = @sessionId AND room_id = @roomId AND user_id = @userId AND device_id = @deviceId AND ns = @ns");
                    this.deMetadataUpsert = this.db.prepare("INSERT INTO decrypted_event_metadata (ns, room_id, event_id, session_id, message_index) VALUES (@ns, @roomId, @eventId, @sessionId, @messageIndex) ON CONFLICT (ns, room_id, event_id) DO UPDATE SET message_index = @messageIndex, session_id = @sessionId");
                    this.deMetadataSelect = this.db.prepare("SELECT ns, room_id, event_id, session_id, message_index FROM decrypted_event_metadata WHERE room_id = @roomId AND session_id = @sessionId AND message_index = @messageIndex AND ns = @ns LIMIT 1");
                }
                setDeviceId(deviceId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.kvUpsert.run({
                            ns: this.namespace,
                            name: 'deviceId',
                            value: deviceId,
                        });
                    });
                }
                getDeviceId() {
                    return __awaiter(this, void 0, void 0, function* () {
                        const row = this.kvSelect.get({
                            ns: this.namespace,
                            name: 'deviceId',
                        });
                        return row === null || row === void 0 ? void 0 : row.value;
                    });
                }
                setPickleKey(pickleKey) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.kvUpsert.run({
                            ns: this.namespace,
                            name: 'pickleKey',
                            value: pickleKey,
                        });
                    });
                }
                getPickleKey() {
                    return __awaiter(this, void 0, void 0, function* () {
                        const row = this.kvSelect.get({
                            ns: this.namespace,
                            name: 'pickleKey',
                        });
                        return row === null || row === void 0 ? void 0 : row.value;
                    });
                }
                setPickledAccount(pickled) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.kvUpsert.run({
                            ns: this.namespace,
                            name: 'pickled',
                            value: pickled,
                        });
                    });
                }
                getPickledAccount() {
                    return __awaiter(this, void 0, void 0, function* () {
                        const row = this.kvSelect.get({
                            ns: this.namespace,
                            name: 'pickled',
                        });
                        return row === null || row === void 0 ? void 0 : row.value;
                    });
                }
                storeRoom(roomId, config) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.roomUpsert.run({
                            roomId: roomId,
                            config: JSON.stringify(config),
                        });
                    });
                }
                getRoom(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const row = this.roomSelect.get({
                            roomId: roomId,
                        });
                        const val = row === null || row === void 0 ? void 0 : row.config;
                        return val ? JSON.parse(val) : null;
                    });
                }
                setActiveUserDevices(userId, devices) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.db.transaction(() => {
                            this.userUpsert.run({
                                userId: userId,
                                outdated: 0,
                            });
                            this.userDevicesDelete.run({
                                userId: userId,
                            });
                            for (const device of devices) {
                                this.userDeviceUpsert.run({
                                    userId: userId,
                                    deviceId: device.device_id,
                                    device: JSON.stringify(device),
                                    active: 1,
                                });
                            }
                        })();
                    });
                }
                getActiveUserDevices(userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const results = this.userActiveDevicesSelect.all({
                            userId: userId,
                        });
                        if (!results)
                            return [];
                        return results.map(d => JSON.parse(d.device));
                    });
                }
                getActiveUserDevice(userId, deviceId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.userActiveDeviceSelect.get({
                            userId: userId,
                            deviceId: deviceId,
                        });
                        if (!result)
                            return null;
                        return JSON.parse(result.device);
                    });
                }
                getAllUserDevices(userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const results = this.userDevicesSelect.all({
                            userId: userId,
                        });
                        if (!results)
                            return [];
                        return results.map(d => Object.assign({}, JSON.parse(d.device), { unsigned: { bsdkIsActive: d.active === 1 } }));
                    });
                }
                flagUsersOutdated(userIds) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.db.transaction(() => {
                            for (const userId of userIds) {
                                this.userUpsert.run({
                                    userId: userId,
                                    outdated: 1,
                                });
                            }
                        })();
                    });
                }
                isUserOutdated(userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const user = this.userSelect.get({
                            userId: userId,
                        });
                        return user ? Boolean(user.outdated) : true;
                    });
                }
                storeOutboundGroupSession(session) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.db.transaction(() => {
                            if (session.isCurrent) {
                                this.obGroupSessionMarkAllInactive.run({
                                    ns: this.namespace,
                                    roomId: session.roomId,
                                });
                            }
                            this.obGroupSessionUpsert.run({
                                ns: this.namespace,
                                sessionId: session.sessionId,
                                roomId: session.roomId,
                                pickled: session.pickled,
                                current: session.isCurrent ? 1 : 0,
                                usesLeft: session.usesLeft,
                                expiresTs: session.expiresTs,
                            });
                        })();
                    });
                }
                getOutboundGroupSession(sessionId, roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.obGroupSessionSelect.get({
                            ns: this.namespace,
                            sessionId: sessionId,
                            roomId: roomId,
                        });
                        if (result) {
                            return {
                                sessionId: result.session_id,
                                roomId: result.room_id,
                                pickled: result.pickled,
                                isCurrent: result.current === 1,
                                usesLeft: result.uses_left,
                                expiresTs: result.expires_ts,
                            };
                        }
                        return null;
                    });
                }
                getCurrentOutboundGroupSession(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.obGroupCurrentSessionSelect.get({
                            ns: this.namespace,
                            roomId: roomId,
                        });
                        if (result) {
                            return {
                                sessionId: result.session_id,
                                roomId: result.room_id,
                                pickled: result.pickled,
                                isCurrent: result.current === 1,
                                usesLeft: result.uses_left,
                                expiresTs: result.expires_ts,
                            };
                        }
                        return null;
                    });
                }
                storeSentOutboundGroupSession(session, index, device) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.obSentGroupSessionUpsert.run({
                            ns: this.namespace,
                            sessionId: session.sessionId,
                            roomId: session.roomId,
                            sessionIndex: index,
                            userId: device.user_id,
                            deviceId: device.device_id,
                        });
                    });
                }
                getLastSentOutboundGroupSession(userId, deviceId, roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.obSentSelectLastSent.get({
                            ns: this.namespace,
                            userId: userId,
                            deviceId: deviceId,
                            roomId: roomId,
                        });
                        if (result) {
                            return { sessionId: result.session_id, index: result.session_index };
                        }
                        return null;
                    });
                }
                storeOlmSession(userId, deviceId, session) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.olmSessionUpsert.run({
                            ns: this.namespace,
                            userId: userId,
                            deviceId: deviceId,
                            sessionId: session.sessionId,
                            lastDecryptionTs: session.lastDecryptionTs,
                            pickled: session.pickled,
                        });
                    });
                }
                getCurrentOlmSession(userId, deviceId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.olmSessionCurrentSelect.get({
                            ns: this.namespace,
                            userId: userId,
                            deviceId: deviceId,
                        });
                        if (!result)
                            return null;
                        return {
                            sessionId: result.session_id,
                            pickled: result.pickled,
                            lastDecryptionTs: result.last_decryption_ts,
                        };
                    });
                }
                getOlmSessions(userId, deviceId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.olmSessionSelect.all({
                            ns: this.namespace,
                            userId: userId,
                            deviceId: deviceId,
                        });
                        return (result || []).map(r => ({
                            sessionId: r.session_id,
                            pickled: r.pickled,
                            lastDecryptionTs: r.last_decryption_ts,
                        }));
                    });
                }
                storeInboundGroupSession(session) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.ibGroupSessionUpsert.run({
                            ns: this.namespace,
                            sessionId: session.sessionId,
                            roomId: session.roomId,
                            userId: session.senderUserId,
                            deviceId: session.senderDeviceId,
                            pickled: session.pickled,
                        });
                    });
                }
                getInboundGroupSession(senderUserId, senderDeviceId, roomId, sessionId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.ibGroupSessionSelect.get({
                            ns: this.namespace,
                            sessionId: sessionId,
                            roomId: roomId,
                            userId: senderUserId,
                            deviceId: senderDeviceId,
                        });
                        if (result) {
                            return {
                                sessionId: result.session_id,
                                roomId: result.room_id,
                                senderUserId: result.user_id,
                                senderDeviceId: result.device_id,
                                pickled: result.pickled,
                            };
                        }
                        return null;
                    });
                }
                setMessageIndexForEvent(roomId, eventId, sessionId, messageIndex) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.deMetadataUpsert.run({
                            ns: this.namespace,
                            roomId: roomId,
                            eventId: eventId,
                            sessionId: sessionId,
                            messageIndex: messageIndex,
                        });
                    });
                }
                getEventForMessageIndex(roomId, sessionId, messageIndex) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.deMetadataSelect.get({
                            ns: this.namespace,
                            roomId: roomId,
                            sessionId: sessionId,
                            messageIndex: messageIndex,
                        });
                        return result === null || result === void 0 ? void 0 : result.event_id;
                    });
                }
                storageForUser(userId) {
                    return new NamespacingSqliteCryptoStorageProvider(userId, this);
                }
                /**
                 * Closes the crypto store. Primarily for testing purposes.
                 */
                close() {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.db.close();
                    });
                }
            };
            exports_89("NamespacingSqliteCryptoStorageProvider", NamespacingSqliteCryptoStorageProvider);
        }
    };
});
System.register("storage/SqliteCryptoStorageProvider", ["better-sqlite3"], function (exports_90, context_90) {
    "use strict";
    var Database, SqliteCryptoStorageProvider;
    var __moduleName = context_90 && context_90.id;
    return {
        setters: [
            function (Database_2) {
                Database = Database_2;
            }
        ],
        execute: function () {
            /**
             * Sqlite crypto storage provider. Requires `better-sqlite3` package to be installed.
             * @category Storage providers
             * @deprecated Use `NamespacingSqliteCryptoStorageProvider` instead
             */
            SqliteCryptoStorageProvider = class SqliteCryptoStorageProvider {
                /**
                 * Creates a new Sqlite storage provider.
                 * @param {string} path The file path to store the database at. Use ":memory:" to
                 * store the database entirely in memory, or an empty string to do the equivalent
                 * on the disk.
                 */
                constructor(path) {
                    this.db = new Database(path);
                    this.db.exec("CREATE TABLE IF NOT EXISTS kv (name TEXT PRIMARY KEY NOT NULL, value TEXT NOT NULL)");
                    this.db.exec("CREATE TABLE IF NOT EXISTS rooms (room_id TEXT PRIMARY KEY NOT NULL, config TEXT NOT NULL)");
                    this.db.exec("CREATE TABLE IF NOT EXISTS users (user_id TEXT PRIMARY KEY NOT NULL, outdated TINYINT NOT NULL)");
                    this.db.exec("CREATE TABLE IF NOT EXISTS user_devices (user_id TEXT NOT NULL, device_id TEXT NOT NULL, device TEXT NOT NULL, active TINYINT NOT NULL, PRIMARY KEY (user_id, device_id))");
                    this.db.exec("CREATE TABLE IF NOT EXISTS outbound_group_sessions (session_id TEXT NOT NULL, room_id TEXT NOT NULL, current TINYINT NOT NULL, pickled TEXT NOT NULL, uses_left NUMBER NOT NULL, expires_ts NUMBER NOT NULL, PRIMARY KEY (session_id, room_id))");
                    this.db.exec("CREATE TABLE IF NOT EXISTS sent_outbound_group_sessions (session_id TEXT NOT NULL, room_id TEXT NOT NULL, session_index INT NOT NULL, user_id TEXT NOT NULL, device_id TEXT NOT NULL, PRIMARY KEY (session_id, room_id, user_id, device_id, session_index))");
                    this.db.exec("CREATE TABLE IF NOT EXISTS olm_sessions (user_id TEXT NOT NULL, device_id TEXT NOT NULL, session_id TEXT NOT NULL, last_decryption_ts NUMBER NOT NULL, pickled TEXT NOT NULL, PRIMARY KEY (user_id, device_id, session_id))");
                    this.db.exec("CREATE TABLE IF NOT EXISTS inbound_group_sessions (session_id TEXT NOT NULL, room_id TEXT NOT NULL, user_id TEXT NOT NULL, device_id TEXT NOT NULL, pickled TEXT NOT NULL, PRIMARY KEY (session_id, room_id, user_id, device_id))");
                    this.db.exec("CREATE TABLE IF NOT EXISTS decrypted_event_metadata (room_id TEXT NOT NULL, event_id TEXT NOT NULL, session_id TEXT NOT NULL, message_index INT NOT NULL, PRIMARY KEY (room_id, event_id))");
                    this.db.exec("CREATE INDEX IF NOT EXISTS idx_decrypted_event_metadata_by_message_index ON decrypted_event_metadata (room_id, session_id, message_index)");
                    this.kvUpsert = this.db.prepare("INSERT INTO kv (name, value) VALUES (@name, @value) ON CONFLICT (name) DO UPDATE SET value = @value");
                    this.kvSelect = this.db.prepare("SELECT name, value FROM kv WHERE name = @name");
                    this.roomUpsert = this.db.prepare("INSERT INTO rooms (room_id, config) VALUES (@roomId, @config) ON CONFLICT (room_id) DO UPDATE SET config = @config");
                    this.roomSelect = this.db.prepare("SELECT room_id, config FROM rooms WHERE room_id = @roomId");
                    this.userUpsert = this.db.prepare("INSERT INTO users (user_id, outdated) VALUES (@userId, @outdated) ON CONFLICT (user_id) DO UPDATE SET outdated = @outdated");
                    this.userSelect = this.db.prepare("SELECT user_id, outdated FROM users WHERE user_id = @userId");
                    this.userDeviceUpsert = this.db.prepare("INSERT INTO user_devices (user_id, device_id, device, active) VALUES (@userId, @deviceId, @device, @active) ON CONFLICT (user_id, device_id) DO UPDATE SET device = @device, active = @active");
                    this.userDevicesDelete = this.db.prepare("UPDATE user_devices SET active = 0 WHERE user_id = @userId");
                    this.userDevicesSelect = this.db.prepare("SELECT user_id, device_id, device, active FROM user_devices WHERE user_id = @userId");
                    this.userActiveDevicesSelect = this.db.prepare("SELECT user_id, device_id, device, active FROM user_devices WHERE user_id = @userId AND active = 1");
                    this.userActiveDeviceSelect = this.db.prepare("SELECT user_id, device_id, device, active FROM user_devices WHERE user_id = @userId AND device_id = @deviceId AND active = 1");
                    this.obGroupSessionUpsert = this.db.prepare("INSERT INTO outbound_group_sessions (session_id, room_id, current, pickled, uses_left, expires_ts) VALUES (@sessionId, @roomId, @current, @pickled, @usesLeft, @expiresTs) ON CONFLICT (session_id, room_id) DO UPDATE SET pickled = @pickled, current = @current, uses_left = @usesLeft, expires_ts = @expiresTs");
                    this.obGroupSessionSelect = this.db.prepare("SELECT session_id, room_id, current, pickled, uses_left, expires_ts FROM outbound_group_sessions WHERE session_id = @sessionId AND room_id = @roomId");
                    this.obGroupCurrentSessionSelect = this.db.prepare("SELECT session_id, room_id, current, pickled, uses_left, expires_ts FROM outbound_group_sessions WHERE room_id = @roomId AND current = 1");
                    this.obGroupSessionMarkAllInactive = this.db.prepare("UPDATE outbound_group_sessions SET current = 0 WHERE room_id = @roomId");
                    this.obSentGroupSessionUpsert = this.db.prepare("INSERT INTO sent_outbound_group_sessions (session_id, room_id, session_index, user_id, device_id) VALUES (@sessionId, @roomId, @sessionIndex, @userId, @deviceId) ON CONFLICT (session_id, room_id, user_id, device_id, session_index) DO NOTHING");
                    this.obSentSelectLastSent = this.db.prepare("SELECT session_id, room_id, session_index, user_id, device_id FROM sent_outbound_group_sessions WHERE user_id = @userId AND device_id = @deviceId AND room_id = @roomId");
                    this.olmSessionUpsert = this.db.prepare("INSERT INTO olm_sessions (user_id, device_id, session_id, last_decryption_ts, pickled) VALUES (@userId, @deviceId, @sessionId, @lastDecryptionTs, @pickled) ON CONFLICT (user_id, device_id, session_id) DO UPDATE SET last_decryption_ts = @lastDecryptionTs, pickled = @pickled");
                    this.olmSessionCurrentSelect = this.db.prepare("SELECT user_id, device_id, session_id, last_decryption_ts, pickled FROM olm_sessions WHERE user_id = @userId AND device_id = @deviceId ORDER BY last_decryption_ts DESC LIMIT 1");
                    this.olmSessionSelect = this.db.prepare("SELECT user_id, device_id, session_id, last_decryption_ts, pickled FROM olm_sessions WHERE user_id = @userId AND device_id = @deviceId");
                    this.ibGroupSessionUpsert = this.db.prepare("INSERT INTO inbound_group_sessions (session_id, room_id, user_id, device_id, pickled) VALUES (@sessionId, @roomId, @userId, @deviceId, @pickled) ON CONFLICT (session_id, room_id, user_id, device_id) DO UPDATE SET pickled = @pickled");
                    this.ibGroupSessionSelect = this.db.prepare("SELECT session_id, room_id, user_id, device_id, pickled FROM inbound_group_sessions WHERE session_id = @sessionId AND room_id = @roomId AND user_id = @userId AND device_id = @deviceId");
                    this.deMetadataUpsert = this.db.prepare("INSERT INTO decrypted_event_metadata (room_id, event_id, session_id, message_index) VALUES (@roomId, @eventId, @sessionId, @messageIndex) ON CONFLICT (room_id, event_id) DO UPDATE SET message_index = @messageIndex, session_id = @sessionId");
                    this.deMetadataSelect = this.db.prepare("SELECT room_id, event_id, session_id, message_index FROM decrypted_event_metadata WHERE room_id = @roomId AND session_id = @sessionId AND message_index = @messageIndex LIMIT 1");
                }
                setDeviceId(deviceId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.kvUpsert.run({
                            name: 'deviceId',
                            value: deviceId,
                        });
                    });
                }
                getDeviceId() {
                    return __awaiter(this, void 0, void 0, function* () {
                        const row = this.kvSelect.get({ name: 'deviceId' });
                        return row === null || row === void 0 ? void 0 : row.value;
                    });
                }
                setPickleKey(pickleKey) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.kvUpsert.run({
                            name: 'pickleKey',
                            value: pickleKey,
                        });
                    });
                }
                getPickleKey() {
                    return __awaiter(this, void 0, void 0, function* () {
                        const row = this.kvSelect.get({ name: 'pickleKey' });
                        return row === null || row === void 0 ? void 0 : row.value;
                    });
                }
                setPickledAccount(pickled) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.kvUpsert.run({
                            name: 'pickled',
                            value: pickled,
                        });
                    });
                }
                getPickledAccount() {
                    return __awaiter(this, void 0, void 0, function* () {
                        const row = this.kvSelect.get({ name: 'pickled' });
                        return row === null || row === void 0 ? void 0 : row.value;
                    });
                }
                storeRoom(roomId, config) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.roomUpsert.run({
                            roomId: roomId,
                            config: JSON.stringify(config),
                        });
                    });
                }
                getRoom(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const row = this.roomSelect.get({ roomId: roomId });
                        const val = row === null || row === void 0 ? void 0 : row.config;
                        return val ? JSON.parse(val) : null;
                    });
                }
                setActiveUserDevices(userId, devices) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.db.transaction(() => {
                            this.userUpsert.run({ userId: userId, outdated: 0 });
                            this.userDevicesDelete.run({ userId: userId });
                            for (const device of devices) {
                                this.userDeviceUpsert.run({ userId: userId, deviceId: device.device_id, device: JSON.stringify(device), active: 1 });
                            }
                        })();
                    });
                }
                getActiveUserDevices(userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const results = this.userActiveDevicesSelect.all({ userId: userId });
                        if (!results)
                            return [];
                        return results.map(d => JSON.parse(d.device));
                    });
                }
                getActiveUserDevice(userId, deviceId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.userActiveDeviceSelect.get({ userId: userId, deviceId: deviceId });
                        if (!result)
                            return null;
                        return JSON.parse(result.device);
                    });
                }
                getAllUserDevices(userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const results = this.userDevicesSelect.all({ userId: userId });
                        if (!results)
                            return [];
                        return results.map(d => Object.assign({}, JSON.parse(d.device), { unsigned: { bsdkIsActive: d.active === 1 } }));
                    });
                }
                flagUsersOutdated(userIds) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.db.transaction(() => {
                            for (const userId of userIds) {
                                this.userUpsert.run({ userId: userId, outdated: 1 });
                            }
                        })();
                    });
                }
                isUserOutdated(userId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const user = this.userSelect.get({ userId: userId });
                        return user ? Boolean(user.outdated) : true;
                    });
                }
                storeOutboundGroupSession(session) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.db.transaction(() => {
                            if (session.isCurrent) {
                                this.obGroupSessionMarkAllInactive.run({
                                    roomId: session.roomId,
                                });
                            }
                            this.obGroupSessionUpsert.run({
                                sessionId: session.sessionId,
                                roomId: session.roomId,
                                pickled: session.pickled,
                                current: session.isCurrent ? 1 : 0,
                                usesLeft: session.usesLeft,
                                expiresTs: session.expiresTs,
                            });
                        })();
                    });
                }
                getOutboundGroupSession(sessionId, roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.obGroupSessionSelect.get({ sessionId: sessionId, roomId: roomId });
                        if (result) {
                            return {
                                sessionId: result.session_id,
                                roomId: result.room_id,
                                pickled: result.pickled,
                                isCurrent: result.current === 1,
                                usesLeft: result.uses_left,
                                expiresTs: result.expires_ts,
                            };
                        }
                        return null;
                    });
                }
                getCurrentOutboundGroupSession(roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.obGroupCurrentSessionSelect.get({ roomId: roomId });
                        if (result) {
                            return {
                                sessionId: result.session_id,
                                roomId: result.room_id,
                                pickled: result.pickled,
                                isCurrent: result.current === 1,
                                usesLeft: result.uses_left,
                                expiresTs: result.expires_ts,
                            };
                        }
                        return null;
                    });
                }
                storeSentOutboundGroupSession(session, index, device) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.obSentGroupSessionUpsert.run({
                            sessionId: session.sessionId,
                            roomId: session.roomId,
                            sessionIndex: index,
                            userId: device.user_id,
                            deviceId: device.device_id,
                        });
                    });
                }
                getLastSentOutboundGroupSession(userId, deviceId, roomId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.obSentSelectLastSent.get({ userId: userId, deviceId: deviceId, roomId: roomId });
                        if (result) {
                            return { sessionId: result.session_id, index: result.session_index };
                        }
                        return null;
                    });
                }
                storeOlmSession(userId, deviceId, session) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.olmSessionUpsert.run({
                            userId: userId,
                            deviceId: deviceId,
                            sessionId: session.sessionId,
                            lastDecryptionTs: session.lastDecryptionTs,
                            pickled: session.pickled,
                        });
                    });
                }
                getCurrentOlmSession(userId, deviceId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.olmSessionCurrentSelect.get({ userId: userId, deviceId: deviceId });
                        if (!result)
                            return null;
                        return {
                            sessionId: result.session_id,
                            pickled: result.pickled,
                            lastDecryptionTs: result.last_decryption_ts,
                        };
                    });
                }
                getOlmSessions(userId, deviceId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.olmSessionSelect.all({
                            userId: userId,
                            deviceId: deviceId,
                        });
                        return (result || []).map(r => ({
                            sessionId: r.session_id,
                            pickled: r.pickled,
                            lastDecryptionTs: r.last_decryption_ts,
                        }));
                    });
                }
                storeInboundGroupSession(session) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.ibGroupSessionUpsert.run({
                            sessionId: session.sessionId,
                            roomId: session.roomId,
                            userId: session.senderUserId,
                            deviceId: session.senderDeviceId,
                            pickled: session.pickled,
                        });
                    });
                }
                getInboundGroupSession(senderUserId, senderDeviceId, roomId, sessionId) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.ibGroupSessionSelect.get({
                            sessionId: sessionId,
                            roomId: roomId,
                            userId: senderUserId,
                            deviceId: senderDeviceId,
                        });
                        if (result) {
                            return {
                                sessionId: result.session_id,
                                roomId: result.room_id,
                                senderUserId: result.user_id,
                                senderDeviceId: result.device_id,
                                pickled: result.pickled,
                            };
                        }
                        return null;
                    });
                }
                setMessageIndexForEvent(roomId, eventId, sessionId, messageIndex) {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.deMetadataUpsert.run({
                            roomId: roomId,
                            eventId: eventId,
                            sessionId: sessionId,
                            messageIndex: messageIndex,
                        });
                    });
                }
                getEventForMessageIndex(roomId, sessionId, messageIndex) {
                    return __awaiter(this, void 0, void 0, function* () {
                        const result = this.deMetadataSelect.get({ roomId: roomId, sessionId: sessionId, messageIndex: messageIndex });
                        return result === null || result === void 0 ? void 0 : result.event_id;
                    });
                }
                /**
                 * Closes the crypto store. Primarily for testing purposes.
                 */
                close() {
                    return __awaiter(this, void 0, void 0, function* () {
                        this.db.close();
                    });
                }
            };
            exports_90("SqliteCryptoStorageProvider", SqliteCryptoStorageProvider);
        }
    };
});
